#
# Table structure for table 'tx_locator_locations'
#
CREATE TABLE tx_locator_locations (
	uid int(11) NOT NULL auto_increment,
	pid int(11) DEFAULT '0' NOT NULL,
	tstamp int(11) DEFAULT '0' NOT NULL,
	crdate int(11) DEFAULT '0' NOT NULL,
	cruser_id int(11) DEFAULT '0' NOT NULL,
	sorting int(10) DEFAULT '0' NOT NULL,
	deleted tinyint(4) DEFAULT '0' NOT NULL,
	hidden tinyint(4) DEFAULT '0' NOT NULL,
	endtime int(11) DEFAULT '0' NOT NULL,
	fe_group int(11) DEFAULT '0' NOT NULL,
	storename varchar(255) DEFAULT '' NOT NULL,
	storeid varchar(25) DEFAULT '' NOT NULL,
	attributes varchar(255) DEFAULT '' NOT NULL,
	address varchar(255) DEFAULT '' NOT NULL,
	additionaladdress varchar(255) DEFAULT '' NOT NULL,
	city varchar(255) DEFAULT '' NOT NULL,
	contactperson varchar(255) DEFAULT '' NOT NULL,
	state varchar(255) DEFAULT '' NOT NULL,
	zipcode varchar(255) DEFAULT '' NOT NULL,
	country varchar(255) DEFAULT '' NOT NULL,
	products varchar(255) DEFAULT '' NOT NULL,
	email varchar(255) DEFAULT '' NOT NULL,
	phone varchar(255) DEFAULT '' NOT NULL,
	mobile varchar(255) DEFAULT '' NOT NULL,
	fax varchar(255) DEFAULT '' NOT NULL,
	hours tinytext NOT NULL,
	url varchar(255) DEFAULT '' NOT NULL,
	notes text NOT NULL,
	media varchar(255) DEFAULT '' NOT NULL,
	imageurl blob NOT NULL,
	icon varchar(255) DEFAULT '' NOT NULL,
	content text,
	use_coordinate tinyint(3) DEFAULT '0' NOT NULL,
#	categories tinytext NOT NULL,
	categoryuid tinytext NOT NULL,
	lat varchar(255) DEFAULT '' NOT NULL,
	lon varchar(255) DEFAULT '' NOT NULL,
	geocode int(4) DEFAULT '1' NOT NULL,
	relatedto text NOT NULL,

	PRIMARY KEY (uid),
	KEY parent (pid)
);



#
# Table structure for table 'tx_locator_categories'
#
CREATE TABLE tx_locator_categories (
	uid int(11) NOT NULL auto_increment,
	pid int(11) DEFAULT '0' NOT NULL,
	parentuid int(11) DEFAULT '0' NOT NULL,
	tstamp int(11) DEFAULT '0' NOT NULL,
	crdate int(11) DEFAULT '0' NOT NULL,
	cruser_id int(11) DEFAULT '0' NOT NULL,
	sorting int(10) DEFAULT '0' NOT NULL,
	hidden tinyint(4) DEFAULT '0' NOT NULL,
	deleted tinyint(4) DEFAULT '0' NOT NULL,
	sys_language_uid int(11) DEFAULT '0' NOT NULL,
	l10n_parent int(11) DEFAULT '0' NOT NULL,
	l10n_diffsource mediumtext,
	fe_group int(11) DEFAULT '0' NOT NULL,
	name varchar(255) DEFAULT '' NOT NULL,
	description text NOT NULL,
	
	PRIMARY KEY (uid),
	KEY parent (pid)
);

#
# Table structure for table 'tx_locator_attributes'
#
CREATE TABLE tx_locator_attributes (
	uid int(11) NOT NULL auto_increment,
	pid int(11) DEFAULT '0' NOT NULL,
	tstamp int(11) DEFAULT '0' NOT NULL,
	crdate int(11) DEFAULT '0' NOT NULL,
	cruser_id int(11) DEFAULT '0' NOT NULL,
	sorting int(10) DEFAULT '0' NOT NULL,
	hidden tinyint(4) DEFAULT '0' NOT NULL,
	deleted tinyint(4) DEFAULT '0' NOT NULL,
	sys_language_uid int(11) DEFAULT '0' NOT NULL,
	l10n_parent int(11) DEFAULT '0' NOT NULL,
	l10n_diffsource mediumtext,
	icon varchar(255) DEFAULT '' NOT NULL,
	name varchar(255) DEFAULT '' NOT NULL,

	PRIMARY KEY (uid),
	KEY parent (pid)
);

#
# Table structure for table 'tx_locator_zipcodeareas'
#
CREATE TABLE tx_locator_zipcodeareas (
	uid int(11) NOT NULL auto_increment,
	pid int(11) DEFAULT '0' NOT NULL,
	tstamp int(11) DEFAULT '0' NOT NULL,
	crdate int(11) DEFAULT '0' NOT NULL,
	cruser_id int(11) DEFAULT '0' NOT NULL,
	sorting int(10) DEFAULT '0' NOT NULL,
	deleted tinyint(4) DEFAULT '0' NOT NULL,
	hidden tinyint(4) DEFAULT '0' NOT NULL,
	zipcode varchar(255) DEFAULT '' NOT NULL,
	storeuid int(11) DEFAULT '0' NOT NULL,
	area int(11) DEFAULT '0' NOT NULL,
	lat varchar(255) DEFAULT '' NOT NULL,
	lon varchar(255) DEFAULT '' NOT NULL,

	PRIMARY KEY (uid),
	KEY parent (pid)
);



#
# Table structure for table 'fe_users'
#
CREATE TABLE fe_users (
	tx_locator_lat varchar(255) DEFAULT '' NOT NULL,
	tx_locator_lon varchar(255) DEFAULT '' NOT NULL,
	tx_locator_geocode int(4) DEFAULT '1' NOT NULL,
	tx_locator_toplocation int(4) DEFAULT '0' NOT NULL,
);

#
# Table structure for table 'tt_address'
#
CREATE TABLE tt_address (
	tx_locator_lat varchar(255) DEFAULT '' NOT NULL,
	tx_locator_lon varchar(255) DEFAULT '' NOT NULL,
	tx_locator_geocode int(4) DEFAULT '1' NOT NULL,
);

#
# Table structure for table 'tt_address_group'
#
CREATE TABLE tt_address_group (
	tx_locator_icon varchar(255) DEFAULT '' NOT NULL,
);


#
# Table structure for table 'tt_news'
#
CREATE TABLE tt_news (
	tx_locator_lat varchar(255) DEFAULT '' NOT NULL,
	tx_locator_lon varchar(255) DEFAULT '' NOT NULL,
	tx_locator_geocode int(4) DEFAULT '1' NOT NULL,

	tx_locator_storename varchar(255) DEFAULT '' NOT NULL,
	tx_locator_address varchar(255) DEFAULT '' NOT NULL,
	tx_locator_city varchar(255) DEFAULT '' NOT NULL,
	tx_locator_state varchar(255) DEFAULT '' NOT NULL,
	tx_locator_zipcode varchar(255) DEFAULT '' NOT NULL,
	tx_locator_country varchar(255) DEFAULT '' NOT NULL,
	tx_locator_email varchar(255) DEFAULT '' NOT NULL,
	tx_locator_phone varchar(255) DEFAULT '' NOT NULL,
	tx_locator_hours tinytext NOT NULL,
	tx_locator_url varchar(255) DEFAULT '' NOT NULL,
	tx_locator_notes text NOT NULL,
	tx_locator_imageurl blob NOT NULL,
	tx_locator_icon varchar(255) DEFAULT '' NOT NULL,
	tx_locator_use_coordinate tinyint(3) DEFAULT '0' NOT NULL,

);