<?php

/***************************************************************
*  Copyright notice
*
*  (c) 2008-2013 Joachim Ruhs <postmaster@joachim-ruhs.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'Locator' for the 'locator' extension.
 *
 * @author        Joachim Ruhs <postmaster@joachim-ruhs.de>
 */

if (!class_exists('tslib_pibase')) require_once (PATH_tslib . 'class.tslib_pibase.php');
require_once (t3lib_extMgm :: extPath('locator') . "pi1/class.tx_locator_view.php");
require_once (t3lib_extMgm :: extPath('locator') . "pi1/class.tx_locator_model.php");

class tx_locator_controller {

	/* Extension Stuff */
	var $prefixId = 'tx_locator_pi1';
	var $scriptRelPath = 'pi1/class.tx_locator_controller.php';
	var $extKey = 'locator';

	/* Global Configuration */
	var $conf;
	var $_GP;

	/* Set Code */
	function setCode($code) {
		$this->code = $code;
	}

	function setConfiguration($conf) {
		$this->conf = $conf;
	}

	function setGPVars($GP) {
		$this->_GP = $GP;
	}

	function setLocalLang(& $LOCAL_LANG) {
		$this->LOCAL_LANG = $LOCAL_LANG;
	}

	/* Main Function for processing */
	function handle() {


//		debug($this->_GP, 'locator controller');
		//debug($this->conf, 'locator controller');
		$GLOBALS['TYPO3_DB']->debugOutput = 1;

		if ($this->_GP['storeUid'] && $this->conf['displayMode'] != 'routeView' && $this->conf['displayMode'] != 'shopFinder' &&
			$this->conf['displayMode'] != 'searchFormView' && $this->_GP['mode'] != 'showRoute' && $this->conf['displayMode'] != 'simpleView') {
			$this->_GP['mode'] = 'singleView';
			$this->conf['uidOfSingleView'] = $this->_GP['storeUid'];
		}

		// Configure caching
		$this->allowCaching = $this->conf["allowCaching"] ? 1 : 0;
		if (!$this->allowCaching) {
			$GLOBALS["TSFE"]->set_no_cache();
		}

		// mk@plan2.net - make work with XCLASS
		$view = t3lib_div :: makeInstance('tx_locator_view');
		//$view->setGPVars($this->_GP);
		$view->setConfiguration($this->conf);
		$view->cObj = t3lib_div :: makeInstance('tslib_cObj');
		$view->template = $view->cObj->fileResource($this->conf['templateFile']);
		$view->pi_loadLL();
		$view->setLocalLang($this->LOCAL_LANG);

		$this->_GP['lat'] = str_replace(',', '.', $this->_GP['lat']);
		$this->_GP['lon'] = str_replace(',', '.', $this->_GP['lon']);

		if ($this->conf['useFeUserData'] == 1 && !$this->conf['feUserGroup']) {
			$data = array (
				'pleaseSelectFeUserGroup'
			);
			$view->setInput($data);
			$view->setCode('SHOWMESSAGE');
			$view->setInput($data);
			$out = $view->display();
			return $out;
		}
		if ($this->conf['displayMode'] == 'routeView')
			$this->conf['showPoiTable'] = 0;
		if ($this->_GP['errors'] != '')
			$this->_GP['mode'] = '';

//		debug($this->_GP, 'controller');

		if ($this->conf['debug']) {
			    $devLog = array ( '$_GP' => $this->_GP);
				t3lib_div::devLog('handle', 'tx_locator', 3, $devLog);
		}



		switch ($this->_GP['mode']) {
			case 'search' :
				$model = new tx_locator_model();
				$model->setConfiguration($this->conf);
				$model->setLocalLang($this->LOCAL_LANG);
				$model->setGPvars($this->_GP);
				$model->update_lat_lon();
				$this->_GP['numberOfStores'] = $model->getNumberOfStores();

				// searchByName
				if ($this->conf['searchByName']) {
					$center = $model->getCenterOfAllStores();
					$this->_GP['lat'] = $center->lat;
					$this->_GP['lon'] = $center->lon;
					$this->_GP['radius'] = $center->radius;
					if ($this->_GP['radius'] == '0.00')
						$this->_GP['radius'] = 1000;
					$this->_GP['start']['lat'] = $center->lat;
					$this->_GP['start']['lon'] = $center->lon;
					$model->setGPvars($this->_GP);

				}
				$data = $model->searchStore();

				if (is_string($data))
					return $data; // multi starting points
//print_r( $data);

				if (!$GLOBALS['TYPO3_DB']->sql_num_rows($data['mysql'])) {
					$data = 'noStoresFound';
					$view->setCode('SHOWMESSAGE');
					$view->setInput($data);
					$out = $view->display();
					return $out;
				}

				if ($this->conf['singleView.']['showRelatedStores'] && mysql_num_rows($data['mysql']) == 1) {
					$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($data['mysql']);
					$this->_GP['uid'] = $row['uid'];
					$model->setGPvars($this->_GP);
					$this->_GP['relatedTo'] = $model->getRelatedStores();
					$data['relatedTo'] = $this->_GP['relatedTo'];
					$model->setGPvars($this->_GP);
					if (count($data['relatedTo']['uid']) > 0) {
						$data['center'] = $model->getCenter();
						$this->_GP['radius'] = $data['center']->radius;
					}
				}


				//$this->_GP = $data;
				$view->setConfiguration($this->conf);
				$view->setGPvars($this->_GP);
				$view->setCode('SHOWSTORES');
				$view->setInput($data);
				$out = $view->display();
				return $errors . $out;
				break;
			case 'showMap' :
				//debug($this->_GP);
				$model = new tx_locator_model();
				$model->setConfiguration($this->conf);
				$model->setGPvars($this->_GP);
				$model->update_lat_lon();
				$this->_GP['numberOfStores'] = $model->getNumberOfStores();

				// for route in listView
				if (($this->_GP['startCity'] || $this->_GP['startZipcode']) && !$this->_GP['startLat']) {
					$address = array (
						'zipcode' => $this->_GP['startZipcode'],
						'city' => $this->_GP['startCity'],
						'country' => 'de',

					);
					$data = $model->geocodeAddress($address);
					$this->_GP['startLat'] = $data->lat;
					$this->_GP['startLon'] = $data->lon;
				}

				if (!$this->_GP['multiRouteAddresses']) {
					$data = $model->getFirstStore(); // get the store with $this->_GP['storeUid'] when set
					// or $this->conf['uidOfSingleView']
					$this->_GP = array_merge($this->_GP, $data);
				}

				$view->setConfiguration($this->conf);
				//$view->setInput($data);
				$view->setGPvars($this->_GP);
				$view->setCode('SHOWMAP');
				$out .= $view->display();
				return $errors . $out;
				break;
			case 'singleView' :
				$model = new tx_locator_model();
				$model->setConfiguration($this->conf);
				$model->update_lat_lon();
				$this->_GP['numberOfStores'] = $model->getNumberOfStores();
				$model->setGPvars($this->_GP);
				$data = $model->getFirstStore();
				$this->_GP = $data;
				if ($this->conf['singleView.']['showRelatedStores']) {
					$this->_GP['relatedTo'] = $model->getRelatedStores();
					$data['relatedTo'] = $this->_GP['relatedTo'];
					$model->setGPvars($this->_GP);
					if (count($data['relatedTo']['uid']) > 0) {
						$data['center'] = $model->getCenter();
						$this->_GP['radius'] = $data['center']->radius;
					}
				}

				$view->setConfiguration($this->conf);
				$view->setGPvars($this->_GP);
				$view->setCode("SHOWSINGLE");
				$view->setInput($data);
				$out = $view->display();
				return $errors . $out;
				break;

			case 'autoMailView' :
				return 'not implemented!';
				//debug($this->_GP);
				break;

			case 'listMailStores' :
				return 'not implemented!';
				//debug($this->_GP);
				break;

			case 'sendMails' :
				return 'not implemented!';
				//debug($this->_GP);
				break;

			case 'mapAllNoFormView' :
				// first get center of all stores
				// and calculate the maxDistance
				$model = new tx_locator_model();
				$model->setConfiguration($this->conf);
				$model->update_lat_lon();
				$model->setGPvars($this->_GP);
				$center = $model->getCenterOfAllStores();
				if (!$this->_GP['radius']) {
					$this->_GP['lat'] = $center->lat;
					$this->_GP['lon'] = $center->lon;
					$this->_GP['radius'] = $center->radius;
					if ($this->_GP['radius'] == '0.00')
						$this->_GP['radius'] = 2;
					$this->_GP['start']['lat'] = $center->lat;
					$this->_GP['start']['lon'] = $center->lon;
				}

				// only for notepadView
				if ($this->conf['enableNotepad']) {
					$complete_address['address'] = $this->_GP['address'];
					$complete_address['city'] = $this->_GP['city'];
					$complete_address['state'] = $this->_GP['state'];
					$complete_address['zipcode'] = $this->_GP['zipcode'];
					$complete_address['country'] = $this->_GP['country'];
	                $latlon = $model->geocodeAddress($complete_address);
					$this->_GP['startLat'] = $latlon->lat;
					$this->_GP['startLon'] = $latlon->lon;
				}

				$this->conf['displayMode'] = 'mapAllView';
				$model->setGPvars($this->_GP);
				$data = $model->searchStore();

				$countOfStores = $GLOBALS['TYPO3_DB']->sql_num_rows($data['mysql']);

				if (!$countOfStores) {
					$data = 'noStoresFound';
					$view->setCode('SHOWMESSAGE');
					$view->setInput($data);
					$out = $view->display();
					return $out;
				}
				$view->setConfiguration($this->conf);
				$view->setGPvars($this->_GP);
				$view->setInput($data);
				$view->setCode('SHOWSTORES');
				$out .= $view->display();
				return $errors . $out;
				break;

			case 'listView' :
				$model = new tx_locator_model();
				$model->setConfiguration($this->conf);
				$model->update_lat_lon();
				$this->conf['displayMode'] = 'listView';
				// get all stores
				$categoryUid = $this->_GP['categoryUid'];
				// origin categoryUid
				$this->_GP['categoryUid'] = $model->getL10nParentCategory($categoryUid);
				$model->setGPvars($this->_GP);

				// first get exact matches
				if ($this->_GP['trademark']) {
					$this->_GP['exactSearch'] = 1;
					$model->setGPvars($this->_GP);
					$data = $model->getAllStores();
					if ($this->_GP['categoryUid']) {
						$data['categoryName'] = $model->getCategory($categoryUid);
					}
					$uidsToHideInOtherMatches = implode(',', $data['uid']);
					$this->_GP['uidsToHideInOtherMatches'] = $uidsToHideInOtherMatches;

					if (count($data['uid']) == 0) {
						$data = 'noExactMatches';
						$view->setCode('SHOWMESSAGE');
						$view->setInput($data);
						$out = $view->display();
						//return $out;
					}
					else {
						$view->setGPvars($this->_GP);
						$view->setInput($data);
						$view->setCode('LISTVIEW');
						$out .= $view->display();
					}
				}
				// now get other matches wichout exact matches
				$this->_GP['exactSearch'] = 0;
				$model->setGPvars($this->_GP);
				$data = $model->getAllStores();
				if ($this->_GP['categoryUid']) {
					$data['categoryName'] = $model->getCategory($categoryUid);
				}
				if (count($data['uid']) == 0) {
					$data = 'noStoresFound';
					if ($this->_GP['trademark'])
						$data = 'noOtherMatches';
					$view->setCode('SHOWMESSAGE');
					$view->setInput($data);
					$out .= $view->display();
					//return $out;
				} else {
					$view->setGPvars($this->_GP);
					$view->setInput($data);

					$view->setCode('LISTVIEW');
					$out .= $view->display();
				}

				return $errors . $out;
				break;

			case 'zipcode' :
				$model = new tx_locator_model();
				$model->setConfiguration($this->conf);
				$model->setLocalLang($this->LOCAL_LANG);
				$model->setGPvars($this->_GP);
				$model->update_lat_lon();
				$view->setConfiguration($this->conf);
				$view->setGPvars($this->_GP);

				$this->_GP['numberOfStores'] = $model->getNumberOfStores();
				//debug($this->_GP, 'controller zipcode');

				if ($this->_GP['zipcode'] == '' && $this->_GP['city'] == '' && $this->conf['displayMode'] != 'zipcodeAreaNoFormView') {
					$view->setConfiguration($this->conf);
					$view->setGPvars($this->_GP);
					$view->model = & $model;
					$view->setCode("SHOWFORM");
					$view->setInput($data);
					$out = $view->display();
					return $errors . $out;
				}

				if ($this->conf['displayMode'] == 'zipcodeAreaNoFormView') {
					// first get center of all stores
					// and calculate the maxDistance
					$model = new tx_locator_model();
					$model->setConfiguration($this->conf);
					//$model->update_lat_lon();
					$center = $model->getCenterOfAllStores();
					$this->_GP['lat'] = $center->lat;
					$this->_GP['lon'] = $center->lon;
					$this->_GP['radius'] = $center->radius;
					$this->_GP['start']['lat'] = $center->lat;
					$this->_GP['start']['lon'] = $center->lon;
					$model->setGPvars($this->_GP);
				}

				// now we have to fetch the coordinates for the areas
				$data = $model->searchZipcodeAreas();
				$center_lat_lon = $model->geocodeAddress($this->_GP);
				if ($this->conf['displayMode'] == 'zipcodeAreaNoFormView') {
					$data['center_lat'] = $center->lat;
					$data['center_lon'] = $center->lon;
					$center_lat_lon->lat = $center->lat;
					$center_lat_lon->lon = $center->lon;
				} else {
					$data['center_lat'] = $center_lat_lon->lat;
					$data['center_lon'] = $center_lat_lon->lon;
				}

				if (count($data['uid']) == 0) {
					$view->setCode('SHOWMESSAGE');
					$message = array (
						'noAreasAvailable'
					);
					$view->setInput($message);
					return $view->display();

				}
				$serviceAvailable = $model->testZipcode((int) $this->_GP['zipcode']);
				// calculate distance
				$pi = M_PI;
				$this->_GP['distance'] = 1000;
				for ($i = 0; $i < count($data['uid']); $i++) {
					$this->_GP['distance'] = min(acos(sin(($center_lat_lon->lat * $pi / 180)) * sin(($data['lat'][$i] * $pi / 180)) + cos(($center_lat_lon->lat * $pi / 180)) * cos(($data['lat'][$i] * $pi / 180)) * cos((($center_lat_lon->lon - $data['lon'][$i]) * $pi / 180))) * 6370, $this->_GP['distance']);
				}
				//debug($this->_GP, 'controller showzip');
				if ($this->conf['displayMode'] != 'zipcodeAreaNoFormView') {

					$this->_GP['radius'] = $this->_GP['distance'];
					if (!$serviceAvailable) {
						$view->setCode('SHOWMESSAGE');
						$message = array (
							'serviceNotAvailable',
							$this->_GP['distance']
						);
						$view->setInput($message);
						$out .= $view->display();
					} else {
						$view->setCode('SHOWMESSAGE');
						$message = array (
							'serviceAvailable'
						);
						$view->setInput($message);
						$out .= $view->display();
					}
				}
				if (is_string($data))
					return $data; // multi starting points
				//$this->_GP = $data;
				$view->setGPvars($this->_GP);
				$view->setCode('SHOWZIPCODEAREAS');
				$view->setInput($data);
				$out .= $view->display();
				return $errors . $out;
				break;

			case 'countryCitySelector' :
				$model = new tx_locator_model();
				$model->setConfiguration($this->conf);
				$model->setLocalLang($this->LOCAL_LANG);
				$model->setGPvars($this->_GP);
				$model->update_lat_lon();
				$data = $model->getCountries();
				if (count($data['country']) == 1) {
					$this->_GP['country'] = $data['country'][0];
					$model->setGPvars($this->_GP);
				}
				if ($this->_GP['country'] == '') {
					$view->setCode('SHOWCOUNTRIES');
					$view->setInput($data);
					$out .= $view->display();
				} else {

					$data = $model->getCities();
					$view->setGPvars($this->_GP);
					$view->setCode('SHOWCITIES');
					$view->setInput($data);
					$out .= $view->display();
				}
				return $errors . $out;
				break;
			case 'shopFinder' :
				$model = new tx_locator_model();
				$model->setConfiguration($this->conf);
				$model->setLocalLang($this->LOCAL_LANG);
				$model->setGPvars($this->_GP);
				$model->update_lat_lon();

				$data['category'] = $model->get_categories();
				//$data['branch'] = $model->getBranches();
				$view->setGPvars($this->_GP);
				$view->setCode('SHOWFINDER');
				$view->setInput($data);
				$out .= $view->display();
				return $errors . $out;
				break;

			case 'simpleSingleView' :
				$model = new tx_locator_model();
				$model->setConfiguration($this->conf);
				$model->setLocalLang($this->LOCAL_LANG);
				$model->setGPvars($this->_GP);
				$data = $model->getFirstStore();
				$this->_GP = $data;
				$view->setGPvars($this->_GP);
				$view->setCode('SIMPLESINGLEVIEW');
				$out .= $view->display();
				return $errors . $out;
				break;
			case 'catMenuView' :
				$model = new tx_locator_model();
				$model->setConfiguration($this->conf);
				$model->setLocalLang($this->LOCAL_LANG);
				//$data = $model->getFirstStore();
				//$this->_GP = $data;


				// only for notepadView
				if ($this->conf['enableNotepad']) {
					$complete_address['address'] = $this->_GP['address'];
					$complete_address['city'] = $this->_GP['city'];
					$complete_address['state'] = $this->_GP['state'];
					$complete_address['zipcode'] = $this->_GP['zipcode'];
					$complete_address['country'] = $this->_GP['country'];

	                $latlon = $model->geocodeAddress($complete_address);
					$this->_GP['startLat'] = $latlon->lat;
					$this->_GP['startLon'] = $latlon->lon;
				}
				$model->setGPvars($this->_GP);
				$out = $data = $model->getCatMenuCategories();

//				$view->setGPvars($this->_GP);
//				$view->setCode('CATMENUVIEW');
//				$out .= $view->display();
				return $errors . $out;
				break;
			case 'ajaxSearchWithMap':
				$model = new tx_locator_model();
				$model->setConfiguration($this->conf);
				$model->setGPvars($this->_GP);
				$model->update_lat_lon();
//				$this->_GP['numberOfStores'] = $model->getNumberOfStores();
//				$view->model = & $model;
				//$categories = $model->get_categories();
				if ($this->conf['useFeUserData'] == 4)
					$data = $model->getTtAdressGroups();
				if ($this->conf['useFeUserData'] == 0)
					$data = $model->getCategories();
				if ($this->conf['useFeUserData'] == 1)
					$data = $model->getFeUserCategories();
				$view->setConfiguration($this->conf);
				$view->setGPvars($this->_GP);
				$view->setCode("AJAXSEARCHWITHMAP");
				$view->setInput($data);
				$out = $view->display();
				return $errors . $out;
			default :
				$model = new tx_locator_model();
				$model->setConfiguration($this->conf);
				$model->setGPvars($this->_GP);
				$model->update_lat_lon();
				$this->_GP['numberOfStores'] = $model->getNumberOfStores();
				$view->model = & $model;
				//$categories = $model->get_categories();
				$view->setConfiguration($this->conf);
				$view->setGPvars($this->_GP);
				$view->setCode("SHOWFORM");
				$view->setInput($data);
				$out = $view->display();
				return $errors . $out;
		}

	}

	/*
	    function createSysFolder($parent, $title) {
	        $time = time();

	        $fields = array();
	        $fields["pid"]         = $parent;
	        $fields["tstamp"]    = $time;
	        $fields["deleted"]    = 0;
	        $fields["doktype"]    = 254;
	        $fields["title"]    = $title;
	        $fields["urltype"]    = 1;
	        $fields["crdate"]    = $time;

	        $result = $GLOBALS['TYPO3_DB']->exec_INSERTquery("pages", $fields);
	        return $GLOBALS['TYPO3_DB']->sql_insert_id();
	    }

	    function checkDirectory($directory) {
	        if ( false === (@opendir($directory)) ) {
	            mkdir( $directory );
	            chmod( $directory, 0777);
	        }
	    }
	*/

	function getStrsBetween($s, $s1, $s2 = false, $offset = 0) {
		/*====================================================================
		Function to scan a string for items encapsulated within a pair of tags

		getStrsBetween(string, tag1, <tag2>, <offset>

		If no second tag is specified, then match between identical tags

		Returns an array indexed with the encapsulated text, which is in turn
		a sub-array, containing the position of each item.

		Notes:
		strpos($needle,$haystack,$offset)
		substr($string,$start,$length)

		====================================================================*/

		if ($s2 === false) {
			$s2 = $s1;
		}
		$result = array ();
		$L1 = strlen($s1);
		$L2 = strlen($s2);

		if ($L1 == 0 || $L2 == 0) {
			return false;
		}

		do {
			$pos1 = strpos($s, $s1, $offset);

			if ($pos1 !== false) {
				$pos1 += $L1;

				$pos2 = strpos($s, $s2, $pos1);

				if ($pos2 !== false) {
					$key_len = $pos2 - $pos1;

					$this_key = substr($s, $pos1, $key_len);

					if (!array_key_exists($this_key, $result)) {
						$result[$this_key] = array ();
					}

					$result[$this_key][] = $pos1;

					$offset = $pos2 + $L2;
				} else {
					$pos1 = false;
				}
			}
		} while ($pos1 !== false);

		return $result;
	}

}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/locator/pi1/class.tx_locator_controller.php']) {
	include_once ($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/locator/pi1/class.tx_locator_controller.php']);
}
?>