<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2012 - 2014 Joachim Ruhs (postmaster@joachim-ruhs.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
* class.tx_locator_eID.php
*
*
* @author Joachim Ruhs <postmaster@joachim-ruhs.de>
*/

if (!class_exists('tslib_pibase')) require_once(PATH_tslib.'class.tslib_pibase.php');


require_once(t3lib_extMgm::extPath('lang', 'lang.php'));
if (is_dir(PATH_site . 't3lib'))  // not TYPO3 6.2
require_once(t3lib_extMgm::extPath('cms', 'tslib/class.tslib_content.php'));
//require_once(PATH_t3lib . 'class.t3lib_page.php');

$_EXTKEY = 'locator';
//require_once(t3lib_extMgm::extPath('booking', 'ext_tables.php'));
unset($_EXTKEY);
//require_once(t3lib_extMgm::extPath('booking', 'tca.php'));

/**
 * locator eID script.
 *
 * @author Joachim Ruhs <postmaster@joachim-ruhs.de>
 * @package TYPO3
 * @subpackage tx_locator
 */
class tx_locator_eID extends tslib_pibase {
	protected $ref;
	protected $pid;
	public $conf;

	public $objectToArrayConf;
	/**
	 * Initializes the class
	 *
	 * @return	void
	 */
	public function __construct() {
		$GLOBALS['LANG'] = t3lib_div::makeInstance('language');
		$GLOBALS['LANG']->init($data['lang'] ? $data['lang'] : 'default');

		tslib_eidtools::connectDB();
	}

	/**
	 * Main processing function of eID script
	 *
	 * @return	void
	 */
	public function main() {
	    // main is called at the end of
		// this script with $SOBE->main();

		// needed for correct encoding...
		header("Content-type:text/html; charset=utf-8");


		// Init language
		if ($GLOBALS['LANG'] instanceof language) {
			$this->language = &$GLOBALS['LANG'];
		}
		else {
			$this->language = t3lib_div::makeInstance('language');
			$this->language->init($GLOBALS['TSFE']->lang);
		}


		// reading data vars for $this->conf
		$arr = t3lib_div::_GP('data');
		$arr = json_decode(urldecode($arr));

//debug($arr, ' array');
//debug(eval("$arr"));

		foreach(get_object_vars($arr) as $key => $value) {
			if (is_string($key) && is_string($value)) {
				//echo $key . '-' . $value;
				$this->conf[$key] = $value;
			}
			// reading data vars for $this->_GP in alternative mode
			// not used yet
			if($key == '_GP' && is_object($value)) {
				foreach(get_object_vars($value) as $key => $value) {
					if (is_string($key) && (is_string($value) || is_int($value) || is_float($value))) {
						//echo $key . '-' . $value;
						$this->conf['_GP'][$key] = $value;
					}
				}
//			echo 'object';
			} else {
			    if (is_object($value)) {
					$this->conf[$key] = $this->objectToArray($value);
				}
			}

			if(is_array($value)) {
				echo 'array';
			}
		}


   		// Get/Post Variables
		$this->_GP = t3lib_div::_GP('tx_locator_pi1');
		// for alternative way
		//$this->_GP = $this->conf['_GP'];


//debug($this->conf);

    	// language
	    $this->lang = $this->conf['lang'];
		if($this->lang == '' || $this->lang == 'en') $this->lang = 'default';

    	// locallang.xml parse
    	$this->LOCAL_LANG = t3lib_div::readLLfile('EXT:locator/pi1/locallang.xml', $this->lang);
		switch ($this->_GP['action']) {
		    case 'getMap':
				$this->getMap();
		    	break;
		    case 'searchAddress':
				$this->getAddress($_GET['term']);
			break;
		    case 'getMapList':
				$this->getMapList();
			break;
		    case 'getStorename':
				$this->getStorename($this->_GP['day']);
			break;
		    case 'getMarkers':
				$this->getMarkers();
			break;
		    case 'getRoute':
				$this->getRoute();
			break;
		    case 'getCategoryFilter':
				$this->getCategoryFilter();
			break;
		    case 'getFilterList':
				$this->getFilterList();
			break;


		    default: echo 'Bad mode!';
		}
	}

	function objectToArray($data)
	{
		if(is_array($data) || is_object($data)) {
			$result = array();
			foreach ($data as $key => $value) {
				$result[$key] = $this->objectToArray($value);
			}
			return $result;
		} else {
			return $data;
		}
	}
/*
	function objectToArray($conf, $key, $value) {
//debug($conf .' - ' . $key2 . ' - ' . $value2);
//		    $conf[$key] = null;
		if (!is_object($value)) {
		    $conf[$key] = $value;
			return;
		}
//debug($conf);
		if (is_object($value)) {
			foreach(get_object_vars($value) as $key2 => $value2) {
//debug($key);
debug($key2, 'key2');
//debug($value2);
			static $keys;
			$keys .= $key2;
//debug($keys, 'keys');
	$a = explode('.', $keys);
//debug($a);
		    $conf[$key] = $key2;
debug($conf);
//debug($conf[$key] .' - ' . $key2 . ' - ' . $value2);
		    $this->objectToArray($conf[$value], $key2, $value2);
			}
		}

	}
*/
	function before($this1, $inthat) {
		return substr($inthat, 0, strpos($inthat, $this1));
	}
	function after($this1, $inthat) {
		if (!is_bool(strpos($inthat, $this1)))
			return substr($inthat, strpos($inthat, $this1) + strlen($this1));
	}

	function getStrsBetween($s, $s1, $s2 = false, $offset = 0) {
		/*====================================================================
		Function to scan a string for items encapsulated within a pair of tags

		getStrsBetween(string, tag1, <tag2>, <offset>

		If no second tag is specified, then match between identical tags

		Returns an array indexed with the encapsulated text, which is in turn
		a sub-array, containing the position of each item.

		Notes:
		strpos($needle,$haystack,$offset)
		substr($string,$start,$length)

		====================================================================*/

		if ($s2 === false) {
			$s2 = $s1;
		}
		$result = array ();
		$L1 = strlen($s1);
		$L2 = strlen($s2);

		if ($L1 == 0 || $L2 == 0) {
			return false;
		}

		do {
			$pos1 = strpos($s, $s1, $offset);

			if ($pos1 !== false) {
				$pos1 += $L1;

				$pos2 = strpos($s, $s2, $pos1);

				if ($pos2 !== false) {
					$key_len = $pos2 - $pos1;

					$this_key = substr($s, $pos1, $key_len);

					if (!array_key_exists($this_key, $result)) {
						$result[$this_key] = array ();
					}

					$result[$this_key][] = $pos1;

					$offset = $pos2 + $L2;
				} else {
					$pos1 = false;
				}
			}
		} while ($pos1 !== false);
		return $result;
	}

	/**
	 * Initializes TSFE. This is necessary to have proper environment for typoLink.
	 *
	 * @return	void
	 */
	protected function createTSFE() {
		if (!is_dir(PATH_site . 't3lib')) {
			// TYPO3 6.2 has no t3lib
			return;
		}

		require_once(PATH_tslib . 'class.tslib_fe.php');
		require_once(PATH_t3lib . 'class.t3lib_page.php');
//		require_once(PATH_tslib . 'class.tslib_content.php');
		require_once(PATH_t3lib . 'class.t3lib_userauth.php' );
		require_once(PATH_tslib . 'class.tslib_feuserauth.php');
		require_once(PATH_t3lib . 'class.t3lib_tstemplate.php');
		require_once(PATH_t3lib . 'class.t3lib_cs.php');

		if (version_compare(TYPO3_version, '4.3', '<')) {
			$tsfeClassName = t3lib_div::makeInstanceClassName('tslib_fe');
			$GLOBALS['TSFE'] = new $tsfeClassName($GLOBALS['TYPO3_CONF_VARS'], $this->conf['pageId'], '');
		}
		else {
			$GLOBALS['TSFE'] = t3lib_div::makeInstance('tslib_fe', $GLOBALS['TYPO3_CONF_VARS'], $this->conf['pageId'], '');
		}

//		$GLOBALS['TSFE']->connectToDB();
		$GLOBALS['TSFE']->initFEuser();
		$GLOBALS['TSFE']->determineId();
		$GLOBALS['TSFE']->getCompressedTCarray();
		$GLOBALS['TSFE']->initTemplate();
		$GLOBALS['TSFE']->getConfigArray();

		// Set linkVars, absRefPrefix, etc
		require_once(PATH_tslib . 'class.tslib_pagegen.php');
		TSpagegen::pagegenInit();
	}

	function between($this1, $that, $inthat) {
		return $this->before($that, $this->after($this1, $inthat));
	}

	function between_last($this1, $that, $inthat) {
		return $this->after_last($this1, $this->before_last($that, $inthat));
	}



	function geocode($search) {
/*
	    if (!$this->googleMapsApiCalls()) {
	        echo 'Limit of Google Api calls reached!';
	        exit;
		}
*/

		if (is_array($search) && $search['results'][0]['geometry']['location']['lat']) {
			$this->lat = floatval($search['results'][0]['geometry']['location']['lat']);
			$this->lon = floatval($search['results'][0]['geometry']['location']['lng']);
		    $this->radius = intval($search['results'][0]['geometry']['location']['radius']);
		    $this->categories = $search['results'][0]['geometry']['location']['categories'];
			return;
		}


	    $data = explode(':', $search);
		$this->city = urlencode($data[0]);
		$this->country = urlencode($data[1]);
	    $this->radius = intval($data[2]);
	    $this->categories = $data[3];
//		$apiURL = "http://maps.google.com/maps/geo?q=$this->city,$this->country&output=xml";

		$apiURL = "http://maps.googleapis.com/maps/api/geocode/json?address=$address,+$this->city,+$this->country&sensor=false";
//		$apiURL = "http://maps.googleapis.com/maps/api/geocode/xml?address=$address,+$this->city,+$this->country&sensor=false";



		$apiURL = utf8_encode($apiURL);
		$addressData = $this->get_webpage($apiURL);
		if (json_decode($addressData)->status != 'OK')
		print_r (json_decode($addressData)->status);
// thats it..............
//print_r(json_decode($addressData)->results[0]->geometry->location->lat)	;

		$this->lat = json_decode($addressData)->results[0]->geometry->location->lat;
		$this->lon = json_decode($addressData)->results[0]->geometry->location->lng;

		return;
	}

	function googleMapsApiCalls() {
		if (!$this->conf['maxGoogleMapsApiCalls'])
		    $this->conf['maxGoogleMapsApiCalls'] = 24000;
		if (!is_file("fileadmin/googleMapsApiCalls.txt")) {
		    $fp = fopen("fileadmin/googleMapsApiCalls.txt", 'a+');
			fclose($fp);
		}

        $usageData = fopen("fileadmin/googleMapsApiCalls.txt","r+");
		$row = fgets($usageData);
		$timestamp = time();
		$date = date("d.m.Y", $timestamp);
		if(substr($row, 0, strpos($row, '#')) == $date){
			//actual date has an entry
			if($this->currentUsage($row) < $this->conf['maxGoogleMapsApiCalls']){
				//max usage not reached
              	$googleMapsApiCallEnabled = true;
			}else{
              	$googleMapsApiCallEnabled = false;
				//no more calls for today
			}
			$newLine = substr($row, strrpos($row, '#')+1)+1;
			$newLine = $date."#".$newLine."\n";
			$this->newEntry($newLine, true);
		}else{
			//actual date has no entry
			$this->newEntry($date."#0\n", false);
			if($this->currentUsage($row) < $this->conf['maxGoogleMapsApiCalls']){
				//max usage not reached
				$googleMapsApiCallEnabled = true;
			}else{
				//no more calls for today
				$googleMapsApiCallEnabled = false;
			}
		}
		//$calls = $this->currentUsage($row) + 1;
		fclose($usageData);

		return $googleMapsApiCallEnabled;
	}
	function currentUsage($rData){
		return trim (substr(strstr($rData, '#'),1));
	}

	function newEntry($entry, $arrShift){
		$arrFile = file("fileadmin/googleMapsApiCalls.txt");
		if($arrShift){
			array_shift($arrFile);
		}
		array_unshift($arrFile, $entry);
		$newData = implode("", $arrFile);
		file_put_contents("fileadmin/googleMapsApiCalls.txt", $newData);
	}


	function getCategoryFilter() {
	    // get the level 0 categories and
	    // put the level 1 categories in these select fields
		$data = $this->getCategoriesOfParent(0);
		
	    for ($i = 0; $i < count($data['name']); $i++) {
	    	$out .= '<select id="catFilter' . $i . '" class="categoryFilter categoryFilter' . $i . '" onchange="getAllMarkers();">';
			$out .= '<option value="0">' . $data['name'][$i] . '</option>';
			$categories = $this->getCategoriesOfParent($data['uid'][$i]);
			for ($j = 0; $j < count($categories['uid']); $j++) {
			$out .= '<option value="' . $categories['uid'][$j] . '">' . $categories['name'][$j] . '</option>';
			}
			$out .= '</select>';

	    }
	    echo $out;
	}

	function getCategoriesOfParent($parentUid = 0) {
		// sanitizing
		if (preg_match('/^[0-9,]*$/', $this->conf['pid_list']) == 1) {
		    // all is ok
		} else $this->conf['pid_list'] = '';


	    $table = 'tx_locator_categories';
	    $fields = '*';
		$where = " pid IN (" . $this->conf['pid_list'] . ") AND deleted='0' AND hidden='0'";
 	    $where .= ' AND parentuid =' . $parentUid;
	    $orderBy ='sorting';
		$result = $GLOBALS['TYPO3_DB']->exec_SELECTquery($fields, $table, $where, '', $orderBy, $limit);

//echo $GLOBALS['TYPO3_DB']->sql_error();
//		$data = array ();
		while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($result)) {
			$data['uid'][] = $row['uid'];
			$data['name'][] = $row['name'];
		}
		return $data;
	
	}
	
	function getFilterList() {
		if ($this->conf['enableTSFEeID'])
			$this->createTSFE(); // needed for typolink, for more speed comment this
		$this->template = file_get_contents(PATH_site . $this->getRelativeFileName($this->conf['templateFile']));
		$this->cObj = t3lib_div::makeInstance('tslib_cObj');
		$subpart = $this->cObj->getSubpart($this->template, "###FILTERLISTHEADER###");
		$marks = array();
		$out .= $this->cObj->substituteMarkerArray($subpart, $marks);

		$subpart = $this->cObj->getSubpart($this->template, "###FILTERLISTDATA###");
		$marks = array();

		$this->geocode($this->_GP['search']);
		$data = $this->getPoiData($this->_GP['search']);

		for ($i = 0; $i < count($data['storename']); $i++) {

			($i % 2 == 0)? $marks['###ODD###'] = 'even' : $marks['###ODD###'] = 'odd';
			if ($data['url'][$i] && $this->conf['enableTSFEeID']) {
				$link = $this->cObj->getTypoLink($data['storename'][$i], $data['url'][$i]);
				$marks['###STORENAMEV###'] = $link;
//				$marks['###STORENAMEV###'] = '<a href="' . $link . '" target="_top">' . $data['storename'][$i] . '</a>';
			}
			if ($data['url'][$i] && !$this->conf['enableTSFEeID']) {
				$marks['###STORENAMEV###'] = '<a href="' . $data['url'][$i] . '" target="_top">' . $data['storename'][$i] . '</a>';
			}
			if (!$data['url'][$i]) {
				$marks['###STORENAMEV###'] = $data['storename'][$i];
			}
            $marks['###CAT1V###'] = '';
            $marks['###CAT2V###'] = '';
            $marks['###CAT3V###'] = '';


			$cat = $this->getCategoriesOfParent(0);

//print_r($cat);
			// the top level categories
			// now compare with the subcategory
			for ($j = 0; $j < count($cat['uid']); $j++) {
			// get the subcategories
				$subCat = $this->getCategoriesOfParent(intval($cat['uid'][$j]));

				for ($k = 0; $k < count($subCat['uid']); $k++) {
				    // if 2 storage folders are used hide the categoryFilter
				    // the modulo funcion is needed!

				    if (t3lib_div::inList($data['categoryuid'][$i], $subCat['uid'][$k])) {
				    if ($marks['###CAT' . (($j % 3) + 1) . 'V###'])
						$marks['###CAT' . (($j % 3) + 1) . 'V###'] .= ', ' . $subCat['name'][$k];
					else $marks['###CAT' . (($j % 3) + 1) . 'V###'] = $subCat['name'][$k];
				    //break;
				    }

				}

			}


			$out .= $this->cObj->substituteMarkerArray($subpart, $marks);
		}

		$subpart = $this->cObj->getSubpart($this->template, "###FILTERLISTFOOTER###");
		$marks = array();
		$out .= $this->cObj->substituteMarkerArray($subpart, $marks);
		echo $out;
	}
	
	function getFilterListData() {
		// sanitizing
		if (preg_match('/^[0-9,]*$/', $this->conf['pid_list']) == 1) {
		    // all is ok
		} else $this->conf['pid_list'] = '';

	    $table = 'tx_locator_locations';
	    $fields = '*';
		$where = " pid IN (" . $this->conf['pid_list'] . ") AND deleted='0' AND hidden='0'";
// 	    $where .= ' AND parentuid =' . $parentUid;
	    $orderBy ='sorting';
		$result = $GLOBALS['TYPO3_DB']->exec_SELECTquery($fields, $table, $where, '', $orderBy, $limit);
echo $GLOBALS['TYPO3_DB']->sql_error();
		while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($result)) {
			$data['storename'][] = $row['storename'];
		}
		return $data;
	}



	function getMarkers() {
		if ($this->conf['enableTSFEeID'])
			$this->createTSFE(); // needed for typolink, for more speed comment this
//$t = microtime(1);
		$this->geocode($this->_GP['search']);
//echo microtime(1) - $t;
		$data = $this->getPoiData($this->_GP['search']);
		$this->template = file_get_contents(PATH_site . $this->getRelativeFileName($this->conf['templateFile']));
		$this->cObj = t3lib_div::makeInstance('tslib_cObj');
//		$this->cObj->start(array());
		if ($this->conf['enableStartpointMarker']) {
				$out .= '
					var myLatLng = new google.maps.LatLng(' . $this->lat . ',' . $this->lon . ');
					var shadow = new google.maps.MarkerImage("typo3conf/ext/locator/pi1/res/shadow.png",
					new google.maps.Size(37, 37),
					new google.maps.Point(0,0),
					new google.maps.Point(10, 37));

					startpointMarker = new google.maps.Marker({
					position: myLatLng,
					title: "' . $this->getLL('startingPoint') . '",
					map: map,';
				$out .= 'icon: "typo3conf/ext/locator/pi1/icons/pointerYellow.gif",';
				$out .= '
					shadow: shadow
					});
					//markersArray.push(marker[' . $i . ']);
					mapBounds.extend(myLatLng);
		        ';
		}

		for ($i = 0; $i < count($data['lat']); $i++) {
 			if ($data['lat'][$i] != "" && $data['lon'][$i] != "") {

				$data['storename'][$i] = preg_replace('~[\r\n]+~', '',  $data['storename'][$i]); // no new lines in javascript (title)

				$out .= '
					var myLatLng = new google.maps.LatLng(' . $data['lat'][$i] . ',' . $data['lon'][$i] . ');
					var shadow = new google.maps.MarkerImage("typo3conf/ext/locator/pi1/res/shadow.png",
					// The shadow image is larger in the horizontal dimension
					// while the position and offset are the same as for the main image.
					new google.maps.Size(37, 37),
					new google.maps.Point(0,0),
					new google.maps.Point(10, 37));

					marker[' . $i . '] = new google.maps.Marker({
					position: myLatLng,
//					title: "' .  addslashes($data['storename'][$i]) . '",
					title: "' .  addslashes($data['rawStorename'][$i]) . '",
					map: map,';



				if ($this->conf['useFeUserData'] == 0) {
				    $out .= 'icon: "' . 'uploads/tx_locator/' . $data['icon'][$i] .'",';
				} else {
					if ($data['icon'][$i])
					    $out .= 'icon: "' . 'uploads/tx_locator/' . $data['icon'][$i] .'",';
					else $out .= 'icon: "typo3conf/ext/locator/pi1/icons/pointerRed.png",';
				}
				$out .= '
					shadow: shadow
					});
					markersArray.push(marker[' . $i . ']);
					mapBounds.extend(myLatLng);
		        ';
				// now the template for the google infoWindow
				$subpart = $this->cObj->getSubpart($this->template, "###AJAXSEARCHINFOWINDOW###");
				$subpartList = $this->cObj->getSubpart($this->template, "###AJAXSEARCHWITHMAPLIST###");
				$marks = array ();
				$marks['###ROUTEV###'] = $this->getLL('route');

				if ($data['url'][$i]> '' && $this->conf['enableTSFEeID']) {
//					$link = $this->cObj->getTypoLink(htmlspecialchars($data['storename'][$i], ENT_QUOTES), $data['url'][$i]);
					$link = $this->cObj->getTypoLink($data['storename'][$i], $data['url'][$i]);
					$marks['###STORENAMEV###'] = $link;
				}

				if ($data['url'][$i]> '' && !$this->conf['enableTSFEeID']) {
					$marks['###STORENAMEV###'] = '<a href="' . $data['url'][$i] . '" target="_blank">' . $data['storename'][$i] . '</a>';
				}

				if (!$data['url'][$i]) {
					$marks['###STORENAMEV###'] = $data['storename'][$i];
				}

	            $marks['###STOREUIDV###'] = $data['uid'][$i];

				$marks['###STORENAMELISTV###'] = $data['storename'][$i];
				$marks['###TITLEV###'] = $data['title'][$i];
				$marks['###FIRSTNAMEV###'] = $data['first_name'][$i];
				$marks['###LASTNAMEV###'] = $data['last_name'][$i];
				$marks['###CATEGORYV###'] = $data['category'][$i];

				$marks['###CATEGORYUIDV###'] = $data['categoryuid'][$i];

				if ($this->conf['useFeUserData'] == 0) {
					$categories = explode(',', $data['categoryuid'][$i]);
					for ($j = 0; $j < count($categories); $j++)
	                $marks['###CATEGORYIMAGESV###'] .=  '<img src="' . $this->conf['categoryImagePath'] . str_replace(' ', '', $categories[$j]) . '.gif"
						title="' . $categories[$j] . '" alt="' . $categories[$j] . '" />';
				} else {
					$categories = explode(',', $data['category'][$i]);
					for ($j = 0; $j < count($categories); $j++)
	                $marks['###CATEGORYIMAGESV###'] .=  '<img src="' . $this->conf['categoryImagePath'] . str_replace(' ', '', $categories[$j]) . '.gif"
						title="' . $categories[$j] . '" alt="' . $categories[$j] . '" />';
				}



				$marks['###ADDRESSV###'] = $data['address'][$i];

				$marks['###ZIPCODEV###'] = $data['zipcode'][$i];
				$marks['###CITYV###'] = $data['city'][$i];
				$marks['###COUNTRYV###'] = $data['country'][$i];

				$marks['###NOTESV###'] =  $this->pi_RTEcssText($data['notes'][$i]);

				$marks['###EMAILV###'] = ($this->cObj->getTypoLink($data['email'][$i], $data['email'][$i]));

				$marks['###PHONEV###'] = $data['phone'][$i];
				$marks['###FAXV###'] = $data['fax'][$i];
				$marks['###MOBILEV###'] = $data['mobile'][$i];
				$marks['###PRODUCTSV###'] = $data['products'][$i];
				$marks['###URLV###'] = $data['url'][$i];
				if ($this->conf['distanceUnit'] == 'miles')
					$marks['###DISTANCEV###'] = number_format($data['distance'][$i] / 1.6, 2, ',', '') . ' ' .$this->getLL('miles');
				else
					$marks['###DISTANCEV###'] = number_format($data['distance'][$i], 2, ',', '') . ' km';
				$marks['###STARTLATV###'] = $this->lat;
				$marks['###STARTLONV###'] = $this->lon;
				$marks['###LATV###'] = $data['lat'][$i];
				$marks['###LONV###'] = $data['lon'][$i];

				if ($this->conf['singleViewPid'] && $this->conf['enableTSFEeID']) {
					$params = array (
						'tx_locator_pi1[storeUid]' => $data['uid'][$i],
					);
					$marks['###SINGLEVIEWLINKV###'] = $this->pi_linkToPage($this->pi_getLL('singleViewLink'), $this->conf['singleViewPid'], '_top', $params);
				}
				else $marks['###SINGLEVIEWLINKV###'] = '';



				$marks['###I###'] = $i;


				if ($this->conf['useFeUserData'] == 0) {
					if ($data['image'][$i]) {
						$marks['###IMAGEV###'] = 'uploads/tx_locator/' . $data['image'][$i];
						$marks['###IMAGEDISPLAYV###'] = 'block';
					} else {
						$marks['###IMAGEV###'] = '';
						$marks['###IMAGEDISPLAYV###'] = 'none';
					}
				}
				if ($this->conf['useFeUserData'] == 1) {
					if ($data['image'][$i]) {
						if (t3lib_extMgm :: isLoaded('sr_feuser_register')) {
							$marks['###IMAGEV###'] = "uploads/tx_srfeuserregister/" . $data['image'][$i];
						} else {
							$marks['###IMAGEV###'] = "uploads/pics/" . $data['image'][$i];
						}
						$marks['###IMAGEDISPLAYV###'] = 'block';
					} else {
						$marks['###IMAGEV###'] = '';
						$marks['###IMAGEDISPLAYV###'] = 'none';
					}
				}
				if ($this->conf['useFeUserData'] == 4) {
					if ($data['image'][$i]) {
						$marks['###IMAGEV###'] = 'uploads/pics/' . $data['image'][$i];
						$marks['###IMAGEDISPLAYV###'] = 'block';
					} else {
						$marks['###IMAGEV###'] = '';
						$marks['###IMAGEDISPLAYV###'] = 'none';
					}
				}


				if ($data['media'][$i] > '' && $this->conf['showVideoPlayer']) {
					$marks['###MEDIADISPLAYV###'] = 'block';
					$marks['###IMAGEDISPLAYV###'] = 'none';
					$marks['###MEDIAV###'] = '/uploads/tx_locator/media/' . $data['media'][$i];
				} else {
					$marks['###MEDIADISPLAYV###'] = 'none';
				}

				$marks['###MARKERID###'] = $i;
				$marks['###FINISHADDRESSV###'] = (htmlspecialchars($data['address'][$i], ENT_QUOTES) . ',' . $data['zipcode'][$i] . ' ' . htmlspecialchars($data['city'][$i], ENT_QUOTES) . ',' . $data['country'][$i]);

				$list .= $this->cObj->substituteMarkerArray($subpartList, $marks);

				$marks['###EMAILV###'] = addslashes($this->cObj->getTypoLink($data['email'][$i], $data['email'][$i]));
				$infoWindow[$i] = $this->cObj->substituteMarkerArray($subpart, $marks);


	         	$out .= "infoBubble[$i] = new InfoBubble({
	            content: '<div>" . str_replace(array("\n", "\r"), '', $infoWindow[$i]) . "</div>',
				minWidth: 50,
				maxWidth: 300,
				shadowStyle: 1,
				padding: 0,
			//	backgroundColor: 'rgb(57,57,57)',
				borderRadius: 6,
				arrowSize: 10,
				borderWidth: 1,
				borderColor: '#2c2c2c',
				disableAutoPan: false,
				//hideCloseButton: true,
				arrowPosition: 10,
				backgroundClassName: 'phoney',
				arrowStyle: 2

	        });
			";


/*
$out .= "
infoBubble[$i] = new google.maps.InfoWindow({
                   content: '" . str_replace(array("\n", "\r"), '', $infoWindow[$i])."'
               });";
*/

			$out .= "google.maps.event.addListener(marker[$i], 'click', function() {";
//			$out .= '$j("video").each(function () { this.pause() });';
			if (!$this->conf['enableMultipleInfoWindows'])
				$out .= "for (var w = 0; w < infoBubble.length; w++) {infoBubble[w].close();};";

			$out .= "infoBubble[$i].open(map, marker[$i]);";

			if ($this->conf['showVideoPlayer'] && $data['media'][$i]) {
			    $out .= "
				google.maps.event.addListener(infoBubble[$i], 'domready', function() {
				//console.log('dom ready');
				player($i);
				});";
			}

			$out .= "})";
//			$out .= "infoBubble[$i].open(map, marker[$i]); player($i);
// 			$out .= "infoWindow[$i].open(map, marker[$i]);


			}
		}
		if ($i) {
			echo '<div class="ajaxSearchWithMapList">' . $list .'</div>';
		}
		else echo '<div class="message" style="width:120px;">' . $this->getLL('noResults') . '</div>';
        echo "<script type='text/javascript'>
        var mapBounds = new google.maps.LatLngBounds();
		var mapCenter = new google.maps.LatLng($this->lat, $this->lon);
		$out;";
		if ($this->conf['enableSearchCircle'])
			echo "drawCircle($this->radius, $this->lat, $this->lon);
			";

		if ($this->conf['enableMarkerClusterer'])
		echo "var markerCluster = new MarkerClusterer(map, marker);";

		echo "
		if (mapBounds!= undefined && $i > 0 && !circle) {
			map.fitBounds(mapBounds);
		}
		if (circle)	map.fitBounds(circle.getBounds());

		if ($i < 1) {
			map.setZoom(16);
			map.setCenter(mapCenter);
		}
		if ($i == 1) {
			map.fitBounds(mapBounds);
			map.setZoom(16);
		}




		</script>";

	}

	function getPoiData($search) {
		// sanitizing
		if (preg_match('/^[0-9,]*$/', $this->conf['pid_list']) == 1) {
		    // all is ok
		} else $this->conf['pid_list'] = '';


		$latmax = $this->lat + $this->radius / 111.3;
		$latmin = $this->lat - $this->radius / 111.3;
		$lonmax = $this->lon + $this->radius / 71.5;
		$lonmin = $this->lon - $this->radius / 71.5;
		$pi = M_PI;
		if ($this->conf['distanceUnit'] == 'miles')
		    $this->radius = $this->radius * 1.6;

		$rand =	rand(0, 1000);
		if ($this->conf['useFeUserData'] == 0) {
			$query = "CREATE TEMPORARY TABLE tx_locationstemp$rand AS (SELECT * from tx_locator_locations where (lat < $latmax and lat > $latmin and
				lon < $lonmax AND lon > $lonmin AND deleted ='0' AND hidden = '0'))";
            $GLOBALS['TYPO3_DB']->admin_query($query);

			$table = "tx_locationstemp$rand a";
			$fields = "*, a.phone,  a.email, a.imageurl as image, (((acos(sin(($this->lat*$pi/180)) * sin((lat*$pi/180)) + cos(($this->lat*$pi/180)) *  cos((lat*$pi/180)) * cos((($this->lon - lon)*$pi/180)))))*6370) as distance";

			// sanitizing
			if (preg_match('/^[0-9,]*$/', $this->categories) == 1) {
			    // all is ok
			} else $this->categories = '';
			

			$cats = explode(',', $this->categories);
			if ($this->categories > "") {
			for ($i = 0; $i < count($cats); $i++) {
				if ($i) {
				    if ($this->conf['enable2LevelCategoryFilter']) {
						// if enable2LevelCategoryFilter is set
						// we have to modify category_search to AND operator
						$category_search .= 'AND FIND_IN_SET('. $cats[$i]. ',a.categoryuid)';
					} else
						$category_search .= 'OR FIND_IN_SET('. $cats[$i]. ',a.categoryuid)';

			    } else
					$category_search .= 'FIND_IN_SET('. $cats[$i]. ',a.categoryuid)';
			}
			$category_search = ' AND ' . $category_search;
			}


			$where = " a.pid IN (" . $this->conf['pid_list'] . ") AND a.deleted='0' AND a.hidden='0' $category_search ";

			// sanitizing
			if (preg_match('/^[A-z]*$/', $this->country) == 1) {
			    // all is ok
			} else $this->country = 'DE';


			if ($this->conf['limitResultsToCountry']) {
				$where .= ' AND a.country = (select cn_short_en from static_countries where cn_iso_2 = "' . strtoupper($this->country) . '")';
			}

			$where .= " HAVING distance <= $this->radius";


		}
		if ($this->conf['useFeUserData'] == 1) {
			$query = "CREATE TEMPORARY TABLE tx_locationstemp$rand AS (SELECT * from fe_users where (tx_locator_lat < $latmax and tx_locator_lat > $latmin and
				tx_locator_lon < $lonmax AND tx_locator_lon > $lonmin))";
            $GLOBALS['TYPO3_DB']->admin_query($query);

			// sanitizing
			if (preg_match('/^[0-9,]*$/', $this->categories) == 1) {
			    // all is ok
			} else $this->categories = '';
			$cats = explode(',', $this->categories);
			if ($this->categories > "") {
			for ($i = 0; $i < count($cats); $i++) {
				if ($i)
					$category_search .= 'OR FIND_IN_SET('. $cats[$i]. ',a.usergroup)';
			    else
					$category_search .= 'FIND_IN_SET('. $cats[$i]. ',a.usergroup)';
			}
			$category_search = ' AND ' . $category_search;
			}

			$table = "tx_locationstemp$rand a";
			$fields = "*, a.company as storename, a.zip as zipcode, a.telephone as phone,  a.email, a.www as url, a.tx_locator_lat as lat, a.tx_locator_lon as lon,(((acos(sin(($this->lat*$pi/180)) * sin((tx_locator_lat*$pi/180)) + cos(($this->lat*$pi/180)) *  cos((tx_locator_lat*$pi/180)) * cos((($this->lon - tx_locator_lon)*$pi/180)))))*6370) as distance";
			$where = " a.pid IN (" . $this->conf['pid_list'] . ") AND a.deleted='0' AND a.disable='0' $category_search HAVING distance <= $this->radius";
		}
		if ($this->conf['useFeUserData'] == 4) {
			$query = "CREATE TEMPORARY TABLE tx_locationstemp$rand AS (SELECT * from tt_address where (tx_locator_lat < $latmax and tx_locator_lat > $latmin and
				tx_locator_lon < $lonmax AND tx_locator_lon > $lonmin))";
            $GLOBALS['TYPO3_DB']->admin_query($query);

			// sanitizing
			if (preg_match('/^[0-9,]*$/', $this->categories) == 1) {
			    // all is ok
			} else $this->categories = '';
			$cats = explode(',', $this->categories);
			if ($this->categories > "") {
			for ($i = 0; $i < count($cats); $i++) {
				if ($i)
					$category_search .= ' OR ' . $cats[$i] . '= c.uid_foreign';
			    else
					$category_search .= $cats[$i] . '= c.uid_foreign';
			}
			$category_search = ' AND (' . $category_search . ')';
			}

			// sanitizing
			if (preg_match('/^[A-z0-9]*$/', $this->conf['tt_addressStorenameField']) == 1) {
			    // all is ok
			} else $this->conf['tt_addressStorenameField'] = '';

			$fields = "distinct GROUP_CONCAT(b.title ORDER BY b.sorting SEPARATOR ', ') as category, a.uid, a.image as image, b.tx_locator_icon as icon, a.first_name as first_name, a.last_name as last_name,  a." . $this->conf['tt_addressStorenameField'] . " as storename, a.address as address, a.zip as zipcode, a.city as city, a.phone,  a.email, a.www as url, a.tx_locator_lat as lat, a.tx_locator_lon as lon,(((acos(sin(($this->lat*$pi/180)) * sin((tx_locator_lat*$pi/180)) + cos(($this->lat*$pi/180)) *  cos((tx_locator_lat*$pi/180)) * cos((($this->lon - tx_locator_lon)*$pi/180)))))*6370) as distance";
			if ($this->conf['useApproximation'])
				$fields = "distinct GROUP_CONCAT(b.title ORDER BY b.sorting SEPARATOR ', ') as category, a.image as image, b.tx_locator_icon as icon, a.first_name as first_name, a.last_name as last_name, a." . $this->conf['tt_addressStorenameField'] . " as storename, a.address as address, a.zip as zipcode, a.city as city, a.phone,  a.email, a.www as url, a.tx_locator_lat as lat, a.tx_locator_lon as lon, (SQRT(POW($this->lat-tx_locator_lat, 2)* 12387 + POW($this->lon-tx_locator_lon,2)*5112)) as distance";

			$table = 'tx_locationstemp' . $rand . ' a
				left outer join(tt_address_group_mm c, tt_address_group b) on (a.uid=c.uid_local AND c.uid_foreign= b.uid)';
			$where = " a.pid IN (" . $this->conf['pid_list'] . ") AND a.deleted='0' AND a.hidden='0' $category_search GROUP BY a." . $this->conf['tt_addressStorenameField'] ." HAVING distance <= $this->radius";


		}

		$orderBy = 'distance asc';
		$limit = '0,'. intval($this->conf['resultLimit']);
		$result = $GLOBALS['TYPO3_DB']->exec_SELECTquery($fields, $table, $where, '', $orderBy, $limit);
//echo $GLOBALS['TYPO3_DB']->sql_error();
		$out = array ();
		while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($result)) {
			$data['uid'][] .= $row['uid'];
			$data['lat'][] .= floatval($row['lat']);
		    $data['lon'][] .= floatval($row['lon']);
		    $data['title'][] .= htmlspecialchars($row['title'], ENT_QUOTES);
		    $data['first_name'][] .= htmlspecialchars($row['first_name'], ENT_QUOTES);
		    $data['last_name'][] .= htmlspecialchars($row['last_name'], ENT_QUOTES);
		    $data['storename'][] .= htmlspecialchars($row['storename'], ENT_QUOTES);
		    $data['rawStorename'][] .= $row['storename'];
		    $data['zipcode'][] .= htmlspecialchars($row['zipcode']);
		    $data['city'][] .= htmlspecialchars($row['city'], ENT_QUOTES);
		    $data['country'][] .= htmlspecialchars($row['country']);
		    $data['address'][] .= htmlspecialchars($row['address'], ENT_QUOTES);
		    $data['notes'][] .= $row['notes'];
		    $data['email'][] .= htmlspecialchars($row['email']);
		    $data['url'][] .= htmlspecialchars($row['url']);
		    $data['phone'][] .= htmlspecialchars($row['phone']);
		    $data['fax'][] .= htmlspecialchars($row['fax']);
		    $data['mobile'][] .= htmlspecialchars($row['mobile']);
		    $data['products'][] .= htmlspecialchars($row['products']);
		    $data['image'][] .= htmlspecialchars($row['image']);
		    $data['media'][] .= htmlspecialchars($row['media']);
		    $data['icon'][] .= htmlspecialchars($row['icon']);
		    $data['distance'][] .= htmlspecialchars($row['distance']);

			if ($this->conf['useFeUserData'] != 0)
			    $data['category'][] .= htmlspecialchars($row['category']);
		    $data['categoryuid'][] .= htmlspecialchars($row['categoryuid']);

			if ($this->conf['useFeUserData'] == 0) {
			    $fields1 = '*';
			    $table1 = 'tx_locator_categories';
				$where1 = 'uid in (' . $row['categoryuid'] . ')';

				$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery($fields1, $table1, $where1);
				$category = '';
				while ($catRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
				    $category[] .= htmlspecialchars($catRow['name']);
				}
		    $data['category'][] .= implode(', ', $category);


echo $GLOBALS['TYPO3_DB']->sql_error();
			}

		}
        $GLOBALS['TYPO3_DB']->admin_query('DROP TABLE IF EXISTS tx_locationstemp' . $rand);
		return $data;
	}


	function getRoute() {
	    // coordinates in $this->_GP['search']
		$coord = explode('|', $this->_GP['search']);
		$startLat = (float) $coord[0];
		$startLon = (float) $coord[1];
		$finishAddress = htmlspecialchars($coord[2]);

        echo "<script type='text/javascript'>
			var directionsService;
			var stepDisplay;
			var myRoute;

		    directionsService = new google.maps.DirectionsService();
	    	var rendererOptions = {
				suppressMarkers: true,
				draggable: true,
				panel: document.getElementById('tx_locator_pi1_route'),
				map: map
		    }
		    directionsDisplay = new google.maps.DirectionsRenderer(rendererOptions)
		    stepDisplay = new google.maps.InfoWindow();
			var orig =  $startLat + ',' + $startLon;
			var dest = \"$finishAddress\";

		    var request = {
		        origin: orig,
		        destination: dest,
		        travelMode: google.maps.DirectionsTravelMode.DRIVING
		    };
		    directionsService.route(request, function(response, status) {
		      if (status == google.maps.DirectionsStatus.OK) {
		        directionsDisplay.setDirections(response);
		      }
		    });

        </script>";

	}


	function getMapList() {
		// sanitizing
		if (preg_match('/^[0-9,]*$/', $this->conf['pid_list']) == 1) {
		    // all is ok
		} else $this->conf['pid_list'] = '';

		$this->createTSFE(); // needed for typolink

		$this->cObj = t3lib_div::makeInstance('tslib_cObj');
//		$this->cObj->start('', '');
		$this->cObj->start(array());
		// the template file
		$this->template = file_get_contents(PATH_site . $this->getRelativeFileName($this->conf['templateFile']));

//debug($this->_GP);
		$this->_GP = $this->conf['_GP'];
		$lat = $this->_GP['startLat'];
		$lon = $this->_GP['startLon'];
		$pi = M_PI;

		// get all field names
		$result = $GLOBALS['TYPO3_DB']->admin_get_fields('tx_locator_locations');
		foreach ($result as $key => $value) {
		    $tableFields[] = $key;
		}

		$table = 'tx_locator_locations a';
		if ($lat) // $lat empty if called without notepadId, so no distance available
			$fields = " distinct *,imageurl as image, (((acos(sin(($lat*$pi/180)) * sin((lat*$pi/180)) + cos(($lat*$pi/180)) *  cos((lat*$pi/180)) * cos((($lon - lon)*$pi/180)))))*6370) as distance,
			 (select group_concat(c.name) from tx_locator_categories c where (a.categoryuid = c.uid OR a.categoryuid like concat('%,',c.uid) OR a.categoryuid like concat(c.uid,',%') OR a.categoryuid like concat('%,', concat(c.uid,',%')))) as name";
		else
			$fields = " distinct *,imageurl as image,
			(select group_concat(c.name) from tx_locator_categories c where (a.categoryuid = c.uid OR a.categoryuid like concat('%,',c.uid) OR a.categoryuid like concat(c.uid,',%') OR a.categoryuid like concat('%,', concat(c.uid,',%')))) as name";
		$where_clause = " a.pid IN (" . $this->conf['pid_list'] . ") ";

		$where_clause .= str_replace('tx_locator_locations', 'a', $this->cObj->enableFields('tx_locator_locations'));


		// sanitizing
		if (preg_match('/^[0-9,]*$/', $this->_GP['categories']) == 1) {
		    // all is ok
		} else $this->_GP['categories'] = '';

		if ($this->_GP['categories'] > 0) {
			if ($this->getChildCategories($this->_GP['categories']))
		 		$categories = $this->_GP['categories'] . ',' . implode(',', $this->getChildCategories($this->_GP['categories']));
			else $categories = $this->_GP['categories'];

//debug($categories);
			$categories = explode(',', $categories);
            $categoryField = 'a.categoryuid';
			foreach ($categories as $cat) {
				$cat = (int) trim($cat);
				if ($counter == 0) {
					$category_search .= " " . $categoryField . " = '$cat' ";
					$category_search .= " OR " . $categoryField . " = '' ";
					$category_search .= " OR " . $categoryField . " LIKE '$cat,%' ";
					$category_search .= " OR " . $categoryField . " LIKE '%,$cat,%' ";
					$category_search .= " OR " . $categoryField . " LIKE '%,$cat' ";
				} else {
					if ($cat != 0) {
						//                    $category_search .= " OR categories LIKE '%$cat%' ";
						$category_search .= " OR " . $categoryField . " = '$cat' ";
						$category_search .= " OR " . $categoryField . " LIKE '$cat,%' ";
						$category_search .= " OR " . $categoryField . " LIKE '%,$cat,%' ";
						$category_search .= " OR " . $categoryField . " LIKE '%,$cat' ";
					}
				}
				$counter++;
			}
//debug($category_search);
// 16.04.2014 Belz
            $where_clause .= ' AND (' . $category_search . ')';
		}

		if ($this->conf['singleView.']['showRelatedStores']) {
			$where_clause .= ' AND relatedto=""';
		}

		// sanitizing
		if (preg_match('/^[0-9,]*$/', $this->_GP['uidsToHideInOtherMatches']) == 1) {
		    // all is ok
		} else $this->_GP['uidsToHideInOtherMatches'] = '';

		if (preg_match('/^[A-z0-9= "]*$/', $this->conf['listViewAddWhere']) == 1) {
		    // all is ok
		} else $this->conf['listViewAddWhere'] = '';

		if (preg_match('/^[A-z0-9 ]*$/', $this->conf['listViewOrderBy']) == 1) {
		    // all is ok
		} else $this->conf['listViewOrderBy'] = 'storename';

		if ($this->_GP['uidsToHideInOtherMatches'])
			$where_clause .= ' AND uid not in (' . $this->_GP['uidsToHideInOtherMatches'] . ')';
		if ($this->conf['listViewAddWhere'])
			$where_clause .= ' AND ' . $this->conf['listViewAddWhere'];
		if (!$this->conf['listViewOrderBy'] || !$lat)  // $lat empty if called without notepadId
			$orderBy = 'storename';
		else
			$orderBy = $this->conf['listViewOrderBy'];

// && $lat added 12.12.2013
		if ($this->_GP['radius'] && $lat)
			$where_clause .= ' HAVING distance <' . intval($this->_GP['radius']);

		// if notepad is enabled and we are on the notepad page
		// show only stores which are stored in cookie
		//

		// sanitizing
		if (preg_match('/^[0-9,]*$/', $_COOKIE['notepadStoreUids']) == 1)
		    $uidList = $_COOKIE['notepadStoreUids'];
		else $uidList = '';
 		if ($_COOKIE['notepadStoreUids'] && $this->conf['pageId'] == $this->conf['notepadId']) {
		    $where_clause .= ' AND a.uid in (' . $uidList . ')';
 		}

		$GLOBALS['TYPO3_DB']->debugOutput = 1;


		$result = $GLOBALS['TYPO3_DB']->exec_SELECTquery($fields, $table, $where_clause, $groupBy, $orderBy, $results_limit);
		while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($result)) {
			for ($j = 0; $j < count($tableFields); $j++) {
                $data[$tableFields[$j]][] .= $row[$tableFields[$j]];
			}
			$data['distance'][] .= $row['distance'];
		}
		$marks = array();
		$template = $this->cObj->getSubpart($this->template, '###MAPALLLISTHEADER###');
		$marks['###PAGEV###'] = $this->conf['notepadId'];
		$marks['###NOTEPADLINKTITLE###'] = $this->getLL('notepad');
		$marks['###ZIPCODEV###'] = htmlspecialchars($this->_GP['zipcode']);
		$marks['###CITYV###'] = htmlspecialchars($this->_GP['city']);
		$marks['###ADDRESSV###'] = htmlspecialchars($this->_GP['address']);
		$marks['###COUNTRYV###'] = htmlspecialchars($this->_GP['country']);
		$marks['###RADIUSV###'] = htmlspecialchars($this->_GP['radius']);

/*
		$urlParams = array (
			'tx_locator_pi1[city]' => $this->_GP['city'],
			'tx_locator_pi1[zipcode]' => $this->_GP['zipcode'],
			'tx_locator_pi1[address]' => $this->_GP['address'],
			'tx_locator_pi1[country]' => $this->_GP['country'],
			'tx_locator_pi1[radius]' => $this->_GP['radius'],
		);
*/
//		$feUserObj = tslib_eidtools::initFeUser(); // Initialize FE user object
//		$GLOBALS[TSFE]->fe_user = $feUserObj;
//		$GLOBALS['TSFE']->sys_page = t3lib_div::makeInstance('t3lib_pageSelect');
//		$GLOBALS['TSFE']->tmpl = t3lib_div::makeInstance('t3lib_TStemplate');
//		$this->cObj = t3lib_div :: makeInstance('tslib_cObj');

		$marks['###NOTEPADLINK###'] =  $this->pi_getPageLink($this->conf['notepadId'], '_top', $urlParams);

		$marks['###STARTLAT###'] = $this->_GP['startLat'];
		$marks['###STARTLON###'] = $this->_GP['startLon'];
		$out = $this->cObj->substituteMarkerArray($template, $marks);
		$template = $this->cObj->getSubpart($this->template, '###MAPALLLISTDATA###');
		$cookie = $_COOKIE['notepadStoreUids'];
		$marks['###ADDTONOTEPAD###'] = $this->getLL('addToNotepad');
		$marks['###REMOVEFROMNOTEPAD###'] = $this->getLL('removeFromNotepad');

		for ($i = 0; $i < count($data['storename']); $i++) {
			for ($j = 0; $j < count($tableFields); $j++) {
			    $marks['###' . strtoupper($tableFields[$j]) . 'V###'] = $data[$tableFields[$j]][$i];
    		}
		    $marks['###STORENAMEV###'] = addslashes($data['storename'][$i]);
		    $marks['###STORENAMELINKV###'] = $data['storename'][$i];
			if ($data['url'][$i]) {
			    $marks['###STORENAMELINKV###'] = $this->pi_linkToPage($data['storename'][$i], $data['url'][$i], '_blank');
			}
			if ($cookie && t3lib_div::inList($cookie, $data['uid'][$i])) {
			    $marks['###MARKSTATEDISPLAY###'] = 'none';
			    $marks['###UNMARKSTATEDISPLAY###'] = 'block';
			} else {
			    $marks['###MARKSTATEDISPLAY###'] = 'block';
			    $marks['###UNMARKSTATEDISPLAY###'] = 'none';
			}

			if ($data['imageurl'][$i]) {
				$this->conf['notepadView.']['image.']['file'] = 'uploads/tx_locator/' . $data['imageurl'][$i];
				$marks['###IMAGEV###'] = $this->cObj->IMAGE($this->conf['notepadView.']['image.']);
			} else $marks['###IMAGEV###'] = '';

			if($this->conf['distanceUnit'] == 'miles')
				$marks['###DISTANCEV###'] = number_format($data['distance'][$i] / 1.6, 2, ',', '') . ' miles';
			else
				$marks['###DISTANCEV###'] = number_format($data['distance'][$i], 2, ',', '') . ' km';


			if (is_array($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerMapAllListHook'])) {
				foreach ($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerMapAllListHook'] as $_classRef) {
					$_procObj = & t3lib_div :: getUserObj($_classRef);
					$marks = $_procObj->extraItemMarkerMapAllListProcessor($marks, $data['uid'][$i], $this);
				}
			}


			$out .= $this->cObj->substituteMarkerArray($template, $marks);
		}
		$template = $this->cObj->getSubpart($this->template, '###MAPALLLISTFOOTER###');



		$out .= $this->cObj->substituteMarkerArray($template, $marks);
		echo $out;

	}


	function getStorename($uid) {
		$table = 'tx_locator_locations';
		$where = ' uid =' .  intval($uid);
		$fields = 'storename';
		$orderBy = 'sorting';
		$result = $GLOBALS['TYPO3_DB']->exec_SELECTquery($fields, $table, $where, '', $orderBy);
		$out = array ();
		$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($result);
		echo htmlspecialchars($row['storename']);
	}

	function getChildCategories($cat) {
		// sanitizing
		if (preg_match('/^[0-9,]*$/', $this->conf['pid_list']) == 1) {
		    // all is ok
		} else $this->conf['pid_list'] = '';

		$table = 'tx_locator_categories';
		$where_clause = " parentUid =" .  intval($cat) ." AND pid IN (" . $this->conf['pid_list'] . ") AND deleted='0' AND hidden='0'";
		$fields = "*";
		$orderBy = 'sorting';
		$result = $GLOBALS['TYPO3_DB']->exec_SELECTquery($fields, $table, $where_clause, '', $orderBy);
		$out = array ();
		while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($result)) {
			$this->children[] .= $row['uid'];
			if ($row['uid'] > 0)
				$this->getChildCategories($row['uid']);

		}
		return $this->children;
	}




	function getMap() {
		require_once(PATH_t3lib . 'class.t3lib_page.php');
		require_once(PATH_tslib . 'class.tslib_pibase.php');
		require_once(PATH_tslib . 'class.tslib_content.php');
		require_once(PATH_t3lib . 'class.t3lib_stdgraphic.php');
		require_once(PATH_tslib . 'class.tslib_gifbuilder.php');

		require_once(PATH_t3lib . 'class.t3lib_div.php');

		$classTemp = t3lib_div::makeInstance('tslib_fe');
		$GLOBALS['TSFE'] = new $classTemp($TYPO3_CONF_VARS, $this->_GP['pageUid'], 0, true);
		$GLOBALS['TSFE']->tmpl = t3lib_div::makeInstance('t3lib_tstemplate');
		$GLOBALS['TSFE']->tmpl->init();
		$GLOBALS['TSFE']->sys_page = t3lib_div::makeInstance('t3lib_pageSelect');
		$GLOBALS['TSFE']->rootLine = $GLOBALS['TSFE']->sys_page->getRootLine(intval(4));
//		$GLOBALS['TSFE']->getCompressedTCarray();
		$GLOBALS['TSFE']->initTemplate();
		$GLOBALS['TSFE']->getConfigArray();

		$GLOBALS['TSFE']->includeTCA(false);

		$this->cObj = new tslib_cObj();



//        require_once(t3lib_extMgm::extPath('locator')."pi1/class.tx_locator_view.php");
//        $this->conf['templateFile'] = 'EXT:locator/pi1/template.html';



        require_once(t3lib_extMgm::extPath('locator')."pi1/class.tx_locator_controller.php");
        require_once(t3lib_extMgm::extPath('locator')."pi1/class.tx_locator_view.php");
        $this->conf['templateFile'] = 'EXT:locator/pi1/template.html';
		$view = tx_locator_view::makeInstance("tx_locator_view",
                                                    $this->conf);


		// reading data vars for $this->conf
		$arr = json_decode(urldecode($this->_GP['jsonData']));
		foreach(get_object_vars($arr) as $key => $value) {
			if (is_string($key) && is_string($value)) {
				//echo $key . '-' . $value;
				$this->conf[$key] = $value;
			}
			// reading data vars for $this->_GP in alternative mode
			// not used yet
			if($key == '_GP' && is_object($value)) {
				foreach(get_object_vars($value) as $key => $value) {
					if (is_string($key) && is_string($value)) {
						//echo $key . '-' . $value;
						$this->conf['_GP'][$key] = $value;
					}
				}
			//echo 'object';

			}
			//if(is_array($value)) echo 'array';
		}




//print_r($GLOBALS['TSFE']->tmpl->setup['plugin.']['tx_locator_pi1.']);
//print_r($this->conf);
//exit;

//        $this->conf['externalLocationTable'] = 'tx_flatmgr_flat';
        $this->conf['displayMode'] = 'mapView';
        $this->conf['mapWidth'] = 600;
        $this->conf['mapHeight'] = 400;

		// sanitizing
		if (preg_match('/^[0-9,]*$/', $this->conf['pid_list']) == 1) {
		    // all is ok
		} else $this->conf['pid_list'] = '';


        $this->conf['showOverviewMap'] = 1;
        $this->conf['distanceUnit'] = 'km';

        $this->conf['googleApiVersion'] = '3.s';
//        $this->conf['uidOfSingleView'] = $this->_GP['flatUid'];
        $this->conf['useFeUserData'] = 0;
        $this->conf['enableStreetView'] = 1;
        $this->conf['enableStreetViewOverlay'] = 1;
        $this->conf['showResultTable'] = 1;

        $controller = new tx_locator_controller();

		$this->_GP['mode'] = 'search';
        $controller->setGPVars($this->_GP);
        $controller->setConfiguration($this->conf);
        $controller->setLocalLang($this->LOCAL_LANG);
        $content = $controller->handle();
        $content = $this->pi_wrapInBaseClass($content);

//        $content .= '<div id="map" class="tx_locator_map" style="width:' . $this->conf['mapWidth'] . 'px; height:' . $this->conf['mapHeight'] . 'px;"></div>';
        $content .= '<script type="text/javascript">
            /*<![CDATA[*/
				$j.getScript("http://maps.google.com/maps/api/js?sensor=true&region=nz&async=2&callback=load", function () {});
//                google.maps.event.trigger(map, "resize");

            /*]]>*/
             </script>';
		echo $content;
	}

	function get_webpage($url) {
		//global $db;
		if (ini_get('allow_url_fopen'))
			$this->conf['useCurl'] = 0;
		else
			$this->conf['useCurl'] = 1;
		if ($this->conf['useCurl']) {
			$sessions = curl_init();
			curl_setopt($sessions, CURLOPT_URL, $url);
			curl_setopt($sessions, CURLOPT_HEADER, 0);
			curl_setopt($sessions, CURLOPT_RETURNTRANSFER, 1);
			$data = curl_exec($sessions);
			curl_close($sessions);
		} else {
			// ini_set('allow_url_fopen','on');
			$data = @ file_get_contents($url);
		}
		return $data;
	}



	function getAddress($location) {
		$location = str_replace(' ', '+', $location);
		$apiURL = "http://maps.googleapis.com/maps/api/geocode/json?address=$location&output=json&language=" . $this->_GP['lang'] . "&sensor=false";
		$addressData = $this->get_webpage($apiURL);

		$_address = $this->getStrsBetween($addressData, "<address>", "</address>");

		$obj = json_decode($addressData, true);
		$addressData = $obj['results'][0]['formatted_address'];


		$_data = array();
		for ($i = 0; $i < count($obj['results']); $i++) {
			$_data['label'] = html_entity_decode($obj['results'][$i]['formatted_address']); // . $obj['results'][$i]['geometry']['location']['lat']);
			$_data['value'] = html_entity_decode($obj['results'][$i]['formatted_address']); // . $obj['results'][$i]['geometry']['location']['lat']);
			$_data['latlon'] = $obj['results'][$i]['geometry']['location']['lat'] .',' . $obj['results'][$i]['geometry']['location']['lng'];
			$_rData[] = $_data;
		}

//$_rData = $addressData;
//print_r($this->_GP);
	    echo json_encode($_rData);
		exit;
	}
	




	function getLL($s) {
		// for typoscript language labels
		if ($this->conf['_LOCAL_LANG.'][$this->lang.'.'][$s])
		    return $this->conf['_LOCAL_LANG.'][$this->lang.'.'][$s];

		global $TYPO3_CONF_VARS;
		if ($TYPO3_CONF_VARS['SYS']['compat_version'] < '4.6')
		return $this->LOCAL_LANG[$this->lang][$s];
		else {
		    $_label = $this->LOCAL_LANG[$this->lang][$s];
		    return $_label[0]['target'];
		}
	}

	function getRelativeFileName($filename)	{
		if (substr($filename,0,4)=='EXT:')	{
			list($extKey,$local) = explode('/',substr($filename,4),2);
			$filename = '';
			if (strcmp($extKey,'') && t3lib_extMgm::isLoaded($extKey) && strcmp($local,''))	{
				return t3lib_extMgm::siteRelPath($extKey).$local;
			}
		} else return $filename;
	}






}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/locator/pi1/class.tx_locator_eID.php']) {
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/locator/pi1/class.tx_locator_eID.php']);
}

// Make instance:
$SOBE = t3lib_div::makeInstance('tx_locator_eID');
$SOBE->main();

?>