<?php

/***************************************************************
*  Copyright notice
*
*  (c) 2007 - 2013 Joachim Ruhs <postmaster@joachim-ruhs.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

if (!class_exists('tslib_pibase')) require_once (PATH_tslib . 'class.tslib_pibase.php');
if (!class_exists('t3lib_tcemain')) require_once (PATH_t3lib . 'class.t3lib_tcemain.php');
//require_once(PATH_t3lib.'class.t3lib_userauthgroup.php');

/**
 * Plugin 'Store Locator' for the 'locator' extension.
 *
 * @author    Joachim Ruhs <postmaster@joachim-ruhs.de>
 * @package    TYPO3
 * @subpackage    tx_locator
 */
class tx_locator_pi1 extends tslib_pibase {
	var $prefixId = 'tx_locator_pi1'; // Same as class name
	var $scriptRelPath = 'pi1/class.tx_locator_pi1.php'; // Path to this script relative to the extension dir.
	var $extKey = 'locator'; // The extension key.
//	var $pi_checkCHash = true; throws error in 6.1
	var $pi_checkCHash = false;

	function getRelativeFileName($filename) {
		if (substr($filename, 0, 4) == 'EXT:') {
			list ($extKey, $local) = explode('/', substr($filename, 4), 2);
			$filename = '';
			if (strcmp($extKey, '') && t3lib_extMgm :: isLoaded($extKey) && strcmp($local, '')) {
				return t3lib_extMgm :: siteRelPath($extKey) . $local;
			}
		} else
			return $filename;
	}


	/**
	 * The main method of the PlugIn
	 *
	 * @param    string       $content: The PlugIn content
	 * @param    array        $conf: The PlugIn configuration
	 * @return   The content that is displayed on the website
	 */
	function main($content, $conf) {
		global $TYPO3_CONF_VARS, $HTTP_POST_VARS;
		$this->_EXTCONF = unserialize($TYPO3_CONF_VARS['EXT']['extConf']['locator']);

		$content = '';
		//      error_reporting(E_ALL);
		$this->conf = $conf;

		$pidList = $this->pi_getPidList($this->cObj->data['pages'], $this->cObj->data['recursive']);
		if (empty ($this->conf['pid_list']))
			$this->conf['pid_list'] = $pidList;

		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();


		$this->pi_initPIflexForm();
		if (empty ($this->conf['displayMode']))
			$this->conf['displayMode'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'displayMode', 'sheetDisplayMode'));
		if ($this->conf['displayMode'] == null)
			$this->conf['displayMode'] = 'mapView';
		if (empty ($this->conf['showAreas']))
			$this->conf['showAreas'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showAreas', 'sheetShapeAreaOptions'));
		if (empty ($this->conf['showPoiTable']))
			$this->conf['showPoiTable'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showPoiTable', 'sheetDisplayMode'));
		if (empty ($this->conf['defaultMapType']))
			$this->conf['defaultMapType'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'defaultMapType', 'sheetDisplayMode'));
		if (empty ($this->conf['defaultZoomLevel']))
			$this->conf['defaultZoomLevel'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'defaultZoomLevel', 'sheetDisplayMode'));
		if (empty ($this->conf['enableStreetViewOverlay']))
			$this->conf['enableStreetViewOverlay'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'enableStreetViewOverlay', 'sheetDisplayMode'));
		if (empty ($this->conf['enableStreetView']))
			$this->conf['enableStreetView'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'enableStreetView', 'sheetDisplayMode'));
		if ($this->conf['enableStreetView'] == null)
			$this->conf['enableStreetView'] = 0;
		if (empty ($this->conf['enableMoreButton']))
			$this->conf['enableMoreButton'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'enableMoreButton', 'sheetDisplayMode'));
		if (empty ($this->conf['additionalLayers']))
			$this->conf['additionalLayers'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'additionalLayers', 'sheetDisplayMode'));

		if (empty ($this->conf['apiV3Layers']))
			$this->conf['apiV3Layers'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'apiV3Layers', 'sheetDisplayMode'));



		if (empty ($this->conf['storeTitle']))
			$this->conf['storeTitle'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'storeTitle', 'sheetDisplayMode'));
		if (empty ($this->conf['linkTarget']))
			$this->conf['linkTarget'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'linkTarget', 'sheetDisplayMode'));
		if (empty ($this->conf['routeViewTarget']))
			$this->conf['routeViewTarget'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'routeViewTarget', 'sheetDisplayMode'));

		if (empty ($this->conf['templateFile']))
			$this->conf['templateFile'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'templateFile', 'sheetTemplateOptions'));
		if (empty ($this->conf['cssFile']))
			$this->conf['cssFile'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'cssFile', 'sheetTemplateOptions'));
		if (empty ($this->conf['finderTemplate']))
			$this->conf['finderTemplate'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'finderTemplate', 'sheetTemplateOptions'));

		if (empty ($this->conf['uidOfSingleView']))
			$this->conf['uidOfSingleView'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'uidOfSingleView', 'sheetDisplayMode'));
		if ($this->conf['uidOfSingleView'] == '')
			$this->conf['uidOfSingleView'] = 1;
		if (empty ($this->conf['useFeUserPageTitle']))
			$this->conf['useFeUserPageTitle'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'useFeUserPageTitle', 'sheetDisplayMode'));
		if (empty ($this->conf['showOverviewMap']))
			$this->conf['showOverviewMap'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showOverviewMap', 'sheetDisplayMode'));
		if (empty ($this->conf['useFeUserData']) /*&& $this->conf['useFeUserData'] != 0 */
			)
			$this->conf['useFeUserData'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'useFeUserData', 'sheetDisplayMode'));
		if (empty ($this->conf['externalLocationTable']))
			$this->conf['externalLocationTable'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'externalLocationTable', 'sheetDisplayMode'));
		if (empty ($this->conf['feUserGroup']))
			$this->conf['feUserGroup'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'feUserGroup', 'sheetDisplayMode'));
		if (empty ($this->conf['tt_addressStorenameField']))
			$this->conf['tt_addressStorenameField'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'tt_addressStorenameField', 'sheetDisplayMode'));
		if (empty ($this->conf['tt_addressAllowedGroups']))
			$this->conf['tt_addressAllowedGroups'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'tt_addressAllowedGroups', 'sheetDisplayMode'));
		if (empty ($this->conf['tt_addressNotAllowedGroups']))
			$this->conf['tt_addressNotAllowedGroups'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'tt_addressNotAllowedGroups', 'sheetDisplayMode'));
		if (empty ($this->conf['showTabbedInfoWindow']))
			$this->conf['showTabbedInfoWindow'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showTabbedInfoWindow', 'sheetDisplayMode'));
		if (empty ($this->conf['showVideoPlayer']))
			$this->conf['showVideoPlayer'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showVideoPlayer', 'sheetDisplayMode'));
		if (empty ($this->conf['numberOfMails']))
			$this->conf['numberOfMails'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'numberOfMails', 'sheetDisplayMode'));
		if (empty ($this->conf['showOnlyMailResultTable']))
			$this->conf['showOnlyMailResultTable'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showOnlyMailResultTable', 'sheetDisplayMode'));
		if (empty ($this->conf['shapeFile']))
			$this->conf['shapeFile'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'shapeFile', 'sheetShapeAreaOptions'));
		if (empty ($this->conf['fillZipcodeArea']))
			$this->conf['fillZipcodeArea'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'fillZipcodeArea', 'sheetShapeAreaOptions'));
		if (empty ($this->conf['zoomZipcodeArea']))
			$this->conf['zoomZipcodeArea'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'zoomZipcodeArea', 'sheetShapeAreaOptions'));
		if (empty ($this->conf['additionalMapTypes']))
			$this->conf['additionalMapTypes'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'additionalMapTypes', 'sheetDisplayMode'));

		if (empty ($this->conf['helpPageId']))
			$this->conf['helpPageId'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'helpPageId', 'sheetGeneralOptions'));
		if (empty ($this->conf['useNotesInternal']))
			$this->conf['useNotesInternal'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'useNotesInternal', 'sheetGeneralOptions'));
		if (empty ($this->conf['enableLogs']))
			$this->conf['enableLogs'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'enableLogs', 'sheetGeneralOptions'));
		if (empty ($this->conf['debug']))
			$this->conf['debug'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'debug', 'sheetGeneralOptions'));
		if (empty ($this->conf['radiusPresets']))
			$this->conf['radiusPresets'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'radiusPresets', 'sheetGeneralOptions'));
		if (empty ($this->conf['resultLimit']))
			$this->conf['resultLimit'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'resultLimit', 'sheetGeneralOptions'));
		if (empty ($this->conf['googleApiKey']))
			$this->conf['googleApiKey'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'googleApiKey', 'sheetGeneralOptions'));
		if (empty ($this->conf['googleApiVersion']))
			$this->conf['googleApiVersion'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'googleApiVersion', 'sheetGeneralOptions'));
		if (empty ($this->conf['useCurl']))
			$this->conf['useCurl'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'useCurl', 'sheetGeneralOptions'));
		if (empty ($this->conf['countryCodes']))
			$this->conf['countryCodes'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'countryCodes', 'sheetGeneralOptions'));
		if (empty ($this->conf['searchByName']))
			$this->conf['searchByName'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'searchByName', 'sheetGeneralOptions'));
		if (empty ($this->conf['resultPageId']))
			$this->conf['resultPageId'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'resultPageId', 'sheetGeneralOptions'));
		if (empty ($this->conf['countrySelectorResultPageId']))
			$this->conf['countrySelectorResultPageId'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'countrySelectorResultPageId', 'sheetGeneralOptions'));
		if (empty ($this->conf['routePageId']))
			$this->conf['routePageId'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'routePageId', 'sheetGeneralOptions'));
		if (empty ($this->conf['feUserListingPageId']))
			$this->conf['feUserListingPageId'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'feUserListingPageId', 'sheetGeneralOptions'));
		if (empty ($this->conf['showStoreImage']))
			$this->conf['showStoreImage'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showStoreImage', 'sheetGeneralOptions'));
		if (empty ($this->conf['distanceUnit']))
			$this->conf['distanceUnit'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'distanceUnit', 'sheetGeneralOptions'));

		if (empty ($this->conf['useCookie']))
			$this->conf['useCookie'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'useCookie', 'sheetCookieOptions'));
		if (empty ($this->conf['cookieLifeTime']))
			$this->conf['cookieLifeTime'] = htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'cookieLifeTime', 'sheetCookieOptions'));

		if ($this->conf['distanceUnit'] == null)
			$this->conf['distanceUnit'] = 'km';
		if ($this->conf['googleApiVersion'] == '')
			$this->conf['googleApiVersion'] = '2.x';

		// Get/Post Variables
		$this->_GP = t3lib_div :: _GP('tx_locator_pi1');
		//$this->cObj = t3lib_div::makeInstance("tslib_cObj");

		if ($this->_GP['mode'] == 'showRoute' && $this->conf['displayMode'] != 'shopFinder') {
			$this->conf['displayMode'] = 'routeView';
			$this->_GP['mode'] = 'showMap';
		}
		if ($this->_GP['mode'] == 'clearCookie') {
			$this->conf['displayMode'] = ' mapView';
		}

		switch ($this->conf['displayMode']) {
			case 'mapView' :
				$this->conf['showResultTable'] = 1;
				$this->conf['showRoute'] = 0;
				break;
			case 'mapAllView' :
				$this->conf['showResultTable'] = 0;
				$this->conf['showRoute'] = 0;
				break;
			case 'mapAllNoFormView' :
				$this->conf['showResultTable'] = 0;
				$this->conf['showRoute'] = 0;
				//                $this->_GP['radius'] = 1000;
				$this->_GP['mode'] = 'mapAllNoFormView';
				break;
			case 'routeView' :
				$this->conf['showResultTable'] = 1;
				$this->conf['showRoute'] = 1;
				break;
			case 'singleView' :
				$this->conf['showResultTable'] = 1;
				$this->conf['showRoute'] = 0;
				break;
			case 'autoMailView' :
				$this->conf['showResultTable'] = 0;
				$this->conf['showRoute'] = 0;
				break;
			case 'zipcodeAreaView' :
				$this->conf['showResultTable'] = 0;
				$this->conf['showRoute'] = 0;
				$this->_GP['mode'] = 'zipcode';
				break;
			case 'zipcodeAreaNoFormView' :
				$this->conf['showResultTable'] = 0;
				$this->conf['showRoute'] = 0;
				$this->_GP['mode'] = 'zipcode';
				break;
			case 'listView' :
				if ($this->_GP['city']) {
					$this->conf['showRoute'] = 1;
					$this->conf['displayMode'] = 'showMap';
					break;
				}

				$this->conf['showResultTable'] = 0;
				$this->conf['showRoute'] = 0;
				if ((int) $this->_GP['storeUid'] != 0) {
					// switch to singelView
					$this->conf['uidOfSingleView'] = (int) $this->_GP['storeUid'];
					$this->conf['showResultTable'] = 1;
					$this->conf['displayMode'] = 'singleView';
				} else
					$this->_GP['mode'] = 'listView';
				break;
			case 'countryCitySelector' :
				if ($this->_GP['city'] == '') {
					$this->conf['showResultTable'] = 1;
					$this->conf['showRoute'] = 0;
					$this->_GP['mode'] = 'countryCitySelector';
				} else {
					$this->conf['showResultTable'] = 1;
					$this->conf['showRoute'] = 0;
					$this->_GP['mode'] = 'search';
					$this->_GP['radius'] = '25';
					// here we have to fetch the correct country code
					require_once (t3lib_extMgm :: extPath('locator') . "pi1/class.tx_locator_model.php");
					$model = new tx_locator_model();
					$this->_GP['country'] = $model->getCnIso2($this->_GP['country']);
					//$this->_GP['country'] = 'de';

				}
				break;
			case 'shopFinder' :
				$this->conf['showResultTable'] = 1;
				$this->conf['showRoute'] = 0;
				$this->_GP['mode'] = 'shopFinder';
				break;

			case 'searchFormView' :
				$this->conf['showResultTable'] = 0;
				$this->conf['showRoute'] = 0;
				$this->_GP['mode'] = '';
				break;
			case 'catMenuView' :
				$this->conf['showResultTable'] = 0;
				$this->conf['showRoute'] = 0;
				$this->_GP['mode'] = 'catMenuView';
				break;
			case 'ajaxSearchWithMap' :
				$this->conf['showResultTable'] = 0;
				$this->conf['showRoute'] = 0;
				$this->_GP['mode'] = 'ajaxSearchWithMap';
				break;

		}
		// cookie
		if (($this->conf['displayMode'] != 'mapView' && $this->conf['displayMode'] != 'simpleView'))
			$this->conf['useCookie'] = 0;
		if ($this->conf['useCookie'] && $this->_GP['storeUid'] > 0) {
			setcookie('tx_locator_storeuid', $this->_GP['storeUid'], time() + $this->conf['cookieLifeTime'], '/');
			setcookie('tx_locator_storename', $this->_GP['storename'], time() + $this->conf['cookieLifeTime'], '/');
			setcookie('tx_locator_city', $this->_GP['city'], time() + $this->conf['cookieLifeTime'], '/');
			setcookie('tx_locator_address', $this->_GP['address'], time() + $this->conf['cookieLifeTime'], '/');
			setcookie('tx_locator_zipcode', $this->_GP['zipcode'], time() + $this->conf['cookieLifeTime'], '/');
			setcookie('tx_locator_phone', $this->_GP['phone'], time() + $this->conf['cookieLifeTime'], '/');
			setcookie('tx_locator_distance', $this->_GP['distance'], time() + $this->conf['cookieLifeTime'], '/');
		}

		if ($this->conf['useCookie'] && $_COOKIE['tx_locator_storeuid']) {
			$this->_GP['storeUid'] = $_COOKIE['tx_locator_storeuid'];
			$this->conf['uidOfSingleView'] = $_COOKIE['tx_locator_storeuid'];
			if ($this->conf['displayMode'] == 'simpleView')
				$this->_GP['mode'] = 'simpleSingleView';
			if (!$this->conf['useFeUserData'])
				$this->conf['useFeUserData'] = 0;
		}

		if ($this->_GP['storename'])
			$this->conf['searchByName'] = 1;
		else
			$this->conf['searchByName'] = 0;


		if ($this->conf['debug']) {
			$devLog = array('$this->_GP' => $this->_GP,
		 					'$this->conf' => $this->conf);
			t3lib_div::devLog('main', 'tx_locator', 3, $devLog);

		}

		// Including CSS
		$cssFile = $this->getRelativeFileName($this->conf['cssFile']);
		$GLOBALS["TSFE"]->additionalHeaderData['locator_pi1'] = '<link rel="stylesheet" type="text/css" href="' . $cssFile . '" />';

		// the template file
		$this->template = $this->cObj->fileResource($this->conf['templateFile']);


		// clear page cache needed for the form to work correct!
		$clearCacheIds = $GLOBALS['TSFE']->id;
		$GLOBALS['TSFE']->clearPageCacheContent_pidList($clearCacheIds);

		if ($this->conf['displayMode'] == 'singleView')
			$this->_GP['mode'] = 'singleView';

		//debug($_COOKIE);
		//debug($this->conf);
		//debug($this->_GP);

		/*
		////////////////// GEO
		// use geo ip if loaded
		    if (t3lib_extMgm::isLoaded('geoip') && $this->_GP['mode'] != 'showMap') {
		        require_once( t3lib_extMgm::extPath('geoip').'/pi1/class.tx_geoip_pi1.php');
		        $this->media = t3lib_div::makeInstance('tx_geoip_pi1');

		        $path = 'fileadmin/GeoLiteCity.dat';
		        $this->media->init($path); // Initialize the Geoip Ext
		        $infos = $this->media->getGeoIP($ip='217.233.106.170'); // get all the infos
		debug($infos);
		        $this->_GP['lat'] = $infos['lat'];
		        $this->_GP['lon'] = $infos['lng'];
		        $this->_GP['radius'] = 100;
		        $this->_GP['mode'] = 'search';
		    }

		////////////////// GEO
		*/

		///////////////////////// MVC ////////////////////////
		require_once (t3lib_extMgm :: extPath('locator') . "pi1/class.tx_locator_controller.php");
		$controller = t3lib_div :: makeInstance('tx_locator_controller');
		$controller->setGPVars($this->_GP);
		$controller->setConfiguration($this->conf);
		$controller->setLocalLang($this->LOCAL_LANG);
		$content = $controller->handle();
		return $this->pi_wrapInBaseClass($content);
	}

	function extraItemMarkerProcessor($markerArray, $row, $lConf, $obj) {
		//debug($row);

		$markerArray['###LOCATOR_LAT###'] = $row['tx_locator_lat'];
		$markerArray['###LOCATOR_LON###'] = $row['tx_locator_lon'];
		$markerArray['###LOCATOR_ADDRESS###'] = $row['tx_locator_address'];
		$markerArray['###LOCATOR_ZIPCODE###'] = $row['tx_locator_zipcode'];
		$markerArray['###LOCATOR_CITY###'] = $row['tx_locator_city'];
		$markerArray['###LOCATOR_STATE###'] = $row['tx_locator_state'];
		$markerArray['###LOCATOR_COUNTRY###'] = $row['tx_locator_country'];
		$markerArray['###LOCATOR_EMAIL###'] = $row['tx_locator_email'];
		$markerArray['###LOCATOR_PHONE###'] = $row['tx_locator_phone'];
		$markerArray['###LOCATOR_HOURS###'] = $row['tx_locator_hours'];
		$markerArray['###LOCATOR_URL###'] = $row['tx_locator_url'];
		$markerArray['###LOCATOR_NOTES###'] = $row['tx_locator_notes'];
		$markerArray['###LOCATOR_IMAGEURL###'] = $row['tx_locator_imageurl'];
		$markerArray['###LOCATOR_ICON###'] = $row['tx_locator_icon'];
		$markerArray['###LOCATOR_STORENAME###'] = $row['tx_locator_storename'];

		if ($obj->config['code'] != 'SINGLE')
			return $markerArray;




		// now the Google map
		/* insert this to pages TS setup of singleView
		plugin.tt_news {
		      displaySingle {
		    date_stdWrap.strftime= %d.%m.%y
		    time_stdWrap.strftime= %H:%M

		    googleApiKey = xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
		    mapWidth = 550
		    mapHeight = 300
		    panoWidth = 550
		    panoHeight = 300
		    enableStreetView = 1
		    allowCaching = 1 // for cache of single view
		    }
		}
		*/

		//debug($obj->config['code']);
		//debug($lConf);

		//debug($obj->tt_news_uid);

		if ($row['tx_locator_city'] != '' && $lConf['googleApiKey'] != '') { // show the map when a city is present
			$this->conf['showResultTable'] = 1;
			$this->conf['showRoute'] = 0;
			require_once (t3lib_extMgm :: extPath('locator') . "pi1/class.tx_locator_controller.php");
			require_once (t3lib_extMgm :: extPath('locator') . "pi1/class.tx_locator_view.php");
			$view = tx_locator_view :: makeInstance("tx_locator_view", $this->conf);
			$pidList = $obj->pid_list;

			$this->conf['allowCaching'] = $lConf['allowCaching']; // for caching tt_news single

			$this->conf['pid_list'] = $pidList;
			$this->conf['googleApiKey'] = $lConf['googleApiKey'];
			$this->conf['googleApiVersion'] = '3.1';
			$this->conf['uidOfSingleView'] = $obj->tt_news_uid;
			$this->conf['useFeUserData'] = 3;
			$this->conf['mapWidth'] = $lConf['mapWidth'];
			$this->conf['mapHeight'] = $lConf['mapHeight'];
			$this->conf['panoWidth'] = $lConf['panoWidth'];
			$this->conf['panoHeight'] = $lConf['panoHeight'];
			$this->conf['pid_list'] = $pidList;
			$this->conf['enableStreetView'] = 1;
			$this->conf['enableStreetViewOverlay'] = 1;
			$this->conf['disableLoadInBodyTag'] = $lConf['disableLoadInBodyTag'];

			$this->conf['ttNewsSinglePid'] = $lConf['ttNewsSinglePid'];


			$this->conf['showVideoPlayer'] = 0;
			$controller = new tx_locator_controller();
			if ($lConf['displayMode'] == 'singleView') {
				$this->_GP['mode'] = 'singleView';
                $this->conf['pid_list'] = $row['pid'];
				$this->conf['templateFile'] = $lConf['templateFile'];

				// tt_news route -->
				$this->_GP = t3lib_div :: _GP('tx_locator_pi1');
				if ($this->_GP['mode'] == 'showRoute') {
				$this->conf['displayMode'] = 'routeView';
				$this->conf['showResultTable'] = 1;
				$this->conf['showRoute'] = 1;

		        //$this->_GP['lat'] = $this->_GP['startLat'];
        		//$this->_GP['lon'] = $this->_GP['startLon'];
				$this->_GP['mode'] = 'singleView';
				}
				else {
					$this->_GP['mode'] = 'singleView';
				}
				// <-- tt_news route

			} else {
				// the template file
				$this->conf['templateFile'] = $lConf['templateFile'];
				$this->conf['displayMode'] = 'mapAllNoFormView';
				$this->conf['showResultTable'] = 0;
				$this->conf['showRoute'] = 0;
				$this->_GP['mode'] = 'mapAllNoFormView';
			}
			$controller->setGPVars($this->_GP);
			$controller->setConfiguration($this->conf);
			$controller->setLocalLang($this->LOCAL_LANG);
			$content = $controller->handle();
			$content = $this->pi_wrapInBaseClass($content);
			$markerArray['###LOCATOR_MAP###'] = $content .
			'<div id="map" class="tx_locator_map" style="width:' . $this->conf['mapWidth'] . 'px; height:' . $this->conf['mapHeight'] . 'px;"></div>' .
			'<div id="pano" class="tx_locator_map" style="width:' . $this->conf['panoWidth'] . 'px; height:' . $this->conf['panoHeight'] . ' px;"></div>';
		} else
			$markerArray['###LOCATOR_MAP###'] = '';
		return $markerArray;
	}

} // end of class

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/locator/pi1/class.tx_locator_pi1.php']) {
	include_once ($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/locator/pi1/class.tx_locator_pi1.php']);
}
?>