<?php

/***************************************************************
*  Copyright notice
*
*  (c) 2008-2013 Joachim Ruhs <postmaster@joachim-ruhs.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'Store Locator' for the 'locator' extension.
 *
 * @author        Joachim Ruhs <postmaster@joachim-ruhs.de>
 */

if (!class_exists('tslib_pibase')) require_once (PATH_tslib . 'class.tslib_pibase.php');

class tx_locator_view extends tslib_pibase {
	var $prefixId = 'tx_locator_pi1';
	function & makeInstance($className, $conf) {
		//$class = new $className;
		$class = t3lib_div :: makeInstance('tx_locator_view');
		$class->setConfiguration($conf);
		$class->cObj = t3lib_div :: makeInstance('tslib_cObj');
		//$class->templateCode = $class->cObj->fileResource($conf["templateFile"]);
		$class->template = $class->cObj->fileResource($conf['templateFile']);
		$class->pi_loadLL();
		return $class;
	}

	/* Set Configuration */
	function setConfiguration($conf) {
		$this->conf = $conf;
	}
	/* Set View Input */
	function setInput($input) {
		$this->input = $input;
	}

	/* Set Code */
	function setCode($code) {
		$this->code = $code;
	}

	function setGPVars($gp) {
		$this->_GP = $gp;
	}

	function setLocalLang(& $LOCAL_LANG) {
		$this->LOCAL_LANG = $LOCAL_LANG;
	}

	function setModel(& $model) {
		$this->model = $model;
	}

	/* initial call */
	function display() {
		switch ($this->code) {
			case 'SHOWSINGLE' :
				return $this->showMap();
				break;
			case 'SHOWFORM' :
				return $this->showForm();
				break;
			case 'SHOWSTORES' :
				return $this->showStores();
				break;
			case 'SHOWMESSAGE' :
				return $this->showMessage();
				break;
			case 'SHOWMAP' :
				return $this->showMap();
				break;
			case 'SHOWZIPCODEAREAS' :
				return $this->showZipcodeAreas();
				break;
			case 'LISTVIEW' :
				return $this->listView();
				break;
			case 'SHOWCOUNTRIES' :
				return $this->countrySelectorView();
				break;
			case 'SHOWCITIES' :
				return $this->citySelectorView();
				break;
			case 'SHOWFINDER' :
				return $this->showFinder();
				break;
			case 'SIMPLESINGLEVIEW' :
				return $this->showSimpleSingle();
				break;
			case 'CATMENUVIEW' :
				return $this->showCatMenu();
				break;
			case 'AJAXSEARCHWITHMAP' :
				return $this->showAjaxSearchWithMap();
				break;
			default :
				//return $this->displayDefault();
		}

	}

	function showMessage() {
		if ($this->input == 'noStoresFound' || $this->input == 'noExactMatches' || $this->input == 'noOtherMatches')
			return '<div class="searchResultHeader">' . $this->pi_getLL($this->input) .
			'</div>';
		else
			if ($this->input[0] == 'serviceNotAvailable') {
				return '<div class="message">' . $this->pi_getLL($this->input[0]) .
				number_format($this->input[1], 1, ',', '.') . $this->pi_getLL('distanceToService') . '</div>';
			} else {
				$message = '<div class="message">';
				$message .= ($this->pi_getLL($this->input[0]) != '') ? $this->pi_getLL($this->input[0]) : $this->input[0];
				$message .= '</div>';
				return $message;
			}
		return;
	}

	function showFinder() {
		if ($this->conf['finderTemplate'] == 1)
			$subpart = $this->cObj->getSubpart($this->template, "###SHOPFINDER###");
		else
			$subpart = $this->cObj->getSubpart($this->template, "###RESTAURANTFINDER###");

		$marks = array ();
		if ($this->conf['resultPageId'])
			$marks['###ID###'] = $this->conf['resultPageId'];
		else
			$marks['###ID###'] = $GLOBALS['TSFE']->id;

		$marks['###SHOPNAME###'] = $this->pi_getLL('shopName');
		$marks['###BRANCH###'] = $this->pi_getLL('branch');
		$marks['###TRADEMARK###'] = $this->pi_getLL('trademark');
		$marks['###RESTAURANTNAME###'] = $this->pi_getLL('restaurantName');
		$marks['###CATEGORY###'] = $this->pi_getLL('category');
		$marks['###KITCHEN###'] = $this->pi_getLL('kitchen');

		for ($i = 0; $i < count($this->input['category']['uid']); $i++) {
			$marks['###CATEGORYV###'] .= '<option value="' . $this->input['category']['uid'][$i] . '">' .
			$this->input['category']['category'][$i] . '</option>';
		}

		for ($i = 0; $i < count($this->input['branch']['branch']); $i++) {
			$marks['###BRANCHV###'] .= '<option value="' . $this->input['branch']['branch'][$i] . '">' .
			$this->input['branch']['branch'][$i] . '</option>';
		}

		//debug($this->input);
		$urlParams = array (
			'tx_locator_pi1[mode]' => 'search',

		);
		if ($this->conf['resultPageId'])
			$marks['###ACTION###'] = $this->pi_getPageLink($this->conf['resultPageId'], '_top', $urlParams);
		else
			$marks['###ACTION###'] = $this->pi_getPageLink($GLOBALS['TSFE']->id, '_top', $urlParams);
		$out .= $this->cObj->substituteMarkerArray($subpart, $marks);
		return $out;
	}

	function showCatMenu() {
	
	}


	function showAjaxSearchWithMap() {
		$subpart = $this->cObj->getSubpart($this->template, "###AJAXSEARCHWITHMAP_TEMPLATE###");
		$GLOBALS['TSFE']->JSeventFuncCalls['onunload'][$this->pObj->prefixId] = 'GUnload();';

		$marks = array();
		$this->conf['_GP'] = $this->_GP;
		$this->conf['lang'] = $this->LLkey;
		$this->conf['pageId'] = "" . $GLOBALS['TSFE']->id; // needed for notepad view
	    $ajaxData = urlencode(json_encode($this->conf));
		$content .= '<div id="ajaxData" style="display: none;">' . $ajaxData . '</div>';
	
		$radius = explode(',', $this->conf['radiusPresets']);
		for ($i = 0; $i < count($radius); $i++) {
			$marks['###RADIUSPRESETSV###'] .= '<option value="' . $radius[$i] .'">' . $radius[$i] . '</option>';
		}

		$marks['###GOOGLELIBRARIES###'] = '&amp;libraries=' . $this->conf['apiV3Layers'];
		if (t3lib_div::inList($this->conf['apiV3Layers'], 'weather'))
			$marks['###SHOWWEATHERLAYER###'] = 1;
		else $marks['###SHOWWEATHERLAYER###'] = 0;	
		if (t3lib_div::inList($this->conf['apiV3Layers'], 'traffic'))
			$marks['###SHOWTRAFFICLAYER###'] = 1;
		else $marks['###SHOWTRAFFICLAYER###'] = 0;	
		if (t3lib_div::inList($this->conf['apiV3Layers'], 'bicycling'))
			$marks['###SHOWBICYCLINGLAYER###'] = 1;
		else $marks['###SHOWBICYCLINGLAYER###'] = 0;	
		if (t3lib_div::inList($this->conf['apiV3Layers'], 'panoramio'))
			$marks['###SHOWPANORAMIOLAYER###'] = 1;
		else $marks['###SHOWPANORAMIOLAYER###'] = 0;	

		for ($i = 0; $i < count($this->input['uid']); $i++) {
			$marks['###GROUPSV###'] .= '<div class="groupSelector"><input type="checkbox" value="' . $this->input['uid'][$i] . '"  onchange="getMarker();"/>'. $this->input['category'][$i] . '</div>';
		}
		$out .= $this->cObj->substituteMarkerArray($subpart, $marks);
		
		if ($this->conf['enable2LevelCategoryFilter']) {
			// takomat 16.05.2013
			$out .= '<script type="text/javascript">setTimeout("getAllMarkers();", 500);
				setTimeout("getCategoryFilter();", 500);
				$j("#tx_locatorSearch").css("display", "none");
				$j("#tx_locator_markers").css("visibility", "hidden");
				</script>';
		}
		
		return $out . $content;
	
	}

	function getNotepadJS() {
           $GLOBALS["TSFE"]->additionalHeaderData['tx_locaor_pi1_catMenuJS'] .=
            '<script type="text/javascript">
            /*<![CDATA[*/
            /*]]>*/
            </script>
				<link href="http://ajax.googleapis.com/ajax/libs/jqueryui/1.8/themes/base/jquery-ui.css" rel="stylesheet" type="text/css"/>
<!--
				<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.5/jquery.min.js"></script>
-->
	            <script type="text/javascript" src="typo3conf/ext/locator/pi1/scripts/jquery-1.7.1.min.js"></script>
				<script src="http://ajax.googleapis.com/ajax/libs/jqueryui/1.8/jquery-ui.min.js"></script>

			<script type="text/javascript">
            /*<![CDATA[*/
                var $j = jQuery.noConflict();
				

				function tx_locator_submit(elementId, value, ajaxData, action, pw) {
				var mode = value;

				$j.ajax({
					type: "POST",
					url: "index.php?eID=tx_locator_eID",
					data: {
                        "ref": value,
                        "data": ajaxData,
                        "tx_locator_pi1[action]": action,
                        "tx_locator_pi1[day]": value,
                        "tx_locator_pi1[pw]": pw
					}
				}).done(function(msg) {
//						$j(elementId).html(msg);
						if (action == "getStorename" && pw =="remove") {
							msg = msg + "<br />' . $this->pi_getLL('removedFromNotepad') .'";
						}
						if (action == "getStorename" && pw =="add") {
							msg = msg + "<br />' . $this->pi_getLL('addedToNotepad') .'";
						}
						$j(elementId).effect("slide", function() {
						}).html(msg);
						
					});

				}


				function getData() {
					var ajaxData = $j("#ajaxData").html();
					tx_locator_submit("#mapAllList", 1, ajaxData, "getMapList", 0);
				}

				function getStorename(uid, mode) {
					var ajaxData = $j("#ajaxData").html();
					tx_locator_submit("#mapAllListMessage", uid, ajaxData, "getStorename", mode);
				}

				var notepadStoreUids = new Array();
				var uids = "";

				function addToCookie(storeUid, storename) {
					uids = "";
					var presentUids = getCookie("notepadStoreUids");// +"";
					
					if (presentUids == false) {
						uids = storeUid;
					}
					else {uids = presentUids + "," + storeUid;}
					var time = new Date();
					time = new Date(time.getTime() + 1000 * ' . $this->conf['cookieLifeTime'] . '); //*60*24);
					document.cookie = "notepadStoreUids=" + uids + ";expires=" + time.toGMTString() + "; path=/";
					$j("#markstate" + storeUid).css("display", "none");
					$j("#unmarkstate" + storeUid).css("display", "block");
					$j("#infoWindowMarkstate" + storeUid).css("display", "none");
					$j("#infoWindowUnMarkstate" + storeUid).css("display", "block");
					if (!storename) {getStorename(storeUid, "add");}
					else {
					//storename = $j("#mapAllListStorename").html();

					$j("#mapAllListMessage").effect("slide", function() {
					})
					.html(storename + "<br />' . $this->pi_getLL('addedToNotepad') . '");
					}
//alert($j("#infoWindowUnMarkstate" + storeUid).css("display"));
				}

				function getCookie(cookieName)
				{
				    var strValue = false;
				    if( strCookie = document.cookie )
				        {
				            if( arrCookie = strCookie.match( new RegExp(cookieName + "=([^;]*)", "g")))
				                {
				                    strValue=RegExp.$1;
				                }
				        }
				    return(strValue);
				}

				function removeFromCookie(storeUid, storename) {
					var arr = new Array();
					var storeUids = getCookie("notepadStoreUids") +"";
					var uidsArray = storeUids.split(",");
					for (i = 0; i < uidsArray.length; i++) {
						if (storeUid != uidsArray[i]) {
							arr.push(uidsArray[i]);
						}
					}
					var myUids = "";
					for (i = 0; i < arr.length; i++) {
						if (i > 0) {
							myUids = myUids + "," + arr[i];
						}
						else { myUids = arr[i]; }
					}
					var time = new Date();
					time = new Date(time.getTime() + 1000 * ' . $this->conf['cookieLifeTime'] . '); //*60*24);
					document.cookie = "notepadStoreUids=" + myUids + ";expires=" + time.toGMTString() + "; path=/";
					$j("#markstate" + storeUid).css("display", "block");
					$j("#unmarkstate" + storeUid).css("display", "none");
					$j("#infoWindowMarkstate" + storeUid).css("display", "block");
					$j("#infoWindowUnMarkstate" + storeUid).css("display", "none");
					if (!storename) {getStorename(storeUid, "remove");}
					else {
						$j("#mapAllListMessage").effect("slide", function() {
						}).html(storename + "<br />' . $this->pi_getLL('removedFromNotepad') . '");
					}
					//getData();
				}

				function setNotepadState(uid) {
					var storeUids = getCookie("notepadStoreUids") +"";
					var uidsArray = storeUids.split(",");
					$j("#infoWindowMarkstate" + uid).css("display", "block");
					$j("#infoWindowUnMarkstate" + uid).css("display", "none");
					for (i = 0; i < uidsArray.length; i++) {
						if (uid == uidsArray[i]) {
						$j("#infoWindowMarkstate" + uid).css("display", "none");
						$j("#infoWindowUnMarkstate" + uid).css("display", "block");
						}
					}
				
				}

				$j(document).ready(function(){
				////////////////////////////////
				//$j("#mapAllList").html("hhhhhhhh");
					getData();
				});


            /*]]>*/
			</script>';
	}


	function showForm() {
//debug($this->conf);
		if ($this->conf['usejQuery'] && $this->conf['includejQuery']) {
           $GLOBALS["TSFE"]->additionalHeaderData['tx_locaor_pi1_showForm'] .=
            '<script type="text/javascript">
            /*<![CDATA[*/
            /*]]>*/
            </script>
				<link href="http://ajax.googleapis.com/ajax/libs/jqueryui/1.8/themes/base/jquery-ui.css" rel="stylesheet" type="text/css"/>
<!--
				<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.5/jquery.min.js"></script>
-->
	            <script type="text/javascript" src="typo3conf/ext/locator/pi1/scripts/jquery-1.7.1.min.js"></script>
				<script src="http://ajax.googleapis.com/ajax/libs/jqueryui/1.8/jquery-ui.min.js"></script>

			<script type="text/javascript">
            /*<![CDATA[*/
            /*]]>*/
			</script>';

		}



		if ($this->conf['usejQuery']) {
           $GLOBALS["TSFE"]->additionalHeaderData['tx_locator_pi1_showForm'] .=
            '<script type="text/javascript">
            /*<![CDATA[*/
                var $j = jQuery.noConflict();

  	$j(document).ready(function(){
		$j("#tx_locator_pi1_searchField").autocomplete({
			source: "index.php?eID=tx_locator_eID&tx_locator_pi1[action]=searchAddress&tx_locator_pi1[pid]=' . $this->conf['pid_list'] . '&tx_locator_pi1[lang] =' . $this->LLkey . '",
			minLength: 3,
//			autoFocus: true,

//			search: function(event, ui)  {
//				$j("#tx_locator_pi1_searchField").val(function(index, value) {
//					  return "";
//				})
//			},
			select: function( event, ui ) {
				$j("#tx_locator_pi1_searchField").val(function(index, value) {

					var latlon = ui.item.latlon.split(",")
					$j("#tx_locator_pi1_lat").val(latlon[0]);
					$j("#tx_locator_pi1_lon").val(latlon[1]);
	
					getMap();
	//				document.forms.locator.submit();
					  return ui.item.uid;
				});

   			}
		});
	});


	function getMap() {
		var url     = "index.php?eID=tx_locator_eID";
		var params  = {"tx_locator_pi1[action]": "getMap",
			"tx_locator_pi1[lat]": $j("#tx_locator_pi1_lat").val(),
			"tx_locator_pi1[lon]": $j("#tx_locator_pi1_lon").val(),
			"tx_locator_pi1[categories]": $j("#tx_locator_pi1_categories").val(),
			"tx_locator_pi1[radius]": 100,
			"tx_locator_pi1[pid]": "' . $this->conf['pid_list'].'",
			"tx_locator_pi1[pageUid]": "' . $GLOBALS['TSFE']->id . '",
   			"tx_locator_pi1[jsonData]":"' .  urlencode(json_encode($this->conf)) .'",
			"tx_locator_pi1[lang]": "' . $this->LLkey .'"};


		var myAjax = new $j.ajax({
		    url:url,
		    method: "post",
		    data: params,
		    success: function(responseText) { // no default update element, we do it manually
		        $j("#tx_locator_pi1_map").html(responseText);
		    }, // success
		    complete: function (text) {
		    }
		});



	}
    /*]]>*/
	</script>';

	}




		$_EXTKEY = 'locator';
		require_once (PATH_site . '/typo3conf/ext/locator/ext_emconf.php');
		$version = $EM_CONF['locator']['title'] . '\n' . $EM_CONF['locator']['version'] .
		'\n' . $EM_CONF['locator']['author'] . '\n' . $EM_CONF['locator']['author_email'];

		if ($this->conf['resultPageId'])
			$marks['###FORMSTART###'] = '<form id="locator_form" name="locator" method="post" action="' . $this->pi_getPageLink($this->conf['resultPageId']) . '">';
		else
			$marks['###FORMSTART###'] = '<form id="locator_form" name="locator" method="post" action="' . $this->pi_getPageLink($GLOBALS['TSFE']->id) . '">';

		if ($this->conf['displayMode'] != 'autoMailView') {
//			$GLOBALS["TSFE"]->additionalHeaderData['tx_locator_pi1_customer'] = '<script type="text/javascript">
			$js = '<script type="text/javascript">
			                /*<![CDATA[*/
			                var message = "' .
			$this->pi_getLL("pleaseFillInRequiredData") . ' ";
							var labels = new Object();
							labels["tx_locator_pi1_city"] = "' . $this->pi_getLL("city_label") . '";
							labels["tx_locator_pi1_zipcode"] = "' . $this->pi_getLL("zip_label") . '";
							labels["tx_locator_pi1_storename"] = "' . $this->pi_getLL("storename_label") . '";
			                
			                
			                function checkFields(fields)    {
			                    fields = fields.split(",");
			                    id = fields;
			                    if (document.getElementById("tx_locator_pi1_storename").value == "") {
			                        for (i = 0; i < fields.length; i++) {
			                            id = fields[i];
			                            if ( document.getElementById(id).value == "" &&
			                                    document.getElementById("tx_locator_pi1_zipcode").value == "" &&
			                                    document.getElementById("tx_locator_pi1_lat").value == "" &&
			                                    document.getElementById("tx_locator_pi1_lon").value == "") {
			                                alert(message + labels[id] + "!");
			                                return false;
			                            }
			                        }
			                    }
			                    document.forms.locator.submit();
			                }

			                categories = new Array();

			                function categorySelect(uid) {
			//                    alert(uid);
			                    elem = document.getElementById("tx_mhtreeview-node_" + uid);
			                    if (elem.className == "selectedCategory") {
			                        elem.className = "";
			                        for(i=0; i < categories.length; i++) {
			                            if (categories[i] == uid) {
			                                categories.splice(i,1);
			                            }
			                        }
			                    }
			                    else {
			                        elem.className = "selectedCategory";
			                    	categories.push(uid);
			                    }
			                    document.getElementById("tx_locator_pi1_categories").value = categories;
			                }

			                function keyReleased (event) {
			                    if (!event) event = window.event
			                    var key = event.keyCode || event.which;
			                    // window.status = key;
			                    //alert(key);
			                    // ctrl m
			                    if (key == 77 && event.ctrlKey) {
			                        alert("' . $version . '");
			                    }

			                }
			                document.onkeyup = keyReleased;


			                /*]]>*/
			                </script>';

			if (is_array($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['modifyJsHook'])) {
				foreach ($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['modifyJsHook'] as $_classRef) {
					$_procObj = & t3lib_div :: getUserObj($_classRef);
					$js = $_procObj->jsProcessor($js, $this);
				}
			}							
			$GLOBALS["TSFE"]->additionalHeaderData['tx_locator_pi1_customer'] = $js;

		}



		if ($this->conf['displayMode'] != 'autoMailView') {
			if ($this->conf['usejQuery'])
				$subpart = $this->cObj->getSubpart($this->template, "###AJAXSEARCH_TEMPLATE###");
			else
				$subpart = $this->cObj->getSubpart($this->template, "###STARTINGPOINT_TEMPLATE###");

			$marks['###FORMHEADER###'] = $this->pi_getLL('formHeader');

			$marks['###FIRSTNAME###'] = '';
			$marks['###FIRSTNAMEV###'] = '';
			$marks['###SURNAME###'] = '';
			$marks['###SURNAMEV###'] = '';

			$marks['###HELPICON###'] = '';
			if ($this->conf['helpPageId']) {
				$marks['###HELPICON###'] = '<a href="' . $this->cObj->getTypoLink_URL($this->conf['helpPageId']) . '" target="_blank"> ' .
				'<img src="typo3conf/ext/locator/pi1/res/helpbubble.gif" alt="' . $this->pi_getLL('searchHelp') . '" title="' . $this->pi_getLL('searchHelp') . '"/></a>';

			}
			$marks['###CATEGORY###'] = '';
			$marks['###CATEGORYV###'] = '';
			if (!($this->conf['useFeUserData'] == 1)) {
				$marks['###CATEGORY###'] = '<td class="selectCategory">' . $this->pi_getLL('categories_label') . '</td>';
				$marks['###CATEGORYV###'] = '<td class="selectCategory"><select name="tx_locator_pi1[categories][]" multiple="multiple"
				                                            style="width:200px;height:50px" class="selectCategory">';

				$categoryList = $this->model->get_categories();
				/*                  foreach ($categories_list AS $cat) {
				                      $cat = trim($cat);
				                      $marks['###CATEGORYV###'] .= "<option>".$cat."</option>";
				                }
				*/
				for ($i = 0; $i < count($categoryList['uid']); $i++) {
					$marks['###CATEGORYV###'] .= '<option value="' . $categoryList['uid'][$i] . '">' .
					$categoryList['category'][$i] . '</option>';
				}

				$marks['###CATEGORYV###'] .= '</select></td></tr>';
			}

			$marks['###HIDDEN###'] = '<input type="hidden" name="tx_locator_pi1[mode]" value="search"/>';
		}
		// language
		//debug($GLOBALS['TSFE']->config['config']['sys_language_uid']);

		$marks['###STORENAME###'] = $this->pi_getLL('storename_label');
		$marks['###STORENAMEV###'] = '<input type="text" id="tx_locator_pi1_storename" name="tx_locator_pi1[storename]" value="' . $this->_GP['storename'] . '"/>';

		$marks['###ZIPCODE###'] = $this->pi_getLL('zip_label');
		$marks['###ZIPCODEV###'] = '<input type="text" id="tx_locator_pi1_zipcode" name="tx_locator_pi1[zipcode]" value="' . $this->_GP['zipcode'] . '"/>';

		$marks['###ADDRESS###'] = $this->pi_getLL('street_label');
		$marks['###ADDRESSV###'] = '<input type="text" id="address" name="tx_locator_pi1[address]" value="' . $this->_GP['address'] . '"/>';
		$marks['###CITY###'] = $this->pi_getLL('city_label');
		$marks['###CITYV###'] = '<input type="text" id="tx_locator_pi1_city" name="tx_locator_pi1[city]" value="' . $this->_GP['city'] . '"/>';
		$marks['###COUNTRY###'] = $this->pi_getLL('country_label');
		$marks['###COUNTRYV###'] = '<select id="tx_locator_pi1_country" name="tx_locator_pi1[country]" class="selectCountry">';
		if ($this->conf['useFeUserData'] == 0) {
			$marks['###PRODUCTS###'] = $this->pi_getLL('products');
			$marks['###PRODUCTSV###'] = '<input type="text" id="tx_locator_pi1_products" name="tx_locator_pi1[products]" value="' . $this->_GP['zipcode'] . '"/>';
		} else {
			$marks['###PRODUCTS###'] = '';
			$marks['###PRODUCTSV###'] = '';
		}

		$country_array = explode(',', $this->conf['countryCodes']);

		// get all fieldnames of static_countries
		// and check for cn_short_xx
		$result = $GLOBALS['TYPO3_DB']->admin_get_fields('static_countries');
		$lang = false;
		while (list ($k, $v) = each($result)) {
			if ($k == 'cn_short_' . $GLOBALS['TSFE']->config['config']['language'])
				$lang = true;
		}
		if ($lang)
			$fields = 'cn_short_' . $GLOBALS['TSFE']->config['config']['language'] . ' AS country';
		else
			$fields = 'cn_short_en' . ' AS country';

		$fields .= ', cn_short_en AS country_en';
		foreach ($country_array AS $country_iso) {
			$where_clause = ' cn_iso_2 = "' . $country_iso . '"';
			$orderBy = '';
			$result = $GLOBALS['TYPO3_DB']->exec_SELECTquery($fields, 'static_countries', $where_clause, '', $orderBy);
			$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($result);
			if ($row['country'])
				$marks['###COUNTRYV###'] .= '<option value="' . $country_iso . '">' . $row['country'] . '</option>';
			else $marks['###COUNTRYV###'] .= '<option value="' . $country_iso . '">' . $row['country_en'] . '</option>';
		}
		$marks['###COUNTRYV###'] .= "</select>";
		$marks['###RADIUS###'] = $this->pi_getLL('radius_label');
		$marks['###RADIUSV###'] = '<select name="tx_locator_pi1[radius]">';
		$radius_array = explode(',', $this->conf['radiusPresets']);
		foreach ($radius_array AS $radius) {
			$marks['###RADIUSV###'] .= "<option>" . $radius . "</option>";
		}
		$marks['###RADIUSV###'] .= '</select>';
		$marks['###RADIUSUNIT###'] = $this->pi_getLL($this->conf['distanceUnit']);

		$marks['###SUBMITBUTTONLABEL###'] = htmlspecialchars($this->pi_getLL('submit_button_label'));
		$marks['###ONCLICK###'] .= 'onclick="checkFields(\'tx_locator_pi1_city\');" name="tx_locator_pi1[submit]"';

		$marks['###STORESEARCH###'] .= $this->pi_getLL('storeSearch');

		$marks['###LONGITUDE###'] .= $this->pi_getLL('longitude');
		$marks['###LATITUDE###'] .= $this->pi_getLL('latitude');
		$marks['###LONGITUDEV###'] .= '<input type="text" id="tx_locator_pi1_lon" name="tx_locator_pi1[lon]" value="' . $this->_GP['longitude'] . '"/>';
		$marks['###LATITUDEV###'] .= '<input type="text" id="tx_locator_pi1_lat" name="tx_locator_pi1[lat]" value="' . $this->_GP['latitude'] . '"/>';

		if ($this->conf['useFeUserData'] == 0 || $this->conf['useFeUserData'] == 3) {
			require_once (t3lib_extMgm :: extPath('mh_treeview') . 'lib/class.tx_mhtreeview.php');
			$treeview = t3lib_div :: makeInstance('tx_mhtreeview');
			$content = array (
				'uid',
				'name'
			);
			$expandAll = 0;
			$expandFirst = 1;
			$categories = array (
				'kkk'
			);

			// WWF for local and global categories
			if ($this->conf['categoryPidList'])
				$this->conf['pid_list'] .= ',' . $this->conf['categoryPidList'];

			if ($GLOBALS['TSFE']->config['config']['sys_language_uid'] == '')
				$GLOBALS['TSFE']->config['config']['sys_language_uid'] = 0;
			$conf = array (
				'JS_Func' => 'categorySelect',
				'JS_Event' => 'onclick',
				'JS_Input' => 'uid',
				'active_id' => $categories,
				'orderBy' => 'name',
				//                'select_where' => ' AND pid in (' . $this->conf['pid_list'] . ')',
				'select_where' => ' AND ' . $GLOBALS['TSFE']->config['config']['sys_language_uid'] . '=sys_language_uid AND pid in (' . $this->conf['pid_list'] . ')',
					//'dontLinkMainNode' => 1,

			);

			//global $TSFE;
			//debug($TSFE->config['config']['sys_language_uid'], 'view showForm');
			if ($this->conf['useFeUserData'] == 0)
				$treeview->init('tx_locator_categories', 'parentuid', 'Kategorien', $content, $conf, $expandAll, $expandFirst);
			// for tt_news
			if ($this->conf['useFeUserData'] == 3) {
				$content = array (
					'uid',
					'title'
				);
				$conf['select_where'] = '';
				$conf['orderBy'] = 'title';
				$treeview->init('tt_news_cat', 'parent_category', 'Kategorien', $content, $conf, $expandAll, $expandFirst);

			}

			$marks['###CATEGORYV###'] = '<td class="treeview">' . $treeview->getTree() . '</td>';
		}
		// tt_address
		if ($this->conf['useFeUserData'] == 4) {
			require_once (t3lib_extMgm :: extPath('mh_treeview') . 'lib/class.tx_mhtreeview.php');
			$treeview = t3lib_div :: makeInstance('tx_mhtreeview');
			$content = array (
				'uid',
				'title'
			);
			$expandAll = 0;
			$expandFirst = 1;
			$categories = array (
				'kkk'
			);

			$select = ' AND pid in (' . $this->conf['pid_list'] . ')';
			if ($this->conf['tt_addressAllowedGroups'])
				$select .= ' AND uid in (' . $this->conf['tt_addressAllowedGroups'] . ')';
			if ($this->conf['tt_addressNotAllowedGroups'])
				$select .= ' AND uid not in (' . $this->conf['tt_addressNotAllowedGroups'] . ')';
			$conf = array (
				'JS_Func' => 'categorySelect',
				'JS_Event' => 'onclick',
				'JS_Input' => 'uid',
				'active_id' => $categories,
				'orderBy' => 'title',
					//                'select_where' => ' AND pid in (' . $this->conf['pid_list'] .')';
				'select_where' => $select,
					//'dontLinkMainNode' => 1,

			);

			$treeview->init('tt_address_group', 'parent_group', 'Kategorien', $content, $conf, $expandAll, $expandFirst);
			$marks['###CATEGORYV###'] = '<td class="treeview">' . $treeview->getTree() . '</td>';
		}


		if (is_array($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerFormViewHook'])) {
			foreach ($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerFormViewHook'] as $_classRef) {
				$_procObj = & t3lib_div :: getUserObj($_classRef);
				$marks = $_procObj->extraItemMarkerFormViewProcessor($marks, $this);
			}
		}

		$final .= $this->cObj->substituteMarkerArray($subpart, $marks);

		return $final;
	}

	function listView() {
		$marks = array ();
		if ($this->_GP['exactSearch']) {
			$subpart = $this->cObj->getSubpart($this->template, "###LISTVIEWEXACT_HEADER###");
			$marks['###EXACTMATCHES###'] = $this->pi_getLL('exactMatches');
			$marks['###OTHERMATCHES###'] = $this->pi_getLL('otherMatches');
		} else {
			$subpart = $this->cObj->getSubpart($this->template, "###LISTVIEW_HEADER###");
			$marks['###EXACTMATCHES###'] = '';
		}
		if ($this->_GP['trademark'])
			$marks['###OTHERMATCHES###'] = $this->pi_getLL('otherMatches');
		else $marks['###OTHERMATCHES###'] = '';
		if ($this->input['categoryName'] > '') {
			$marks['###CATEGORYV###'] = $this->input['categoryName'];
		} else
			$marks['###CATEGORYV###'] = '';
		$final .= $this->cObj->substituteMarkerArray($subpart, $marks);



		$flexLinkSubpart = $this->cObj->getSubpart($this->template, "###FLEXLINK###");


		for ($i = 0; $i < count($this->input['uid']); $i++) {
			if ($i % 2 == 0)
				$marks['###ODD###'] = 'class="even"';
			else
				$marks['###ODD###'] = 'class="odd"';

			if ($this->_GP['exactSearch'])
				$subpart = $this->cObj->getSubpart($this->template, "###LISTVIEWEXACT_DATA###");
			else $subpart = $this->cObj->getSubpart($this->template, "###LISTVIEW_DATA###");
			if ($this->input['url'][$i]) {
				if (strpos($this->input['url'][$i], 'ttp://') != 1)
					$this->input['url'][$i] = 'http://' . $this->input['url'][$i];
				$marks['###STORENAMEV###'] = '<a href="' . $this->input['url'][$i] . '" target="_blank">' . $this->input['storename'][$i] . '</a>';
			} else
				$marks['###STORENAMEV###'] = $this->input['storename'][$i];


			// link to single view
			$_urlParams = array (
				'tx_locator_pi1[storeUid]' => $this->input['uid'][$i],
			);
			$marks['###STORENAMEV###'] = $this->pi_linkToPage($this->input['storename'][$i], $this->conf['resultPageId'], '', $_urlParams);

			if ($this->input['image'][$i] > '') {
				if ($this->conf['useFeUserData'] == 3) {
					$images = explode(',', $this->input['image'][$i]);
					$this->conf['listView.']['image.']['file'] = 'uploads/pics/' . $images[0];
				}
				else $this->conf['listView.']['image.']['file'] = 'uploads/tx_locator/' . $this->input['image'][$i];
				$marks['###IMAGEV###'] = $this->cObj->IMAGE($this->conf['listView.']['image.']);
			} else
				$marks['###IMAGEV###'] = '';
			$marks['###UID###'] = $this->input['uid'][$i];
			$marks['###STOREIDV###'] = $this->input['storeid'][$i];
			$marks['###PURESTORENAMEV###'] = $this->input['storename'][$i];
			$marks['###CATEGORYV###'] = $this->input['category'][$i];
			$marks['###ADDRESSV###'] = $this->input['address'][$i];
			$marks['###ADDITIONALADDRESSV###'] = $this->input['additionalAddress'][$i];
			$marks['###ZIPCODEV###'] = $this->input['zipcode'][$i];
			$marks['###CITYV###'] = $this->input['city'][$i];
			$marks['###COUNTRYV###'] = $this->input['country'][$i];
			$marks['###CONTACTPERSONV###'] = $this->input['contactPerson'][$i];
			$marks['###HOURSV###'] = $this->input['hours'][$i];
			$marks['###PHONEV###'] = $this->input['phone'][$i];
			$marks['###MOBILEV###'] = $this->input['mobile'][$i];
			$marks['###FAXV###'] = $this->input['fax'][$i];
			$marks['###URLV###'] = $this->input['url'][$i];
			$marks['###EMAILV###'] = $this->cObj->getTypoLink($this->input['email'][$i], $this->input['email'][$i]);
			$marks['###NOTESV###'] = $this->input['notes'][$i];
			$marks['###ATTRIBUTESV###'] = $this->input['attributes'][$i];

			if ($this->conf['resultPageId']) $pageId = $this->conf['resultPageId'];
			else $pageId = $GLOBALS['TSFE']->id;

			$marks['###FORM###'] = '<form method="post" action="' . $this->pi_getPageLink($pageId) . '">';
			$marks['###HIDDEN###'] = '<input type="hidden" name="tx_locator_pi1[mode]" value="listView"/>' .
			'<input type="hidden" name="tx_locator_pi1[storeUid]" value="' . $this->input['uid'][$i] . '"/>';
			$marks['###BUTTON###'] = '<input type="submit" value="' . $this->pi_getLL('showMap') . '"/>';

//debug($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']);

			if (is_array($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerListViewHook'])) {
				foreach ($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerListViewHook'] as $_classRef) {
					$_procObj = & t3lib_div :: getUserObj($_classRef);
					$marks = $_procObj->extraItemMarkerListViewProcessor($marks, $this->input, $this->conf, $this);
				}
			}

			// flexLink
			if ($this->input['storeid'][$i]) 
			$marks['###FLEXLINKV###'] = $this->cObj->substituteMarkerArray($flexLinkSubpart, $marks);
			else
			$marks['###FLEXLINKV###'] = $this->cObj->substituteMarkerArray('###FORM###' . $marks['###HIDDEN###'] . $marks['###BUTTON###'] .'</form>', $marks);



			$final .= $this->cObj->substituteMarkerArray($subpart, $marks);
		}

		if ($this->_GP['exactSearch'])
			$subpart = $this->cObj->getSubpart($this->template, "###LISTVIEWEXACT_FOOTER###");
		else $subpart = $this->cObj->getSubpart($this->template, "###LISTVIEW_FOOTER###");
		$final .= $this->cObj->substituteMarkerArray($subpart, $marks);
		return $final;
	}

	function showSimpleSingle() {
		$subpart = $this->cObj->getSubpart($this->template, "###MYSTORE_TEMPLATE###");
		$marks = array ();
		$marks['###STORENAMEV###'] = $this->pi_linkToPage(stripslashes(stripslashes($this->_GP['storename'])), $this->conf['resultPageId']);
		$marks['###CITYV###'] = $this->pi_linkToPage($this->_GP['city'], $this->conf['resultPageId']);
		$marks['###ZIPCODEV###'] = $this->pi_linkToPage($this->_GP['zipcode'], $this->conf['resultPageId']);
		$marks['###ADDRESSV###'] = $this->pi_linkToPage($this->_GP['address'], $this->conf['resultPageId']);
		$marks['###PHONEV###'] = $this->pi_linkToPage($this->_GP['phone'], $this->conf['resultPageId']);
		$out .= $this->cObj->substituteMarkerArray($subpart, $marks);
		return $out;

	}

	function countrySelectorView() {
		$out = '<ul class="countrySelector">';
		if ($this->conf['resultPageId'])
			$pageUid = $this->conf['resultPageId'];
		else
			$pageUid = $GLOBALS['TSFE']->id;

		for ($i = 0; $i < count($this->input['country']); $i++) {
			$urlParams = array (
				'tx_locator_pi1[country]' => $this->input['country'][$i],

			);
			if ($this->input['country'][$i] > '') {
				if ($this->pi_getLL($this->input['country'][$i])) {
					if ($i % 2)
						$out .= '<li class="even">' . $this->pi_linkToPage($this->pi_getLL($this->input['country'][$i]), $pageUid, '_top', $urlParams) . '</li>';
					else
						$out .= '<li class="odd">' . $this->pi_linkToPage($this->pi_getLL($this->input['country'][$i]), $pageUid, '_top', $urlParams) . '</li>';
				} else {
					if ($i % 2)
						$out .= '<li class="even">' . $this->pi_linkToPage($this->input['country'][$i], $pageUid, '_top', $urlParams) . '</li>';
					else
						$out .= '<li class="odd">' . $this->pi_linkToPage($this->input['country'][$i], $pageUid, '_top', $urlParams) . '</li>';
				}
			}
		}
		$out .= '</ul>';
		$marks['###COUNTRYSELECTORV###'] = $out;
		$template = $this->cObj->getSubpart($this->template, "###COUNTRYSELECTOR###");
		$final .= $this->cObj->substituteMarkerArray($template, $marks);
		return $final;
	}

	function citySelectorView() {
		$out = '<ul class="citySelector">';
		if ($this->conf['resultPageId'])
			$pageUid = $this->conf['resultPageId'];
		else
			$pageUid = $GLOBALS['TSFE']->id;

		for ($i = 0; $i < count($this->input['city']); $i++) {
			if ($this->input['city'][$i] > '') {
				$urlParams = array (
					'tx_locator_pi1[country]' => $this->_GP['country'],
					'tx_locator_pi1[city]' => $this->input['city'][$i],
					'tx_locator_pi1[storeUid]' => $this->input['storeUid'][$i],

				);
				if ($i % 2)
					$out .= '<li class="even">' . $this->pi_linkToPage($this->input['city'][$i], $pageUid, '_top', $urlParams) . '</li>';
				else
					$out .= '<li class="odd">' . $this->pi_linkToPage($this->input['city'][$i], $pageUid, '_top', $urlParams) . '</li>';
			}
		}
		$out .= '</ul>';
		$marks['###CITYSELECTORV###'] = $out;
		$template = $this->cObj->getSubpart($this->template, "###CITYSELECTOR###");
		$final .= $this->cObj->substituteMarkerArray($template, $marks);
		return $final;
	}

	function showStores() {
		//debug($this->_GP, 'showStores');
		//debug($this->conf);

		$mysqlResults = $this->input['mysql'];

		$center_lat_lon = $this->input['center'];
		$center_lat = $center_lat_lon->lat;
		$center_lon = $center_lat_lon->lon;
		$center_lat_float = floatval($center_lat);
		$center_lon_float = floatval($center_lon);
		//        $content .= '<div id="results" class="tx_locator_results">';

		$HTTP_POST_VARS['lat_lon'] = $center_lat_lon;

		$this->_GP['lat_lon'] = $center_lat_lon;
		if ($this->conf['showResultTable']) {


		$flexLinkSubpart = $this->cObj->getSubpart($this->template, "###FLEXLINK###");

// 09.05.2013 is_object 
			if ((!is_object($mysqlResults) && !is_resource($mysqlResults)) || $mysqlResults == null) {

				$marksHeader['###TITLE###'] = '<div class="searchResultHeader">' . $this->pi_getLL('theSearchFrom') .
				$this->_GP['numberOfStores'] .
				//$this->pi_getLL('stores') .
				$this->conf['storeTitle'] .
				$this->pi_getLL('inRadius') .
				$this->_GP['radius'] . ' ' . $this->pi_getLL($this->conf['distanceUnit']) . ' ' . $this->pi_getLL('gaveNoResults') . '</div>';
				$marksHeader['###SEARCHRESULT_HEADER###'] = $this->pi_getLL('formHeader');
				$subpart = $this->cObj->getSubpart($this->template, "###SEARCHRESULT_HEADER###");
				$final .= $this->cObj->substituteMarkerArray($subpart, $marksHeader);
			} else {
				//                   $marksHeader['###TITLE###'] = $this->pi_getLL('searchFor') .'&nbsp;' . $this->_GP['address'].'&nbsp;' . $this->_GP['zipcode'].
				//                      '&nbsp;' . $this->_GP['city'] . " (" . $this->_GP['country'] . ")";

				$marksHeader['###TITLE###'] = $this->pi_getLL('searchFor') . '&nbsp;';
				if ($this->_GP['address'] != '') {
					$marksHeader['###TITLE###'] .= $this->_GP['address'] . '&nbsp;';
				}
				if ($this->_GP['zipcode'] != '') {
					$marksHeader['###TITLE###'] .= $this->_GP['zipcode'] . '&nbsp;';
				}
				if ($this->_GP['city'] != '') {
					$marksHeader['###TITLE###'] .= $this->_GP['city'] . '&nbsp;';
				}
				$marksHeader['###TITLE###'] .= "(" . $this->_GP['country'] . ")";

//				while ($rows = mysql_fetch_array($mysqlResults)) {
//					$counter++;
//				}

				
// 10.05.2013				
				while ($rows = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($mysqlResults)) {
					$counter++;
				}
				$GLOBALS['TYPO3_DB']->sql_data_seek($mysqlResults, 0);

				$marksHeader['###TITLE###'] .= '&nbsp;' . $this->pi_getLL('gave') . '&nbsp;' . $counter . '&nbsp;' . $this->pi_getLL('results');

				if ($this->conf['showPoiTable'] == 0) { // no searchresult_header with POI table
					$subpart = $this->cObj->getSubpart($this->template, "###SEARCHRESULT_HEADER###");
					$final .= $this->cObj->substituteMarkerArray($subpart, $marksHeader);
				}
				$counter = 0;

				$GLOBALS["TSFE"]->additionalHeaderData['tx_locator_pi1_multiRoute'] = '<script type="text/javascript">
				                    /*<![CDATA[*/
				                    var routePoints = 0;
				                    function addToRoute(address, buttonId)    {
				                        //alert(address +" " +buttonId);
				                        if (routePoints == 0) {
				                            document.getElementById("multiRouteAddresses").value = "";
				                         }
				                        addresses = document.getElementById("multiRouteAddresses").value;
				                        //alert(addresses);
				                        pos = addresses.indexOf(address);
				                        if (addresses.length > 0 && addresses.indexOf(address) != -1) {
				                            pos = addresses.indexOf(address);
				                            new1 =    addresses.substring(0,pos);
				                            new2 =    addresses.substring(pos + address.length + 1);
				                            addresses = new1 + new2;
				                            //alert("nach replaced" + addresses);
				                            routePoints--;
				                            document.getElementById(buttonId).className="viaButtonUnselected";                        }
				                        if ( pos == -1 ) {
				                            addresses = addresses + address + ":";
				                            routePoints++;
				                            document.getElementById(buttonId).className="viaButtonSelected";
				                        }
				                        if (routePoints == 23) {
				                            alert("Only 25 points inclusive startingpoint and endpoint allowed!");
				                            return;
				                        }
				                        document.getElementById("multiRouteAddresses").value = addresses;

				                        if ( routePoints > 0 ) {
				                            document.getElementById("tx_locator_pi1_multiRoute").disabled = false;
				                        } else {
				                            document.getElementById("tx_locator_pi1_multiRoute").disabled = true;
				                        }
				                    }
				                    /*]]>*/
				                    </script>';

				//                while ($rows = mysql_fetch_array($mysqlResults)) {

				while ($rows = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($mysqlResults)) {
					$counter++;
					$uid = $rows['storeuid'];
					$uid = $rows['uid'];
					$lat = $rows['lat'];
					$lon = $rows['lon'];
					$address = htmlspecialchars($rows['address']);
					$additionalAddress = htmlspecialchars($rows['additionaladdress']);
					$contactPerson = htmlspecialchars($rows['contactperson']);
					$city = htmlspecialchars($rows['city']);
					$state = htmlspecialchars($rows['state']);
					$zipcode = htmlspecialchars($rows['zipcode']);
					$country = htmlspecialchars($rows['country']);
					$storename = htmlspecialchars($rows['storename']);

					$firstName = htmlspecialchars($rows['first_name']);
					$lastName = htmlspecialchars($rows['last_name']);

					$storeId = htmlspecialchars($rows['storeid']);
					$attributes = htmlspecialchars($rows['attributes']);

					if ($this->conf['useFeUserData'] == 4)
						$category = htmlspecialchars($rows['category']);
					else
						$category = htmlspecialchars($rows['name']);

					$phone = htmlspecialchars($rows['phone']);
					$fax = htmlspecialchars($rows['fax']);
					$mobile = htmlspecialchars($rows['mobile']);
					$hours = htmlspecialchars($rows['hours']);
					$notes = $rows['notes'];
					$company = htmlspecialchars($rows['company']);
					$nameTitle = htmlspecialchars($rows['title']);
					$url = $rows['url'];
					if ($url == 'http://')
						$url = '';
					//$image      = $rows['imageurl'];
					$icon = htmlspecialchars($rows['icon']);
					$email = htmlspecialchars($rows['email']);
					$id = htmlspecialchars($rows['id']);
					$products = htmlspecialchars($rows['products']);
					$media = htmlspecialchars($rows['media']);
					$image = htmlspecialchars($rows['image']);
					// may be, fe user have more than 1 image
					$images = explode(',', $image);
					$image = $images[0];
					$distance = number_format($rows['distance'], 2, '.', '');

					$this->_GP['content'] = $rows['content'];

					if (t3lib_extMgm :: isLoaded('locatorfeuser')) {
						require_once (t3lib_extMgm :: extPath('locatorfeuser') . "pi1/class.tx_locatorfeuser_model.php");
						$model = new tx_locatorfeuser_model();
						$nameTitle = htmlspecialchars($model->getFeUserTitle($rows['tx_locatorfeuser_feuseruid']));
						$qualification = htmlspecialchars($rows['tx_locatorfeuser_qualification']);
						$generalTraining = htmlspecialchars($rows['tx_locatorfeuser_generaltraining']);
						$actualTraining = htmlspecialchars($rows['tx_locatorfeuser_actualtraining']);
						$references = htmlspecialchars($rows['tx_locatorfeuser_references']);
						$prefBilling = htmlspecialchars($rows['tx_locatorfeuser_prefbilling']);
						$locatorfeuser_feuseruid = htmlspecialchars($rows['tx_locatorfeuser_feuseruid']);
					}

					// needed for pageTitle in URL with realURL
					$urlParams = array (
						'tx_locator_pi1[storeUid]' => $uid,

					);
					$marks['###ODD###'] = $counter % 2 == 0 ? 'even':'odd';
					$marks['###UID###'] = $rows['uid'];
					$marks['###MAPLINK###'] = '<a href="' . $this->pi_getPageLink($GLOBALS['TSFE']->id, '_top', $urlParams) . '">' .
					'<div class="showMapLink">' . $this->pi_getLL('showMap') . '</div></a>';
					// needed for pageTitle in URL end
					if ($this->conf['resultPageId'])
						$marks['###FORM###'] = '<form method="post" name="form' . $rows['uid'] . '" action="' . $this->pi_getPageLink($this->conf['resultPageId']) . '">';
					else
						$marks['###FORM###'] = '<form method="post" name="form' . $rows['uid'] . '" action="' . $this->pi_getPageLink($GLOBALS['TSFE']->id) . '">';

					if ($url > '') {
						$link = $this->cObj->getTypoLink_URL($url);
						$marks['###STORENAMEV###'] = '<a href="' . $link . '" target="' . $this->conf['linkTarget'] . '">' . $storename . '</a>';
					} else {
						$marks['###STORENAMEV###'] = $storename;
						$link = '';
					}

//					$this->conf['listView.']['fields.']['storename.']['value'] = $marks['###STORENAMEV###'];
//					$marks['###STORENAMEV###'] = $this->cObj->HTML($this->conf['listView.']['fields.']['storename.']);



					$marks['###PURESTORENAMEV###'] = $storename;
					$marks['###LINKV###'] = $link;
					$marks['###FIRSTNAMEV###'] = $firstName;
					$marks['###LASTNAMEV###'] = $lastName;

					// link to feUserListing
					if ($this->conf['feUserListingPageId'] > 0 && $this->conf['useFeUserData']) {
						$params = array (
							'tx_feuserlisting_pi1[showUid]' => $uid,

						);
						$link = $this->pi_getPageLink($this->conf['feUserListingPageId'], '_top', $params);
						$marks['###STORENAMEV###'] = '<a href="' . $link . '" target="_top">' . $storename . '</a>';
						$marks['###COMPANYV###'] = '<a href="' . $link . '" target="_top">' . $company . '</a>';
						//debug($marks['###STORENAMEV###']);
					} else
						$marks['###COMPANYV###'] = $company;



					$marks['###TX_LOCATORFEUSER_FIRSTNAMEV###'] = $rows['tx_locatorfeuser_firstname'];
					$marks['###NAMETITLEV###'] = $nameTitle;
					$marks['###ADDRESSV###'] = $address;
					$marks['###ADDITIONALADDRESSV###'] = $additionalAddress;
					$marks['###COUNTRYV###'] = $country;
					$marks['###CATEGORYV###'] = $category;
					$marks['###CONTACTPERSONV###'] = $contactPerson;
					$marks['###ZIPCODEV###'] = $zipcode;
					$marks['###CITYV###'] = $city;
					$marks['###PHONEV###'] = $phone;
					$marks['###FAXV###'] = $fax;
					$marks['###MOBILEV###'] = $mobile;
					$marks['###EMAILV###'] = $this->cObj->getTypoLink($email, $email);
					$marks['###HOURSV###'] = nl2br($hours);
					$marks['###NOTESV###'] = nl2br($notes);


				if ($media > '' && $this->conf['showVideoPlayer']) {
					$marks['###I###'] = $counter;
					$marks['###MEDIAV###'] = $GLOBALS['TSFE']->baseUrl . 'uploads/tx_locator/media/' . $media;
					$marks['###MEDIADISPLAYV###'] = 'block';
				} else {
					$marks['###MEDIAV###'] = '';
					$marks['###MEDIADISPLAYV###'] = 'none';
				}



					// now the store attributes
					$attribs = explode(',', $attributes);
					//$marks['###ATTRIBUTESV###'] = '';
					$marks['###ATTRIBUTESV###'] = '';
					if (count($attribs) && $attribs[0] != '') {
						$marks['###ATTRIBUTESV###'] = '<ul class="attributesList">';
						for ($i = 0; $i < count($attribs); $i++) {
							list ($attributeName, $attributeIcon) = explode(':', $attribs[$i]);
							$marks['###ATTRIBUTESV###'] .= '<li><img src="uploads/tx_locator/' . $attributeIcon . '"/><span class="text">' . $attributeName . '</span></li>';
						}
						$marks['###ATTRIBUTESV###'] .= '</ul>';
					}
					$marks['###STOREIDV###'] = $storeId;

					if ($this->conf['distanceUnit'] == 'km')
						$marks['###DISTANCEV###'] = $distance . ' km';
					else
						$marks['###DISTANCEV###'] = number_format($distance / 1.6, 2, '.', '') . ' miles';

					if ($this->conf['useFeUserData'] == 1) {
						if ($this->conf['showStoreImage']) {
							if (t3lib_extMgm :: isLoaded('sr_feuser_register')) {
								$this->conf['resultTableView.']['image.']['file'] = 'uploads/tx_srfeuserregister/' . $image;
								$marks['###IMAGEV###'] = ($image > '') ? $this->cObj->IMAGE($this->conf['resultTableView.']['image.']) : '';
							} else {
								$this->conf['resultTableView.']['image.']['file'] = '/uploads/pics/' . $image;
								$marks['###IMAGEV###'] = ($image > '') ? $this->cObj->IMAGE($this->conf['resultTableView.']['image.']) : '';
							}
						} else
							$marks['###IMAGEV###'] = '';
					} else {
						if ($this->conf['showStoreImage']) {
							if ($this->conf['useFeUserData'] == 4) {
								$this->conf['resultTableView.']['image.']['file'] = 'uploads/pics/' . $image;
								$marks['###IMAGEV###'] = ($image > '') ? $this->cObj->IMAGE($this->conf['resultTableView.']['image.']) : '';
							} else {
								$this->conf['resultTableView.']['image.']['file'] = 'uploads/tx_locator/' . $image;
								$marks['###IMAGEV###'] = ($image > '') ?  $this->cObj->IMAGE($this->conf['resultTableView.']['image.']) : '';
							}
						} else
							$marks['###IMAGEV###'] = '';
					}

					$marks['###BUTTON###'] = '<input type="submit" class="mapButton" value="' . $this->pi_getLL('showMap') . '"/>';
					$marks['###HIDDEN###'] = '<input type="hidden" name="tx_locator_pi1[mode]" value="showMap"/>' .
					'<input type="hidden" name="tx_locator_pi1[startCity]" value="' . $this->_GP['city'] . '"/>' .
					'<input type="hidden" name="tx_locator_pi1[storeUid]" value="' . $uid . '"/>' .
					'<input type="hidden" name="tx_locator_pi1[startZipcode]" value="' . $this->_GP['zipcode'] . '"/>' .
					'<input type="hidden" name="tx_locator_pi1[startAddress]" value="' . $this->_GP['address'] . '"/>' .
					'<input type="hidden" name="tx_locator_pi1[startCountry]" value="' . $this->_GP['country'] . '"/>' .
					'<input type="hidden" name="tx_locator_pi1[distance]" value="' . $distance . '"/>' .
					'<input type="hidden" name="tx_locator_pi1[startLat]" value="' . $this->_GP['lat'] . '"/>' .
					'<input type="hidden" name="tx_locator_pi1[startLon]" value="' . $this->_GP['lon'] . '"/>';

					$marks['###MULTI###'] = '<span class="viaButton"><input type="button" value="via" id="tx_locator_via' . $counter . '"' .
					' name="tx_locator_via' . $counter . '" onclick="addToRoute(' . '\'' . $lat . ',' . $lon . '\',\'tx_locator_via' . $counter . '\');"/></span>';


					$marks['###UID###'] = $uid;
                    // link for tt_news single view
                    if ($this->conf['ttNewsSinglePid']) {
                        $urlParams = array (
                            'tx_ttnews[tt_news]' => $uid,
							'tx_locator_pi1[startLat]' => $this->_GP['lat_lon']->lat,
							'tx_locator_pi1[startLon]' => $this->_GP['lat_lon']->lon
                        );
                        $marks['###TTNEWSSINGLEVIEWLINK###'] = $this->pi_getPageLink($this->conf['ttNewsSinglePid'],'', $urlParams);



                    }
//debug($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']);


					// add hook for processing of extra item markers
					if (is_array($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerShowStoresHook'])) {
						foreach ($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerShowStoresHook'] as $_classRef) {
							$_procObj = & t3lib_div :: getUserObj($_classRef);
							$marks = $_procObj->extraItemMarkerShowStoresProcessor($marks, $rows, $this->conf, $this);
						}
					}


					// flexLink
					if ($storeId) 
					$marks['###FLEXLINKV###'] = $this->cObj->substituteMarkerArray($flexLinkSubpart, $marks);
					else
					$marks['###FLEXLINKV###'] = $this->cObj->substituteMarkerArray('###FORM###' . $marks['###HIDDEN###'] . $marks['###BUTTON###'] .'</form>', $marks);



					if ($this->conf['showPoiTable'] == 0) {
						$part = $this->cObj->getSubpart($this->template, "###SEARCHRESULT_DATA###");
						$final .= $this->cObj->substituteMarkerArray($part, $marks);
					}
				}

			

			
			} // end else


			if ($this->conf['showPoiTable'] == 0) {
				$part = $this->cObj->getSubpart($this->template, "###SEARCHRESULT_FOOTER###");
				$marks['###FORMMULTI###'] = '<form method="post" action="' . $this->pi_getPageLink($GLOBALS['TSFE']->id) . '">';
				$marks['###MULTIROUTEADDRESSES###'] = '<input type="hidden" name="tx_locator_pi1[multiRouteAddresses]" ' .
				'id="multiRouteAddresses" value=""/>';
				$marks['###HIDDEN###'] = '<input type="hidden" name="tx_locator_pi1[startCity]" value="' . $this->_GP['city'] . '"/>' .
				'<input type="hidden" name="tx_locator_pi1[mode]" value="showMap"/>' .
				'<input type="hidden" name="tx_locator_pi1[radius]" value="' . $this->_GP['radius'] . '"/>' .
				'<input type="hidden" name="tx_locator_pi1[lon]" value="' . $lon . '"/>' .
				'<input type="hidden" name="tx_locator_pi1[lat]" value="' . $lat . '"/>' .
				'<input type="hidden" name="tx_locator_pi1[startZipcode]" value="' . $this->_GP['zipcode'] . '"/>' .
				'<input type="hidden" name="tx_locator_pi1[startAddress]" value="' . $this->_GP['address'] . '"/>' .
				'<input type="hidden" name="tx_locator_pi1[startCountry]" value="' . $this->_GP['country'] . '"/>';
				$marks['###FORMMULTIEND###'] = '<div><input type="submit" id="tx_locator_pi1_multiRoute" disabled="disabled" value="' .
				$this->pi_getLL('roundTripMap') . '"/></div></form>';

				$final .= $this->cObj->substituteMarkerArray($part, $marks);
			}
		} // end if ($this->conf['displayResultTable'])

		$listContent .= "</table></div>";
		if ($counter != 1) {
			$content .= $final;
		} else {
			// only one store found in radius
			// display the map of this
			$this->_GP['startAddress'] = $this->_GP['address'];
			$this->_GP['startCity'] = $this->_GP['city'];
			$this->_GP['startZipcode'] = $this->_GP['zipcode'];
			$this->_GP['startCountry'] = $this->_GP['country'];

			$this->_GP['lat'] = $lat;
			$this->_GP['lon'] = $lon;

			$this->_GP['uid'] = $uid;
			$this->_GP['storeUid'] = $uid;
			$this->_GP['storename'] = $storename;
			$this->_GP['company'] = $company;
			$this->_GP['nameTitle'] = $nameTitle;
			$this->_GP['firstName'] = $firstName;
			$this->_GP['lastName'] = $lastName;
			$this->_GP['url'] = $url; // maybe this is not needed
			$this->_GP['link'] = $url;
			$this->_GP['contactPerson'] = $contactPerson;
			$this->_GP['media'] = $media;
			$this->_GP['image'] = $image;
			$this->_GP['zipcode'] = $zipcode;
			$this->_GP['city'] = $city;
			$this->_GP['address'] = $address;
			$this->_GP['additionalAddress'] = $additionalAddress;
			$this->_GP['country'] = $country;
			$this->_GP['category'] = $category;
			$this->_GP['icon'] = $icon;
			$this->_GP['email'] = $email;
			$this->_GP['phone'] = $phone;
			$this->_GP['mobile'] = $mobile;
			$this->_GP['fax'] = $fax;
			$this->_GP['distance'] = $distance;
			$this->_GP['hours'] = $hours;
			$this->_GP['notes'] = $notes;
			$this->_GP['storeProducts'] = $products;
			$this->_GP['attributes'] = $attributes;

			if (t3lib_extMgm :: isLoaded('feuser_open')) {
				$this->_GP['tx_feuseropen_montag_vormittag'] = $moVo;
				$this->_GP['tx_feuseropen_dienstag_vormittag'] = $diVo;
				$this->_GP['tx_feuseropen_mittwoch_vormittag'] = $miVo;
				$this->_GP['tx_feuseropen_donnerstag_vormittag'] = $doVo;
				$this->_GP['tx_feuseropen_freitag_vormittag'] = $frVo;

				$this->_GP['tx_feuseropen_montag_nachmittag'] = $moNa;
				$this->_GP['tx_feuseropen_dienstag_nachmittag'] = $diNa;
				$this->_GP['tx_feuseropen_mittwoch_nachmittag'] = $miNa;
				$this->_GP['tx_feuseropen_donnerstag_nachmittag'] = $doNa;
				$this->_GP['tx_feuseropen_freitag_nachmittag'] = $frNa;
			}

			if ($this->conf['useCookie'] && $this->_GP['storeUid'] > 0) {
				setcookie('tx_locator_storeuid', $this->_GP['storeUid'], time() + $this->conf['cookieLifeTime'], '/');
				setcookie('tx_locator_storename', $this->_GP['storename'], time() + $this->conf['cookieLifeTime'], '/');
				setcookie('tx_locator_city', $this->_GP['city'], time() + $this->conf['cookieLifeTime'], '/');
				setcookie('tx_locator_address', $this->_GP['address'], time() + $this->conf['cookieLifeTime'], '/');
				setcookie('tx_locator_zipcode', $this->_GP['zipcode'], time() + $this->conf['cookieLifeTime'], '/');
				setcookie('tx_locator_phone', $this->_GP['phone'], time() + $this->conf['cookieLifeTime'], '/');
				setcookie('tx_locator_distance', $this->_GP['distance'], time() + $this->conf['cookieLifeTime'], '/');
			}

			if (t3lib_extMgm :: isLoaded('locatorfeuser')) {
				require_once (t3lib_extMgm :: extPath('locatorfeuser') . "pi1/class.tx_locatorfeuser_model.php");
				$model = new tx_locatorfeuser_model();
				$this->_GP['nameTitle'] = $model->getFeUserTitle($locatorfeuser_feuseruid);

				$this->_GP['locatorfeuser_qualification'] = $qualification;
				$this->_GP['locatorfeuser_generaltraining'] = $generalTraining;
				$this->_GP['locatorfeuser_actualtraining'] = $actualTraining;
				$this->_GP['locatorfeuser_references'] = $references;
				$this->_GP['locatorfeuser_prebilling'] = $prefBilling;
			}
			$content = $this->showMap();
		}
		if (!$this->conf['showResultTable'] && !($this->conf['displayMode'] == 'autoMailView')) {


// 10.05.2013 prob with mapallView
			if (is_resource($mysqlResults)) {
				if (!$mysqlResults || mysql_num_rows($mysqlResults) == 0) {
					$marksHeader['###TITLE###'] = '<div class="searchResultHeader">' . $this->pi_getLL('no_results_found') . '</div>';
					$marksHeader['###SEARCHRESULT_HEADER###'] = $this->pi_getLL('formHeader');
					$subpart = $this->cObj->getSubpart($this->template, "###SEARCHRESULT_HEADER###");
					$content .= $this->cObj->substituteMarkerArray($subpart, $marksHeader);
					$content .= '</table></div>';
				} else {
					$this->_GP['lat'] = $center_lat_float;
					$this->_GP['lon'] = $center_lon_float;
	
				if ($this->conf['enableNotepad']) {
		
					$this->conf['_GP'] = $this->_GP;
					$this->conf['lang'] = $this->LLkey;
					$this->conf['pageId'] = "" . $GLOBALS['TSFE']->id; // needed for notepad view
				    $ajaxData = urlencode(json_encode($this->conf));
					$content .= '<div id="ajaxData" style="display: none;">' . $ajaxData . '</div>';
			    }
	
					$content .= $this->showMap($mysqlResults);
				}
			}
			if (is_object($mysqlResults)) { // TYPO3 6.1
					$this->_GP['lat'] = $center_lat_float;
					$this->_GP['lon'] = $center_lon_float;
	
					if ($this->conf['enableNotepad']) {
			
						$this->conf['_GP'] = $this->_GP;
						$this->conf['lang'] = $this->LLkey;
						$this->conf['pageId'] = "" . $GLOBALS['TSFE']->id; // needed for notepad view
					    $ajaxData = urlencode(json_encode($this->conf));
						$content .= '<div id="ajaxData" style="display: none;">' . $ajaxData . '</div>';
				    }
	
					$content .= $this->showMap($mysqlResults);
			}
		
		}

		if (!$this->conf['showResultTable'] && $this->conf['displayMode'] == 'autoMailView') {
			while ($rows = mysql_fetch_array($mysqlResults)) {
				if ($this->conf['useFeUserData'] == 1) {
					$data['lat'][] .= $rows['tx_locator_lat'];
					$data['lon'][] .= $rows['tx_locator_lon'];
					$data['address'][] .= $rows['address'];
					$data['city'][] .= $rows['city'];
					$data['state'][] .= $rows['state'];
					$data['zipcode'][] .= $rows['zip'];
					$data['country'][] .= $rows['country'];
					$data['storename'][] .= $rows['name'];
					$data['email'][] .= $rows['email'];
					$data['distance'][] .= $rows['distance'];

				} else {
					$data['uid'][] .= $rows['uid'];
					$data['lat'][] .= $rows['lat'];
					$data['lon'][] .= $rows['lon'];
					$data['address'][] .= $rows['address'];
					$data['city'][] .= $rows['city'];
					$data['state'][] .= $rows['state'];
					$data['zipcode'][] .= $rows['zipcode'];
					$data['country'][] .= $rows['country'];
					$data['storename'][] .= $rows['storename'];
					$data['email'][] .= $rows['email'];
					$data['distance'][] .= $rows['distance'];
				}
			}
			$content = $this->sendMail($data);
		}
		if ($this->conf['displayMode'] != 'mapAllView' && $this->conf['showOverviewMap'] && $counter > 1) {
			$center_lat = $center_lat_lon->lat;
			$center_lon = $center_lat_lon->lon;
			$this->_GP['lat'] = $center_lat_float;
			$this->_GP['lon'] = $center_lon_float;

			$this->conf['displayMode'] = 'mapAllView';
			$this->_GP['mode'] == 'search';
			$this->conf['showResultTable'] = 0;
			$this->conf['showRoute'] = 0;

			$content .= $this->showMap($mysqlResults);
		}
		return $content;
	}

	function prepareMapResults($mysql_results) {
		//        debug($mysql_results, 'mysql prepare');
		//        debug($this->_GP, 'prepare');
		$retval = '';
		$lat = $this->_GP['lat'];
		$lon = $this->_GP['lon'];
		$uid = $this->_GP['uid'];
//		$storename = addslashes(addslashes(htmlspecialchars($this->_GP['storename'], ENT_QUOTES)));
		$storename = addslashes(addslashes($this->_GP['storename']));

		$nameTitle = $this->_GP['nameTitle'];
		$firstName = htmlspecialchars($this->_GP['firstName'], ENT_QUOTES);
		$lastName = htmlspecialchars($this->_GP['lastName'], ENT_QUOTES);
		$company = $this->_GP['company'];
		$icon = $this->_GP['icon'];
		$address = addslashes(addslashes($this->_GP['address']));
		$country = $this->_GP['country'];

		$zipcode = $this->_GP['zipcode'];
		$city = $this->_GP['city'];
		$icon = "uploads/tx_locator/" . addslashes($this->_GP['icon']);
		$image = $this->_GP['image'];
		$url = $this->_GP['url'];

		$attributes = $this->_GP['attributes'];
		$storeId = $this->_GP['storeId'];

		//kamppeter
		//        $url = $this->_GP['link'];

		$hours = $this->_GP['hours'];
		if ($image != '')
			$imageAvailable = 1;
		else
			$imageAvailable = 0;
		if ($this->conf['useFeUserData'] == 1 && $this->conf['showStoreImage']) {
			$images = explode(',', $this->_GP['image']);
			$image = $images[0];
		}
		if ($this->conf['showStoreImage'] && $imageAvailable) {
			if (!$this->conf['useFeUserData'] || $this->conf['useFeUserData'] == 3) {
				$image = "uploads/tx_locator/" . addslashes($image);
			}
			if ($this->conf['useFeUserData'] == 1) {
				if (t3lib_extMgm :: isLoaded('sr_feuser_register')) {
					$image = "uploads/tx_srfeuserregister/" . addslashes($image);
				} else {
					$image = "uploads/pics/" . addslashes($image);
				}
			}
			if ($this->conf['useFeUserData'] == 4) {
				$image = "uploads/pics/" . addslashes($image);
			}
		}

		//debug($this->_GP, 'locator view prepare');

		// external location table
		if ($this->conf['useFeUserData'] == 2 && $this->conf['showStoreImage'] && $this->conf['externalLocationTable'] == 'tx_cal_location') {
			$image = 'uploads/tx_cal/pics/' . $this->_GP['image'];
		}
		//debug($image);

		//kamppeter
		//        if($url != '') {
		//            $url = $this->cObj->getTypoLink_URL($url);
		//        }
		$linkParams = array ();
		if ($url != '')
			$storename = $this->cObj->getTypoLink($storename, $url, $linkParams, $this->conf['linkTarget']);
		if (!is_file($icon))
			$icon = t3lib_extMgm :: siteRelPath('locator') . 'pi1/icons/pointerRed.gif';

		$notes = htmlspecialchars(wordwrap($rows['notes'], 80, "<br>"), ENT_QUOTES);

		$comments = str_replace("'", '&lsquo;', $this->_GP['notes']);
		if ($this->_GP['storeProducts'])
			$comments .= '<br />' . $this->pi_getLL('infoWindowProducts') . $this->_GP['storeProducts'];
		$comments = preg_replace('#\r?\n#', '<br />', $comments); // for javascript
		$phone = $this->_GP['phone'];
		$mobile = $this->_GP['mobile'];
		$fax = $this->_GP['fax'];
		$id = $rows['id'];
		$use_coordinate = addslashes($rows['use_coordinate']);
		$distance = number_format($rows['distance'], 2, '.', '');
		//If the location is blank, skip it.  Otherwise, setup a bullet on the map for it.
		if ($lat != 0 or $lon != 0) {
			$retval .= "
			              lon = " . floatval($lon) . ";
			              lat = " . floatval($lat) . ";
			              point = new GPoint(lon,lat);
			              point2 = new GLatLng(lat,lon);
			              //Create the custom Green icon.  Google only provides red, so I've modified it with a different color.

			              icon = new GIcon();
			              //icon.shadow = \"http://www.google.com/mapfiles/shadow50.png\";";

			// Get the size of the image so we can pass it to GSize.
			// Leaving GSize blank will break the map, so we have to pass
			// these sizes or things dont work right :/

			$mapicon = $icon;
			list ($width, $height, $type, $attr) = getimagesize("$mapicon");
			//list($width, $height, $type, $attr) = getimagesize(locations_marker_icon);
			$retval .= "icon.iconSize = new GSize(" . $width . ", " . $height . ");
			              //icon.shadowSize = new GSize(37, 34);
			              icon.shadow = 'typo3conf/ext/locator/pi1/res/shadow.png';
			              icon.shadowSize = new GSize(30, 17);

			              //icon.iconAnchor = new GPoint(9, 34);
			              icon.iconAnchor = new GPoint(9, " . $height . ");
			              icon.infoWindowAnchor = new GPoint(9, 2);
			              icon.infoShadowAnchor = new GPoint(18, 25);";
			//var address = ";

			//This little snippet makes the balloon "to here, from here" features use the same logic as the results page
			//when determining whether to send google a coordinate or address to get driving directions.
			/*
			                 if ($use_coordinate == 'on')
			                    {
			                    $retval .= "'$lat,$lon'";
			                 }
			                 else
			                    {
			                    $retval .= "'$address,$city,$state $zipcode $country'";
			                 }
			*/
			$retval .= "  //Setup the custom Icons
			                icon.image = \"" . $mapicon . "\";
			                marker = new GMarker(point2, {icon: icon, draggable: true});
			                marker.enableDragging();";

			if ($this->conf['showStoreImage'] && $imageAvailable) {
				$image1 = $image;
				$image = '<div class="tooltipImage"><img src="' . $image . '" height="80px"/></div>';
			} else
				$image = '';

			if ($url == '') {
				$storeLink = $company . '<br />' . $storename;
				if ($this->conf['feUserListingPageId'] > 0 && $this->conf['useFeUserData']) {
					$params = array (
						'tx_feuserlisting_pi1[showUid]' => $uid,

					);
					$url = $this->pi_getPageLink($this->conf['feUserListingPageId'], '_top', $params);
					$storeLink = '<a href="' . $url . '" target="_top">' . $storename . '</a>';
				}

			} else {
				// link to feUserListing
				if ($this->conf['feUserListingPageId'] > 0 && $this->conf['useFeUserData']) {
					$params = array (
						'tx_feuserlisting_pi1[showUid]' => $uid,

					);
					$url = $this->pi_getPageLink($this->conf['feUserListingPageId'], '_top', $params);
				}
			}

			// now the template for the google infoWindow
			$subpart = $this->cObj->getSubpart($this->template, "###INFOWINDOW###");
			$marks = array ();

			if ($this->_GP['media'] > '' && $this->conf['showVideoPlayer']) {
				$marks['###I###'] = 1;
				$marks['###MEDIAV###'] = $GLOBALS['TSFE']->baseUrl . 'uploads/tx_locator/media/' . $this->_GP['media'];
				$marks['###MEDIADISPLAYV###'] = 'block';
			} else {
				$marks['###MEDIAV###'] = '';
				$marks['###MEDIADISPLAYV###'] = 'none';
			}

			$this->conf['googleInfoWindow.']['image.']['file'] = $image1;
			$marks['###IMAGEV###'] = $this->cObj->IMAGE($this->conf['googleInfoWindow.']['image.']);
			$marks['###ROUTEV###'] = '';

            $marks['###TTNEWSSINGLEVIEWLINK###'] = '';
			$marks['###SINGLEVIEWLINKV###'] = '';
			if ($this->conf['ttNewsSinglePid']) {
				$urlParams = array (
					'tx_ttnews[tt_news]' => $uid,
					'tx_locator_pi1[startLat]' => $this->_GP['startLat'],
					'tx_locator_pi1[startLon]' => $this->_GP['startLon'],
					'tx_locator_pi1[mode]' => 'showRoute'
				);
                $marks['###ROUTEV###'] = $this->pi_linkToPage($this->pi_getLL('route', 'Route'), $this->conf['ttNewsSinglePid'], '', $urlParams);

				$urlParams = array (
                    'tx_ttnews[tt_news]' => $uid,
					'tx_locator_pi1[startLat]' => $this->_GP['startLat'],
					'tx_locator_pi1[startLon]' => $this->_GP['startLon']
                );
                $marks['###TTNEWSSINGLEVIEWLINK###'] = $this->pi_getPageLink($this->conf['ttNewsSinglePid'],'', $urlParams);
			}
			$marks['###NAMETITLEV###'] = $nameTitle;

			$marks['###STORENAMEV###'] = addslashes(addslashes($storename));


			if ($this->_GP['link'] != '')
				$storename = $this->cObj->getTypoLink($this->_GP['storename'], $this->_GP['link'], $urlParams, $this->conf['linkTarget']);
			$marks['###STORENAMEV###'] = addslashes(addslashes($storename));
			$marks['###FIRSTNAMEV###'] = $firstName;
			$marks['###LASTNAMEV###'] = $lastName;
			$marks['###COMPANYV###'] = addslashes(addslashes($company));
			$marks['###TX_LOCATORFEUSER_FIRSTNAMEV###'] = $this->_GP['tx_locatorfeuser_firstname'];
			$marks['###ADDRESSV###'] = $address;
			$marks['###ZIPCODEV###'] = $zipcode;
			$marks['###CITYV###'] = $city;
			$marks['###COUNTRYV###'] = $country;
			$marks['###PHONEV###'] = $phone;
			$marks['###MOBILEV###'] = $mobile;
			$marks['###FAXV###'] = $fax;
			$marks['###EMAILV###'] = addslashes(addslashes($this->cObj->getTypoLink($this->_GP['email'], $this->_GP['email'])));
			$marks['###URLV###'] = $url;
			$marks['###HOURSV###'] = nl2br($hours);
			$marks['###COMMENTSV###'] = $comments;

			// now the store attributes
			$attribs = explode(',', $attributes);
			$marks['###ATTRIBUTESV###'] = '';
			if (count($attribs) && $attribs[0] != '') {
				$marks['###ATTRIBUTESV###'] = '<ul class="attributesList">';
				for ($i = 0; $i < count($attribs); $i++) {
					list ($attributeName, $attributeIcon) = explode(':', $attribs[$i]);
					$marks['###ATTRIBUTESV###'] .= '<li><img src="uploads/tx_locator/' . $attributeIcon . '"/><span class="text">' . $attributeName . '</span></li>';
				}
				$marks['###ATTRIBUTESV###'] .= '</ul>';
			}
			$marks['###STOREIDV###'] = $storeId;

			if ($this->conf['useFeUserPageTitle'] && $this->conf['useFeUser'] == 1) {
				$GLOBALS['TSFE']->page['title'] = $nameTitle . ' ' . $this->_GP['firstName'] . ' ' .
				$this->_GP['lastName'] . ' ' . $this->_GP['city'];
			}
			if ($this->conf['useFeUserPageTitle'] && $this->conf['useFeUser'] == 0) {
				$GLOBALS['TSFE']->page['title'] = $this->_GP['storename'];
			}

			$marks['###UID###'] = $uid;



			/* modification for dl_locator_hooks start */
			if (is_array($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerInfoWindowHook'])) {
				foreach ($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerInfoWindowHook'] as $_classRef) {
					$_procObj = & t3lib_div :: getUserObj($_classRef);
					$marks = $_procObj->extraItemMarkerInfoWindowProcessor($marks, $rows, $this->conf, $this);
				}
			}
			/* modification for by dl_locator_hooks end */


			$infoWindow = $this->cObj->substituteMarkerArray($subpart, $marks);
			$infoWindow = preg_replace('#\r?\n#', '', $infoWindow); // for javascript

			// the second tab
			$subpart = $this->cObj->getSubpart($this->template, "###INFOWINDOW2###");
			$infoWindow2 = $this->cObj->substituteMarkerArray($subpart, $marks);
			$infoWindow2 = preg_replace('#\r?\n#', '', $infoWindow2); // for javascript

			$retval .= "taba = new GInfoWindowTab('" . $this->pi_getLL('street_label') . "', '" . $infoWindow . "');";
			//                $retval .= "tabb = new GInfoWindowTab('".$this->pi_getLL('toComments')."', '".$comments."');";
			$retval .= "tabb = new GInfoWindowTab('" . $this->pi_getLL('toComments') . "', '" . $infoWindow2 . "');";

			$panorama = '<div id=\"pano\" class=\"tx_locator_map\" style=\"width: 400px; height: 200px;margin-top: 13px;\"></div>';
			//$retval .= "tabc = new GInfoWindowTab('".$this->pi_getLL('panorama')."', '".$panorama."');";
			$retval .= "tabArray = new Array (taba, tabb);";

			// map types
			$types = explode(',', $this->conf['additionalMapTypes']);
			for ($i = 0; $i < count($types); $i++) {
				$retval .= "map.addMapType(" . $types[$i] . ");";
			}

			/*                $retval .= "
			                    GEvent.addListener(marker, 'mouseover', function() {";
			                if ($this->conf['showTabbedInfoWindow'] )
			                      $retval .= "
			                          if (map.getInfoWindow().isHidden())
			                          marker.openInfoWindowTabsHtml(tabArray,{maxWidth:200});
			                        ";
			                else $retval .= "
			                    marker.openInfoWindowHtml('".$infoWindow."',{maxWidth:200, maxHeight:50,autoScroll:true});
			                    ";

			                $retval .= "});";
			*/

			$retval .= "
			                    //GEvent.addListener(marker, 'mouseout', function() {
			                    //if (taba.isHidden() == false) {alert('ssss');}
			                    //  });
			                      ";

			$retval .= "
			                //    GEvent.addListener(marker, 'click', function() {
			                //      marker.openInfoWindowHtml('$infoWindow');
			                //      });

			                GEvent.addListener(marker, 'dragstart', function() {";
			if ($this->conf['enableStreetView'])
				$retval .= "
				                        myPano.remove();";
			$retval .= "
			                    map.closeInfoWindow();  });
			                GEvent.addListener(marker, 'dragend', function() {
			                    infoWindow = '<div>" . $this->pi_getLL('Coordinates (lat, lon)') . "<br />' + marker.getLatLng().toString() +'</div>';
			                    marker.openInfoWindowHtml(infoWindow);
			                    document.getElementById('pano').innerHTML = '';
			                    document.getElementById('pano').style.display = 'block';
			                ";
			if ($this->conf['enableStreetView'])
				$retval .= "
				                        panoClient.getNearestPanorama(marker.getLatLng(), showPanoData);";
			$retval .= "
			                        });

			                        map.enableDoubleClickZoom();
			                          map.addOverlay(marker);";

			// for panorama view
			if ($this->conf['enableStreetView']) {
				$retval .= "
				                        myPano = new GStreetviewPanorama(document.getElementById('pano'));
				                     panoClient.getNearestPanorama(marker.getLatLng(), showPanoData);";
			} // end $this->conf['enableStreetView']

			// show infoWindow by default
			if ($this->conf['showTabbedInfoWindow'])
				$retval .= "
				                          marker.openInfoWindowTabsHtml(tabArray,{maxWidth:200}); player(1);";
			else
				$retval .= "
				                        marker.openInfoWindowHtml('" . $infoWindow . "',{maxWidth:300, maxHeight:200,autoScroll:true});";

			if (substr($this->conf['googleApiVersion'], 0, 1) == '3') {
	         	$ret .= "infoBubble[$i] = new InfoBubble({
	            content: '<div>$infoWindow</div>',
				minWidth: 200,
				maxWidth: 300,
				shadowStyle: 1,
				padding: 0,
			//	backgroundColor: 'rgb(57,57,57)',
				borderRadius: 6,
				arrowSize: 10,
				borderWidth: 1,
				borderColor: '#2c2c2c',
				disableAutoPan: true,
				//hideCloseButton: true,
				arrowPosition: 10,
				backgroundClassName: 'phoney',
				arrowStyle: 2

	        });
			";

			if ($this->conf['showTabbedInfoWindow']) {
			    $ret .= "
	            InfoBubble.tabCounter = 0;
				infoBubble[$i].addTab('" . '<div class="tabLabel">' . $this->pi_getLL('street_label') ." ', '" . $infoWindow . '</div>' ."','1' );
				infoBubble[$i].addTab(' " . $this->pi_getLL('toComments') ." ', '$infoWindow2');
				";
			}


				$ret .= "var myLatLng = new google.maps.LatLng($lat,$lon);
				                var shadow = new google.maps.MarkerImage('typo3conf/ext/locator/pi1/res/shadow.png',
				                // The shadow image is larger in the horizontal dimension
				                // while the position and offset are the same as for the main image.
				                new google.maps.Size(37, 37),
				                new google.maps.Point(0,0),
				                new google.maps.Point(10, 37));


				                marker = new google.maps.Marker({
				                position: myLatLng,
				                map: map,
				                icon: '$icon',
				                shadow: shadow
				                });

				                var infowindow = new google.maps.InfoWindow({
				                    content: '$infoWindow'
				                });

				                google.maps.event.addListener(marker, 'click', function() {
			            infoBubble[$i].open(map, marker);";
//				                  infowindow.open(map,marker);";
				if ($this->conf['showVideoPlayer'])
					$ret .= "
// J. Ruhs 18.08.2013
					                          setTimeout('player(1)', 1000);";
				$ret .= "
				                });
				            ";



				// now the relatedTo markers
				for ($i = 0; $i < count($this->input['relatedTo']['uid']); $i++) {
					$icon = $this->input['relatedTo']['icon'][$i];

					// now the template for the google infoWindow
					$subpart = $this->cObj->getSubpart($this->template, "###INFOWINDOW###");

					$marks = array ();
					if ($this->input['relatedTo']['media'][$i] > '' && $this->conf['showVideoPlayer']) {
						$marks['###I###'] = 1;
						$marks['###MEDIAV###'] = $GLOBALS['TSFE']->baseUrl . 'uploads/tx_locator/media/' . $this->input['relatedTo']['media'][$i];
						$marks['###MEDIADISPLAYV###'] = 'block';
					} else {
						$marks['###MEDIAV###'] = '';
						$marks['###MEDIADISPLAYV###'] = 'none';
					}
					$this->conf['googleInfoWindow.']['image.']['file'] = 'uploads/tx_locator/' . $this->input['relatedTo']['image'][$i];
					$marks['###IMAGEV###'] = $this->cObj->IMAGE($this->conf['googleInfoWindow.']['image.']);
					$marks['###ROUTEV###'] = '';
					$marks['###COMPANYV###'] = '';
					$marks['###FIRSTNAMEV###'] = '';
					$marks['###LASTNAMEV###'] = '';
					$marks['###TX_LOCATORFEUSER_FIRSTNAMEV###'] = '';
					$marks['###NAMETITLEV###'] = $nameTitle;
					$marks['###STORENAMEV###'] = addslashes(addslashes($this->input['relatedTo']['storename'][$i]));
					$marks['###ADDRESSV###'] = $this->input['relatedTo']['address'][$i];
					$marks['###ZIPCODEV###'] = $this->input['relatedTo']['zipcode'][$i];
					$marks['###CITYV###'] = $this->input['relatedTo']['city'][$i];
					$marks['###COUNTRYV###'] = $this->input['relatedTo']['country'][$i];
					$marks['###PHONEV###'] = $this->input['relatedTo']['phone'][$i];
					$marks['###MOBILEV###'] = $this->input['relatedTo']['mobile'][$i];
					$marks['###FAXV###'] = $this->input['relatedTo']['fax'][$i];
					$marks['###EMAILV###'] = addslashes(addslashes($this->cObj->getTypoLink($this->input['relatedTo']['email'][$i], $this->input['relatedTo']['email'][$i])));
					$marks['###URLV###'] = $this->input['relatedTo']['url'][$i];
					$marks['###HOURSV###'] = $this->input['relatedTo']['hours'][$i];
					$marks['###COMMENTSV###'] = $this->input['relatedTo']['comments'][$i];

					$infoWindow = $this->cObj->substituteMarkerArray($subpart, $marks);
					$infoWindow = preg_replace('#\r?\n#', '', $infoWindow); // for javascript





					$ret .= "var myLatLng" . $i . " = new google.maps.LatLng(" . $this->input['relatedTo']['lat'][$i] . "," . $this->input['relatedTo']['lon'][$i] . ");

					                var marker" . $i . " = new google.maps.Marker({
					                position: myLatLng" . $i . ",
					                map: map,
					                icon: 'uploads/tx_locator/$icon',
					                shadow: shadow
					                });

					                var infowindow" . $i . " = new google.maps.InfoWindow({
					                    content: '$infoWindow'
					                });








					                google.maps.event.addListener(marker" . $i . ", 'click', function() {
					                  infowindow" . $i . ".open(map,marker" . $i . ");
					                  setTimeout('player(1)', 1000);
					                });
					                ";
				}
			}
		} //end if

		if (substr($this->conf['googleApiVersion'], 0, 1) == 3)
			return $ret;

		return ($retval);
	}

	function prepareMapAllResults($mysql_results) {

		//debug($this->_GP, 'prepareMapAllResults');
		//http://www.citybeat.de/plz/hole_plz.html?plz=79365

		$retval = '';
		// map types
		$types = explode(',', $this->conf['additionalMapTypes']);
		for ($i = 0; $i < count($types); $i++) {
			$retval .= "map.addMapType(" . $types[$i] . ");";
		}

		//If the seek line is missing, then the results will never show.  Do not remove the seek line.
		$GLOBALS['TYPO3_DB']->sql_data_seek($mysql_results, 0);


		$i = 0;
		while ($rows = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($mysql_results)) {
			$i++;
			$uid = $rows['uid'];
			$lat = $rows['lat'];
			$lon = $rows['lon'];
			$address = addslashes(addslashes(nl2br($rows['address'])));
			$additionalAddress = addslashes($rows['additionaladdress']);
			$contactPerson = addslashes($rows['contactperson']);
			$city = addslashes($rows['city']);
			$state = addslashes($rows['state']);
			$zipcode = addslashes(htmlspecialchars($rows['zipcode']));

			$country = addslashes($rows['country']);
			if ($this->conf['useFeUserData'] == 4)
				$storename = addslashes(addslashes($rows[$this->conf['tt_addressStorenameField']]));
			else
				$storename = addslashes(addslashes(htmlspecialchars($rows['storename'], ENT_QUOTES)));

			$firstName = $rows['first_name'];
			$lastName = $rows['last_name'];

			$company = addslashes(addslashes($rows['company']));
			$media = $rows['media'];
			$image = addslashes($rows['image']);
			$hours = addslashes(nl2br($rows['hours']));
			$url = addslashes($rows['url']);
			$fax = $rows['fax'];
			$comments = $rows['notes'];
			$nameTitle = $rows['title'];
			$attributes = $rows['attributes'];
			$storeId = $rows['storeid'];

			if (t3lib_extMgm :: isLoaded('locatorfeuser')) {
				require_once (t3lib_extMgm :: extPath('locatorfeuser') . "pi1/class.tx_locatorfeuser_model.php");
				$model = new tx_locatorfeuser_model();
				$nameTitle = $model->getFeUserTitle($rows['tx_locatorfeuser_feuseruid']);
			}

			$email = addslashes($rows['email']);

			$address = preg_replace('#\r?\n#', '<br />', $address); // for javascript

			if ($this->conf['useNotesInternal'])
				$rows['notes'] = '';
			$comments = str_replace("'", '&lsquo;', $rows['notes']);


			if ($rows['products'])
				$comments .= '<br />' . $this->pi_getLL('infoWindowProducts') . $rows['products'];

			$comments = preg_replace('#\r?\n#', '<br />', $comments); // for javascript

			if ($image != '')
				$imageAvailable = 1;
			else
				$imageAvailable = 0;
			if ($this->conf['useFeUserData'] == 1 && $this->conf['showStoreImage']) {
				$images = explode(',', $rows['image']);
				$image = $images[0];
				if (t3lib_extMgm :: isLoaded('sr_feuser_register')) {
					$image = "uploads/tx_srfeuserregister/" . addslashes($image);
				} else {
					$image = "uploads/pics/" . addslashes($image);
				}
			}

			if ($this->conf['useFeUserData'] == 4 && $this->conf['showStoreImage']) {
				$images = explode(',', $rows['image']);
				$image = $images[0];
				$image = "uploads/pics/" . addslashes($image);
			}
			// external location table
			if ($this->conf['useFeUserData'] == 2 && $this->conf['externalLocationTable'] == 'tx_cal_location') {
				$image = 'uploads/tx_cal/pics/' . $rows['image'];
				$zipcode = $rows['zip'];
				$address = $rows['street'];
				$url = $rows['link'];
			}

			if (!$this->conf['useFeUserData'] == 1 && $this->conf['showStoreImage'])
				$image = "uploads/tx_locator/" . addslashes($rows['image']);
			if ($this->conf['useFeUserData'] == 3 && $this->conf['showStoreImage']) {
				$image = "uploads/tx_locator/" . addslashes($rows['tx_locator_imageurl']);
				if ($rows['tx_locator_imageurl'] != '')
					$imageAvailable = 1;
			}
			$image1 = '';
			if ($this->conf['showStoreImage'] && $imageAvailable) {
				$image1 = $image;
				$image = '<div class="tooltipImage"><img src="' . $image . '" height="80px"/></div>';
			} else
				$image = '';

			if (preg_match('/^[0-9]+$/', $url))
				$url = '/' . $this->pi_getPageLink($url);
			else {
				if (strpos($url, 'ttp://') != 1 && $url != '')
					$url = 'http://' . $url;
			}

			$icon = "uploads/tx_locator/" . addslashes($rows['icon']);
			if (!is_file($icon))
				$icon = t3lib_extMgm :: siteRelPath('locator') . 'pi1/icons/pointerRed.gif';

			$notes = addslashes(wordwrap($rows['notes'], 80, "<br>"));
			$phone = addslashes($rows['phone']);
			$mobile = addslashes($rows['mobile']);
			$id = $rows['id'];

			if ($this->conf['useFeUserData'] == 3)
				$image_url = addslashes($rows['tx_locator_imageurl']);
			else
				$image_url = addslashes($rows['imageurl']);

			$use_coordinate = addslashes($rows['use_coordinate']);
			$distance = number_format($rows['distance'], 2, '.', '');
			//If the location is blank, skip it.  Otherwise, setup a bullet on the map for it.
			if ($lat != 0 or $lon != 0) {
				$retval .= "
				              lon = " . floatval($lon) . ";
				              lat = " . floatval($lat) . ";
				              point = new GPoint(lon,lat);";

				//Create the custom Green icon.  Google only provides red, so I've modified it with a different color.
				$mapicon = $icon;

				//This little snippet makes the balloon "to here, from here" features use the same logic as the results page
				//when determining whether to send google a coordinate or address to get driving directions.
				/*
				                 if ($use_coordinate == 'on')
				                    {
				                    $retval .= "'$lat,$lon';";
				                 }
				                 else
				                    {
				                    $retval .= "'$address,$city,$state $zipcode $country';";
				                 }
				*/
				$params = array (
					"tx_locator_pi1[dummy]" => "showMap",
					"tx_locator_pi1[mode]" => "showRoute",
					"tx_locator_pi1[storeUid]" => $uid,
					"tx_locator_pi1[startZipcode]" => $this->_GP['zipcode'],
					"tx_locator_pi1[startCity]" => $this->_GP['city'],
					"tx_locator_pi1[startAddress]" => $this->_GP['address'],
					"tx_locator_pi1[startCountry]" => $this->_GP['country'],
					"tx_locator_pi1[startLat]" => $this->_GP['lat'],
					"tx_locator_pi1[startLon]" => $this->_GP['lon'],
					"tx_locator_pi1[lat]" => $lat,
					"tx_locator_pi1[lon]" => $lon,
					"tx_locator_pi1[distance]" => number_format($rows['distance'], 2, ',', '.'),
				);
				if ($this->conf['routePageId'] > '') {
					$urlResultPage = '/' . $this->pi_getPageLink($this->conf['routePageId'], '_blank', $params);
				} else
					$urlResultPage = $this->pi_getPageLink($GLOBALS['TSFE']->id, '_blank', $params);

				if ($url == '') {
					if ($this->conf['feUserListingPageId'] > 0 && $this->conf['useFeUserData']) {
						$params = array (
							'tx_feuserlisting_pi1[showUid]' => $uid,

						);
						$url = $this->pi_getPageLink($this->conf['feUserListingPageId'], '_top', $params);
						$storeLink = '<a href="' . $url . '" target="_top">' . $company . '<br />' . $storename . '</a>';
					}
				} else {
					// link to feUserListing
					if ($this->conf['feUserListingPageId'] > 0 && $this->conf['useFeUserData']) {
						$params = array (
							'tx_feuserlisting_pi1[showUid]' => $uid,

						);
						$url = $this->pi_getPageLink($this->conf['feUserListingPageId'], '_top', $params);
					}
				}
				$tooltip[$i] = $storename . ' ' . $address . ' ' . $zipcode . ' ' . $city .
				$state . ' ' . $country . ' ' . $phone;


				// now the template for the google infoWindow
				$subpart = $this->cObj->getSubpart($this->template, "###INFOWINDOW###");
				$marks = array ();
				if ($media > '' && $this->conf['showVideoPlayer']) {
					$marks['###I###'] = $i;
					$marks['###MEDIAV###'] = $GLOBALS['TSFE']->baseUrl . 'uploads/tx_locator/media/' . $media;
					$marks['###MEDIADISPLAYV###'] = 'block';
				} else {
					$marks['###I###'] = $i;
					$marks['###MEDIAV###'] = '';
					$marks['###MEDIADISPLAYV###'] = 'none';
				}

				$marks['###UID###'] = $uid;
				

				if ($this->conf['singleViewPid']) {
					$params = array (
						'tx_locator_pi1[storeUid]' => $uid,
					);

					$marks['###SINGLEVIEWLINKV###'] = $this->pi_linkToPage($this->pi_getLL('singleViewLink'), $this->conf['singleViewPid'], '_top', $params);
				
				}
				else $marks['###SINGLEVIEWLINKV###'] = '';
				



				//////////// notepad ////////////////////
				$marks['###ADDTONOTEPAD###'] = $this->pi_getLL('addToNotepad');
				$marks['###REMOVEFROMNOTEPAD###'] = $this->pi_getLL('removeFromNotepad');
				if (t3lib_div::inList($_COOKIE['notepadStoreUids'], $uid)) {
					$marks['###MARKSTATEDISPLAY###'] = 'none';
					$marks['###UNMARKSTATEDISPLAY###'] = 'block';
				} else {
					$marks['###MARKSTATEDISPLAY###'] = 'block';
					$marks['###UNMARKSTATEDISPLAY###'] = 'none';
				}

				$marks['###IMAGEV###'] = $image;

				$this->conf['googleInfoWindow.']['image.']['file'] = $image1;
				$marks['###IMAGEV###'] = $this->cObj->IMAGE($this->conf['googleInfoWindow.']['image.']);

				$marks['###ROUTEV###'] = "<a href=\"$urlResultPage\" target=\"" . $this->conf['routeViewTarget'] . "\">" . $this->pi_getLL('route') . "</a>";

                $marks['###TTNEWSSINGLEVIEWLINK###'] = '';
				if ($this->conf['ttNewsSinglePid']) {
					$marks['###ROUTEV###'] = '<a href="/index.php?id=' . $this->conf['ttNewsSinglePid'] . '&tx_ttnews[tt_news]=' . $uid .
						'&tx_locator_pi1[startLat]=' . (float) $this->_GP['lat'] .'&tx_locator_pi1[startLon]=' . (float) $this->_GP['lon'] .'&tx_locator_pi1[mode]=showRoute">Route</a>';
                    $urlParams = array (
                        'tx_ttnews[tt_news]' => $uid,
						'tx_locator_pi1[startLat]' => (float) $this->_GP['lat_lon']->lat,
						'tx_locator_pi1[startLon]' => (float) $this->_GP['lat_lon']->lon
                    );
                    $marks['###TTNEWSSINGLEVIEWLINK###'] = $this->pi_getPageLink($this->conf['ttNewsSinglePid'],'', $urlParams);
				}

				$urlParams = array ();

				if ($url != '')
					$storename = $this->cObj->getTypoLink($storename, $url, $urlParams, $this->conf['linkTarget']);

				$marks['###STORENAMEV###'] = $storename;

				$marks['###NAMETITLEV###'] = addslashes($nameTitle);
				$marks['###FIRSTNAMEV###'] = addslashes(htmlspecialchars($firstName, ENT_QUOTES));
				$marks['###LASTNAMEV###'] = addslashes(htmlspecialchars($lastName, ENT_QUOTES));

				$marks['###COMPANYV###'] = addslashes($company);
				$marks['###TX_LOCATORFEUSER_FIRSTNAMEV###'] = $rows['tx_locatorfeuser_firstname'];
				$marks['###ADDRESSV###'] = addslashes($address);
				$marks['###ZIPCODEV###'] = addslashes($zipcode);
				$marks['###CITYV###'] = addslashes($city);
				$marks['###COUNTRYV###'] = addslashes($country);
				$marks['###PHONEV###'] = addslashes($phone);
				$marks['###MOBILEV###'] = addslashes($mobile);
				$marks['###FAXV###'] = addslashes($fax);
				$marks['###URLV###'] = addslashes($url);
				$marks['###HOURSV###'] = addslashes($hours);
				$marks['###COMMENTSV###'] = addslashes($comments);
				$marks['###EMAILV###'] = addslashes(addslashes($this->cObj->getTypoLink($email, $email)));

				// now the store attributes
				$attribs = explode(',', $attributes);
				//$marks['###ATTRIBUTESV###'] = '';
				$marks['###ATTRIBUTESV###'] = '';
				if (count($attribs) && $attribs[0] != '') {
					$marks['###ATTRIBUTESV###'] = '<ul class="attributesList">';
					for ($j = 0; $j < count($attribs); $j++) {
						list ($attributeName, $attributeIcon) = explode(':', $attribs[$j]);
						$marks['###ATTRIBUTESV###'] .= '<li><img src="uploads/tx_locator/' . $attributeIcon . '"/><span class="text">' . $attributeName . '</span></li>';
					}
					$marks['###ATTRIBUTESV###'] .= '</ul>';
				}
				$marks['###STOREIDV###'] = $storeId;


				/* modification for dl_locator_hooks start */
				if (is_array($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerInfoWindowHook'])) {
					foreach ($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerInfoWindowHook'] as $_classRef) {
						$_procObj = & t3lib_div :: getUserObj($_classRef);
						$marks = $_procObj->extraItemMarkerInfoWindowProcessor($marks, $rows, $this->conf, $this);
					}
				}
				/* modification for by dl_locator_hooks end */


				$infoWindow[$i] = $this->cObj->substituteMarkerArray($subpart, $marks);
				$infoWindow[$i] = preg_replace('#\r?\n#', '', $infoWindow[$i]); // for javascript
				// the second tab
				$subpart = $this->cObj->getSubpart($this->template, "###INFOWINDOW2###");
				$infoWindow2[$i] = $this->cObj->substituteMarkerArray($subpart, $marks);
				$infoWindow2[$i] = preg_replace('#\r?\n#', '', $infoWindow2[$i]); // for javascript

				list ($width, $height, $type, $attr) = getimagesize("$icon");
				///// the markers /////
				$retval .= "
				                      icon" . $i . " = new GIcon();
				                    icon" . $i . ".image = \"" . $icon . "\";
				                    icon" . $i . ".iconSize = new GSize(" . $width . "," . $height . ");
				                    icon" . $i . ".shadow = 'typo3conf/ext/locator/pi1/res/shadow.png';
				                    icon" . $i . ".shadowSize = new GSize(30, 17);
				                    icon" . $i . ".iconAnchor = new GPoint(9, " . $height . ");
				                    icon" . $i . ".infoWindowAnchor = new GPoint(9, 2);
				                    icon" . $i . ".infoShadowAnchor = new GPoint(18, 25);
				                    marker" . $i . " = new GMarker(point,{title:'" . $tooltip[$i] . "'+'',icon:icon" . $i . "});
				                    html" . $i . " = '" . $infoWindow[$i] . "';";

				$retval .= "taba" . $i . "= new GInfoWindowTab('" . $this->pi_getLL('street_label') . "', '" . $infoWindow[$i] . "');";
				$retval .= "tabb" . $i . "= new GInfoWindowTab('" . $this->pi_getLL('toComments') . "', '" . $infoWindow2[$i] . "');";

				$retval .= "tabArray" . $i . " = new Array (taba" . $i . ", tabb" . $i . ");";
				//    GEvent.addListener(marker".$i.", 'mouseover', function() {
				//      marker".$i.".openInfoWindowHtml(html".$i.",{maxWidth:100});
				//    ";
				//if ( $this->conf['routePageId'] > '') {
				//    $retval .= "window.open(\"".$urlResultPage."\", \"_blank\");";
				//}
				$retval .= "

				                    GEvent.addListener(map, 'click', function() {
				                    });

				                    GEvent.addListener(marker" . $i . ", 'click', function() {
				                      marker" . $i . ".openInfoWindowHtml(html" . $i . ",{maxWidth:150});
				                    ";
				if ($this->conf['routePageId'] > '') {
					$retval .= "window.open(\"" . $urlResultPage . "\", \"_blank\");";
				}
				$retval .= "});
				                    GEvent.addListener(marker" . $i . ", 'infowindowopen', function() {
				                        if (document.getElementById('player' + infoWindowId)) document.getElementById('player' + infoWindowId).innerHTML = '';
				                        //alert('open');
				                        infoWindowId = " . $i . ";
				                    });
				                    GEvent.addListener(map, 'infowindowbeforeclose', function() {
				                        if (document.getElementById('player' + infoWindowId)) document.getElementById('player' + infoWindowId).innerHTML = '';
				                    });

				                    GEvent.addListener(marker" . $i . ", 'infowindowclose', function() {
				                        if (document.getElementById('player' + infoWindowId)) document.getElementById('player' + infoWindowId).innerHTML = '';
				                        infoWindowId = -1;
				                    });

				                    gmarkers[" . $i . "] = marker" . $i . ";

				                    GEvent.addListener(marker" . $i . ", 'mouseover', function() {";
				if ($this->conf['showTabbedInfoWindow'])
					$retval .= "if (infoWindowId != " . $i . ")
					                                marker" . $i . ".openInfoWindowTabsHtml(tabArray" . $i . ",{maxWidth:200});";
				else
					$retval .= "if (infoWindowId != " . $i . ")
					                                marker" . $i . ".openInfoWindowHtml(html" . $i . ",{maxWidth:300, maxHeight:200,autoScroll:true});";

				if ($this->conf['showVideoPlayer']) {
					$retval .= " if (document.getElementById('player' + infoWindowId ))
					                                document.getElementById('player' + infoWindowId ).innerHTML = '';";
					$retval .= "player(" . $i . ");";
				}

				$retval .= "});
				                    map.addOverlay(marker" . $i . ");";

				if (substr($this->conf['googleApiVersion'], 0, 1) == '3') {
					$ret .= "var myLatLng = new google.maps.LatLng($lat,$lon);
					                var shadow = new google.maps.MarkerImage('typo3conf/ext/locator/pi1/res/shadow.png',
					                // The shadow image is larger in the horizontal dimension
					                // while the position and offset are the same as for the main image.
					                new google.maps.Size(37, 37),
					                new google.maps.Point(0,0),
					                new google.maps.Point(10, 37));

					                marker[$i] = new google.maps.Marker({
					                position: myLatLng,
					                map: map,
					                icon: '$icon',
					                shadow: shadow
					                });
					                markersArray.push(marker[$i]);
					                infoWindow[$i] = new google.maps.InfoWindow({
					                    content: '$infoWindow[$i]'
					                });
                                    ";

					//    google.maps.event.addListener(marker[$i], 'mouseover', function() {
					//      infoWindow[$i].open(map,marker[$i]);";
					/*
					if ($this->conf['showVideoPlayer'])
					    $ret .= "player(" . $i . ");";
					$ret .= "});";
					*/


		         	$ret .= "infoBubble[$i] = new InfoBubble({
		            content: '<div>$infoWindow[$i]</div>',
					minWidth: 50,
					maxWidth: 300,
					shadowStyle: 1,
					padding: 0,
				//	backgroundColor: 'rgb(57,57,57)',
					borderRadius: 6,
					arrowSize: 10,
					borderWidth: 1,
					borderColor: '#2c2c2c',
					disableAutoPan: false,
					//hideCloseButton: true,
					arrowPosition: 10,
					backgroundClassName: 'phoney',
					arrowStyle: 2

		        });
		            InfoBubble.tabCounter = 0;
				";

			if ($this->conf['enableMarkerMouseover'])
			$ret .= "google.maps.event.addListener(marker[$i], 'mouseover', function() {
	            infoBubble[$i].open(map, marker[$i]);
	            setTimeout('setNotepadState($uid)', 500);";
			if (!$this->conf['enableMultipleInfoWindows'])
				$ret .= "for (w=1; w < infoBubble.length; w++) infoBubble[w].close();";

			if ($this->conf['enableMarkerMouseover'])
				$ret .= "});";



			if ($this->conf['enableMarkerMouseout'])
			$ret .= "google.maps.event.addListener(marker[$i], 'mouseout', function() {
	            infoBubble[$i].close();
	            });";


			if ($this->conf['showTabbedInfoWindow']) {
				$ret .= "
					infoBubble[$i].addTab('" . '<div class="tabLabel">' . $this->pi_getLL('street_label') ." ', '" . $infoWindow[$i] . '</div>' ."','$i' );
					infoBubble[$i].addTab(' " . $this->pi_getLL('toComments') ." ', '$infoWindow2[$i]');
					";
			}

					$ret .= "google.maps.event.addListener(marker[$i], 'click', function() {";
					if (!$this->conf['enableMultipleInfoWindows'])
						$ret .= "for (w=1; w < infoBubble.length; w++) infoBubble[w].close();";
					$ret .= "infoBubble[$i].open(map, marker[$i]);";
//					$ret .= "infoWindow[$i].open(map, marker[$i]);
			            
			            ";

//				                  infoWindow[$i].open(map,marker[$i]);";
					if ($this->conf['enableNotepad'])
						$ret .= "setTimeout('setNotepadState(" . $uid . ")',500);";

					if ($this->conf['showVideoPlayer'])
						$ret .= "setTimeout('player(" . $i . ")', 1000);";
					$ret .= "});";



/*
					$ret .= "google.maps.event.addListener(infoWindow[$i], 'closeclick', function() {
								if (document.getElementById('player" . $i . "')) {
                                    players[$i].close();
                                    players[$i].unload();
                                }
                            });";
*/

				}

			} //end if
		} // end of while loop
		if (substr($this->conf['googleApiVersion'], 0, 1) == '3')
			return $ret;

		return ($retval);
	}
	
	function googleMapsApiCalls() {
		if (!$this->conf['maxGoogleMapsApiCalls'])
		    $this->conf['maxGoogleMapsApiCalls'] = 24000;
		if (!is_file("fileadmin/googleMapsApiCalls.txt")) {
		    $fp = fopen("fileadmin/googleMapsApiCalls.txt", 'a+');
			fclose($fp);
		}

        $usageData = fopen("fileadmin/googleMapsApiCalls.txt","r+");
		$row = fgets($usageData);
		$timestamp = time();
		$date = date("d.m.Y", $timestamp);
		if(substr($row, 0, strpos($row, '#')) == $date){
			//actual date has an entry
			if($this->currentUsage($row) < $this->conf['maxGoogleMapsApiCalls']){
				//max usage not reached
              	$googleMapsApiCallEnabled = true;
			}else{
              	$googleMapsApiCallEnabled = false;
				//no more calls for today
			}
			$newLine = substr($row, strrpos($row, '#')+1)+1;
			$newLine = $date."#".$newLine."\n";
			$this->newEntry($newLine, true);
		}else{
			//actual date has no entry
			$this->newEntry($date."#0\n", false);
			if($this->currentUsage($row) < $this->conf['maxGoogleMapsApiCalls']){
				//max usage not reached
				$googleMapsApiCallEnabled = true;
			}else{
				//no more calls for today
				$googleMapsApiCallEnabled = false;
			}
		}
		//$calls = $this->currentUsage($row) + 1;
		fclose($usageData);

		return $googleMapsApiCallEnabled;
	}

	function currentUsage($rData){
		return trim (substr(strstr($rData, '#'),1));
	}

	function newEntry($entry, $arrShift){
			$arrFile = file("fileadmin/googleMapsApiCalls.txt");
			if($arrShift){
				array_shift($arrFile);
			}
		array_unshift($arrFile, $entry);
		$newData = implode("", $arrFile);
		file_put_contents("fileadmin/googleMapsApiCalls.txt", $newData);
	}



	function showMap($mysql_results = NULL) {
		if ($this->conf['enableNotepad']) 
			$this->getNotepadJS();

	    // chrome did not show videos correct in v 3 api
//		if (eregi('chrome',$_SERVER['HTTP_USER_AGENT']))
//			$this->conf['googleApiVersion'] = '2.208';
		//debug($this->conf);
		//debug($this->input);
		$apiCalls = $this->googleMapsApiCalls();
		if (!$apiCalls)
		    return 'Max. api calls reached!';

		if (!$this->conf['showResultTable'] || $this->input['center']->lat) { // used for singleViews
			// zoom levels 0 to 17, 17 being Country view, 0 being Street closeup
			$zoom = 13;
			if ($this->_GP['radius'] > 500 && $this->_GP['radius'] <= 1000)
				$zoom = 12;
			if ($this->_GP['radius'] <= 500)
				$zoom = 10;
			if ($this->_GP['radius'] <= 100)
				$zoom = 8;
			if ($this->_GP['radius'] <= 25)
				$zoom = 6;
			if ($this->_GP['radius'] < 5)
				$zoom = 4;
			if ($this->_GP['radius'] < 3)
				$zoom = 3;
			if ($this->_GP['radius'] < 2)
				$zoom = 2;
			//$zoom = $this->conf['zoomLevel'];
		} else
			$zoom = 2;
		if ($this->conf['defaultZoomLevel'])
			$zoom = $this->conf['defaultZoomLevel'];
		$google_key = $this->conf['googleApiKey'];

		if ($this->conf['apiV3Layers'])
			$googleLibraries = '&amp;libraries=' . $this->conf['apiV3Layers'];

		if (t3lib_div::inList($this->conf['apiV3Layers'], 'weather'))
		    $showWeatherLayer = 1;
		else $showWeatherLayer = 0;
		if (t3lib_div::inList($this->conf['apiV3Layers'], 'traffic'))
		    $showTrafficLayer = 1;
		else $showTrafficLayer = 0;
		if (t3lib_div::inList($this->conf['apiV3Layers'], 'panoramio'))
		    $showPanoramioLayer = 1;
		else $showPanoramioLayer = 0;
		if (t3lib_div::inList($this->conf['apiV3Layers'], 'bicycling'))
		    $showBicyclingLayer = 1;
		else $showBicyclingLayer = 0;


		if ($this->conf['enableMarkerClusterer']) 
			$enableMarkerClusterer = 1;
		else $enableMarkerClusterer = 0;


		if (!$this->conf['disableLoadInBodyTag']) {
			// Den Aufruf des JS in den Bodytag schreiben.
			// und vorhandene tags mit uebernehmen
//			$tags = explode('"', $GLOBALS['TSFE']->pSetup['bodyTag']);
//			$GLOBALS['TSFE']->pSetup['bodyTag'] = '';
//			$GLOBALS['TSFE']->JSeventFuncCalls['onload'][$this->pObj->prefixId] = 'load();' . $tags[1];

			// don't touch ids and classes in body tag - only onload
			preg_match("@onload=(\")(.*)\g1@iU", $GLOBALS['TSFE']->pSetup['bodyTag'], $tags);
			$GLOBALS['TSFE']->pSetup['bodyTag'] = preg_replace("@onload=(\")(.*)\g1@iU", "", $GLOBALS['TSFE']->pSetup['bodyTag']);
			$GLOBALS['TSFE']->JSeventFuncCalls['onload'][$this->pObj->prefixId] = 'load();' . $tags[2];


		}
		$GLOBALS['TSFE']->JSeventFuncCalls['onunload'][$this->pObj->prefixId] = 'GUnload();';

		$center_lat_float = $this->_GP['lat'];
		$center_lon_float = $this->_GP['lon'];

		if ($this->input['center']->lat) {
			$center_lat_float = $this->input['center']->lat;
			$center_lon_float = $this->input['center']->lon;
		}

		if ($this->conf['showResultTable']) {
			if ($this->conf['distanceUnit'] == 'miles')
				$this->_GP['distance'] = number_format($this->_GP['distance'] / 1.6, 2, '.', '');
			if ($this->_GP['company'] != '' && $this->conf['feUserListingPageId'] == 0) {
				if ($this->_GP['link'] != '')
					$marks['###COMPANYV###'] = $this->pi_linkToPage($this->_GP['company'], $this->_GP['link']);
				else
					$marks['###COMPANYV###'] = $this->_GP['company'];
			}
			if ($this->_GP['company'] != '' && $this->conf['feUserListingPageId'] != 0) {
				if ($this->_GP['link'] != '') {
					$params['tx_feuserlisting_pi1[showUid]'] = $this->_GP['uid'];
					$marks['###COMPANYV###'] = $this->pi_linkToPage($this->_GP['company'], $this->conf['feUserListingPageId'], '_top', $params);
				} else
					$marks['###COMPANYV###'] = $this->_GP['company'];
			} else
				$marks['###COMPANYV###'] = '';

			//            if ($this->_GP['url'] != '' ) $marks['###STORENAMEV###'] = $this->pi_linkToPage($this->_GP['storename'], $this->_GP['url']);
			//            else $marks['###STORENAMEV###'] = stripslashes($this->_GP['storename']);
			$linkParams = array ();
			if ($this->_GP['link'] != '')
				$marks['###STORENAMEV###'] = $this->cObj->getTypoLink($this->_GP['storename'], $this->_GP['link'], $linkParams, $this->conf['linkTarget']);
			else
				$marks['###STORENAMEV###'] = stripslashes($this->_GP['storename']);

			$marks['###FIRSTNAMEV###'] = $this->_GP['firstName'];
			$marks['###LASTNAMEV###'] = $this->_GP['lastName'];

			$marks['###COMPANYV###'] = $this->_GP['company'];
			$marks['###NAMETITLEV###'] = $this->_GP['nameTitle'];
			$marks['###CATEGORYV###'] = $this->_GP['category'];
			$marks['###CONTACTPERSONV###'] = $this->_GP['contactPerson'];
			$marks['###ZIPCODEV###'] = $this->_GP['zipcode'];
			$marks['###CITYV###'] = stripslashes($this->_GP['city']);
			$marks['###ADDRESSV###'] = stripslashes($this->_GP['address']);
			$marks['###ADDITIONALADDRESSV###'] = stripslashes($this->_GP['additionalAddress']);
			$marks['###COUNTRYV###'] = $this->_GP['country'];
			$marks['###PHONEV###'] = $this->_GP['phone'];
			$marks['###HOURSV###'] = nl2br($this->_GP['hours']);
			if ($this->_GP['phone']) {
				$marks['###PHONE###'] = $this->pi_getLL('phone');
			} else
				$marks['###PHONE###'] = '';
			$marks['###MOBILEV###'] = $this->_GP['mobile'];
			if ($this->_GP['mobile']) {
				$marks['###MOBILE###'] = $this->pi_getLL('mobile');
			} else
				$marks['###MOBILE###'] = '';
			$marks['###FAXV###'] = $this->_GP['fax'];
			if ($this->_GP['fax']) {
				$marks['###FAX###'] = $this->pi_getLL('fax');
			} else
				$marks['###FAX###'] = '';

			$marks['###EMAILV###'] = $this->cObj->getTypoLink($this->_GP['email'], $this->_GP['email']);
			if ($this->_GP['email']) {
				$marks['###EMAIL###'] = $this->pi_getLL('email');
			} else {
				$marks['###EMAIL###'] = '';
			}

			$marks['###COMMENTSV###'] = $this->_GP['comments'];

			$marks['###PURESTORENAMEV###'] = $this->_GP['storename'];

			$linkParams = array ();
			$marks['###LINKV###'] = $this->cObj->getTypoLink($this->_GP['link'], $this->_GP['link'], $linkParams, $this->conf['linkTarget']);
			if ($this->_GP['link']) {
				$marks['###LINK###'] = $this->pi_getLL('link');
			} else {
				$marks['###LINK###'] = '';
			}

			// now the store attributes
			$attribs = explode(',', $this->_GP['attributes']);

			$marks['###ATTRIBUTESV###'] = '';
			if (count($attribs) && $attribs[0] != '') {
				$marks['###ATTRIBUTESV###'] = '<ul class="attributesList">';
				for ($i = 0; $i < count($attribs); $i++) {
					list ($attributeName, $attributeIcon) = explode(':', $attribs[$i]);
					$marks['###ATTRIBUTESV###'] .= '<li><img src="uploads/tx_locator/' . $attributeIcon . '"/><span class="text">' . $attributeName . '</span></li>';
				}
				$marks['###ATTRIBUTESV###'] .= '</ul>';
			}
			$marks['###STOREIDV###'] = $this->_GP['storeId'];

			if (t3lib_extMgm :: isLoaded('locatorfeuser')) {
				$marks['###TX_LOCATORFEUSER_NAMETITLEV###'] = $this->_GP['tx_locatorfeuser_nameTitle'];
				$marks['###TX_LOCATORFEUSER_FIRSTNAMEV###'] = $this->_GP['tx_locatorfeuser_firstname'];
				$marks['###TX_LOCATORFEUSER_QUALIFICATIONV###'] = $this->_GP['locatorfeuser_qualification'];
				$marks['###TX_LOCATORFEUSER_GENERALTRAININGV###'] = $this->_GP['locatorfeuser_generaltraining'];
				$marks['###TX_LOCATORFEUSER_ACTUALTRAININGV###'] = $this->_GP['locatorfeuser_actualtraining'];
				$marks['###TX_LOCATORFEUSER_REFERENCESV###'] = $this->_GP['locatorfeuser_references'];
				$marks['###TX_LOCATORFEUSER_PREFBILLINGV###'] = $this->_GP['locatorfeuser_prefbilling'];
			}

			// now render additional content elements
			$contentArray = explode(',', $this->_GP['content']);
			foreach ($contentArray as $val) {
				$cont = array (
					'tables' => 'tt_content',
					'source' => (int) $val,
					'dontCheckPid' => 1
				);
				$marks['###CONTENTV###'] .= '<div class="additionalContent' . $val . '">' . $this->cObj->RECORDS($cont) . '</div>';
			}

			$arr = array (
				'tx_locator_pi1[mode]' => 'clearCookie',

			);
			if ($this->conf['useCookie']) {
				$arr = array (
					'tx_locator_pi1[mode]' => 'clearCookie',

				);
				$marks['###NEWSEARCHLINKV###'] = '<a href="' . $this->pi_getPageLink($GLOBALS['TSFE']->id, '', $arr) .
				'" onclick="clearCookie();">' . $this->pi_getLL('newSearch') . '</a>';
			} else
				$marks['###NEWSEARCHLINKV###'] = '';

			$marks['###HOURS###'] = nl2br($this->_GP['hours']);
			$marks['###NOTES###'] = nl2br(stripslashes($this->_GP['notes']));
			$marks['###IMAGEV###'] = '';
			if ($this->conf['useFeUserData'] == 0 && $this->_GP['image'] > '')
				if (strpos($this->_GP['image'], 'tx_locator') > 0) {
					$marks['###IMAGEV###'] = $this->_GP['image'];
					$image = $this->_GP['image'];
				} else {
					$marks['###IMAGEV###'] = '<img src="/uploads/tx_locator/' . $this->_GP['image'] . '"/>';
					$image = 'uploads/tx_locator/' . $this->_GP['image'];
				}
			if ($this->conf['useFeUserData'] == 4)
				if ($this->_GP['image'] > '')
					if ($this->conf['displayMode'] == 'singleView') {
						$marks['###IMAGEV###'] = '<img src="/uploads/pics/' . $this->_GP['image'] . '"/>';
						$image = 'uploads/pics/' . $this->_GP['image'];
					} else {
						$marks['###IMAGEV###'] = $this->_GP['image'];
						$image = $this->_GP['image'];
					}
				else
					$marks['###IMAGEV###'] = '';

			if ($this->conf['useFeUserData'] == 1 || $this->conf['useFeUserData'] == 2 || $this->conf['useFeUserData'] == 3) {
				$marks['###IMAGEV###'] = $this->_GP['image'];
				$image = $this->_GP['image'];
			}
			if ($this->conf['useFeUserData'] == 1 && t3lib_extMgm :: isLoaded('sr_feuser_register')) {
				// 22.07.2010
				if (strpos($this->_GP['image'], 'img src') == 0) {
					$marks['###IMAGEV###'] = '<img src="uploads/tx_srfeuserregister/' . $this->_GP['image'] . '"/>';
					if (strpos($this->_GP['image'], 'tx_srfeuserregister/') == 0)
						$image = 'uploads/tx_srfeuserregister/' . $this->_GP['image'];
					else
						$image = $this->_GP['image'];
				}
			}
			$this->conf['singleView.']['image.']['file'] = $image;
			$marks['###IMAGEV###'] = $this->cObj->IMAGE($this->conf['singleView.']['image.']);

			// external location table
			if ($this->conf['useFeUserData'] == 2 && $this->conf['showStoreImage'] && $this->conf['externalLocationTable'] == 'tx_cal_location') {
				if (strpos($this->_GP['image'], 'tooltipImage') > 0)
					$marks['###IMAGEV###'] = $this->_GP['image'];
				else
					$marks['###IMAGEV###'] = '<img src="uploads/tx_cal/pics/' . $this->_GP['image'] . '"/>';
			}

			if ($this->_GP['media']) $marks['###MEDIADISPLAYV###'] = 'block';
			else $marks['###MEDIADISPLAYV###'] = 'none';
			$marks['###MEDIAV###'] = '/uploads/tx_locator/media/' . $this->_GP['media'];


			if ($this->conf['displayMode'] != 'singleView' && !$this->_GP['multiRouteAddresses'])
				$marks['###DISTANCEV###'] = $this->_GP['distance'] .
				' ' . $this->pi_getLL($this->conf['distanceUnit']);
			else
				$marks['###DISTANCEV###'] = '';

			if ($this->_GP['distance'])
				$marks['###DISTANCEV###'] = $this->_GP['distance'] .
				' ' . $this->pi_getLL($this->conf['distanceUnit']);

			if ($this->conf['useCookie'] && $_COOKIE['tx_locator_storeuid'] != '')
				$marks['###DISTANCEV###'] = floatval($_COOKIE['tx_locator_distance']) . ' ' . $this->pi_getLL($this->conf['distanceUnit']);

			if ($this->_GP['storeUid'])
				$marks['###UID###'] = $this->_GP['storeUid']; // needed for locatorfeuser
			else
				$marks['###UID###'] = $this->_GP['uid'];

			// add hook for processing of extra item markers
			if (is_array($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerShowMapHook'])) {
				foreach ($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerShowMapHook'] as $_classRef) {
					$_procObj = & t3lib_div :: getUserObj($_classRef);
					$marks = $_procObj->extraItemMarkerShowMapProcessor($marks, $row, $this->conf, $this);
				}
			}



			//debug($this->_GP, 'showMap');
			$map_results = $this->prepareMapResults($mysql_results);
			$subpart = $this->cObj->getSubpart($this->template, "###MAP###");
			$content = $this->cObj->substituteMarkerArray($subpart, $marks);

		} else { // used for mapAllViews
			/*********************************************
			 *											 *
			 *		preparing the map					 *
			 *											 *
			 *********************************************/				
			$map_results = $this->prepareMapAllResults($mysql_results);

			if (is_resource($mysql_results)) 
			$marks['###NUMBEROFSTORES###'] = mysql_num_rows($mysql_results);

			if (!is_resource($mysql_results)) {
				$marks['###NUMBEROFSTORES###'] = $GLOBALS['TYPO3_DB']->sql_num_rows($mysql_results);			
			}


			$marks['###FOUNDTEXT###'] = $this->conf['storeTitle'] . '&nbsp;' . $this->pi_getLL('foundText') . '&nbsp;' . $this->_GP['radius'] . ' ' .
			'&nbsp;' . $this->pi_getLL($this->conf['distanceUnit']);
			$marks['###POITABLE###'] = '';

			if ($this->_GP['mode'] == 'mapAllNoFormView' && $this->conf['showPoiTable'] == 1 || ($this->conf['displayMode'] == 'mapAllView' && $this->_GP['mode'] == 'search' && $this->conf['showPoiTable'] == 1)) {
				//mysql_data_seek($mysql_results, 0);

				$GLOBALS['TYPO3_DB']->sql_data_seek($mysql_results, 0);

				// delete old poitables in uploads/tx_locator/temp/
				$destDir = PATH_site . 'uploads/tx_locator/temp/';
				if (!is_dir($destDir))
					mkdir($destDir);
				$curDir = opendir($destDir);
				while ($file = readdir($curDir)) {
					if (preg_match('%^poitable.*$%', $file)) {
						if (time() - filemtime($destDir . $file) > 3600)
							unlink($destDir . $file);
					}
				}

				// create temporary file
				$file = 'poitable.' . $_SERVER['REMOTE_ADDR'] . '.' . (string) time() . '.html';
				$fHandle = fopen($destDir . $file, 'w');

				$poiTable = $this->cObj->getSubpart($this->template, "###POITABLE_HEADER###");

				$marks['###SEARCHRESULTSFROM###'] = $this->pi_getLL('searchResultsFrom');
				$marks['###DATE###'] = date('d.m.Y', time());

				// add hook for processing of extra item markers
				if (is_array($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerPoiHeaderHook'])) {
					foreach ($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerPoiHeaderHook'] as $_classRef) {
						$_procObj = & t3lib_div :: getUserObj($_classRef);
						$marks = $_procObj->extraItemMarkerMapAllProcessor($marks, $this->conf, $this);
					}
				}



				$poiTable = $this->cObj->substituteMarkerArray($this->cObj->getSubpart($this->template, "###POITABLE_HEADER###"), $marks);
				$htmlTable = $this->cObj->substituteMarkerArray($this->cObj->getSubpart($this->template, "###HTMLPOITABLE_HEADER###"), $marks);
				$i = 1;
				$poiSubpart = $this->cObj->getSubpart($this->template, "###POITABLE_DATA###");
				$htmlSubpart = $this->cObj->getSubpart($this->template, "###HTMLPOITABLE_DATA###");
				while ($rows = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($mysql_results)) {
					$marks['###EVEN###'] = ($i % 2 == 0) ? 'class="even"' : 'class="odd"';
					$marks['###ROWCOUNT###'] = $i;
					$marks['###MOUSE###'] = 'onmouseover="openInfoWindow(' . $i++ . ');" style="cursor:pointer;"';
					//$i++;
					$marks['###COMPANY###'] = $rows['company'];
					$linkParams = array ();
					$marks['###STORENAME###'] = $this->cObj->getTypoLink($rows['storename'], $rows['url'], $linkParams, $this->conf['linkTarget']);
					;

					$this->conf['resultTableView.']['image.']['file'] = 'uploads/tx_locator/' . $rows['image'];
					$marks['###IMAGE###'] = $this->cObj->IMAGE($this->conf['resultTableView.']['image.']);

					$marks['###NAME###'] = $rows['name'];
					$marks['###ZIPCODE###'] = $rows['zipcode'];
					$marks['###CITY###'] = $rows['city'];

					// external location table
					if ($this->conf['useFeUserData'] == 2 && $this->conf['externalLocationTable'] == 'tx_cal_location') {
						$image = 'uploads/tx_cal/pics/' . $rows['image'];
						$rows['zipcode'] = $rows['zip'];
						$rows['address'] = $rows['street'];
						$rows['url'] = $rows['link'];
					}
					// tt_news
					if ($this->conf['useFeUserData'] == 3)
						$marks['###COUNTRY###'] = $rows['tx_locator_country'];
					else $marks['###COUNTRY###'] = $rows['country'];
					$marks['###ADDRESS###'] = $rows['address'];
					$marks['###ADDITIONALADDRESS###'] = $rows['additionaladdress'];
					$marks['###CONTACTPERSON###'] = $rows['contactperson'];
					$marks['###PHONE###'] = $rows['phone'];
					$marks['###FAX###'] = $rows['fax'];
					$marks['###NAMETITLE###'] = $rows['title'];
					$marks['###MOBILE###'] = $rows['mobile'];
					$marks['###EMAIL###'] = $rows['email'];
					$marks['###EMAILV###'] = $this->cObj->getTypoLink($rows['email'], $rows['email']);
					$marks['###URL###'] = $rows['url'];

					$marks['###UIDV###'] = $rows['uid'];
					if ($this->conf['distanceUnit'] == 'miles')
						$rows['distance'] = $rows['distance'] / 1.6;
					$marks['###DISTANCEV###'] = number_format($rows['distance'], 1, ',', '.');
					$marks['###DISTANCEUNIT###'] = $this->pi_getLL($this->conf['distanceUnit']);

					if ($this->conf['useNotesInternal'])
						$rows['notes'] = '';
					$marks['###NOTES###'] = $rows['notes'];
					$marks['###HOURS###'] = $rows['hours'];
					$marks['###PRODUCTS###'] = $rows['products'];

					// now the store attributes
					$attribs = explode(',', $rows['attributes']);
					if (count($attribs)) {
						$marks['###ATTRIBUTESV###'] = '<ul class="attributesList">';
						for ($j = 0; $j < count($attribs); $j++) {
							list ($attributeName, $attributeIcon) = explode(':', $attribs[$j]);
							$marks['###ATTRIBUTESV###'] .= '<li><img src="uploads/tx_locator/' . $attributeIcon . '"/><span class="text">' . $attributeName . '</span></li>';
						}
						$marks['###ATTRIBUTESV###'] .= '</ul>';
					}
					$marks['###STOREIDV###'] = $rows['storeid'];

					$marks['###TX_LOCATORFEUSER_FIRSTNAME###'] = $rows['tx_locatorfeuser_firstname'];

        			if ($this->conf['ttNewsSinglePid']) {
                        $urlParams = array (
                            'id' => $this->conf['ttNewsSinglePid'],
                            'tx_ttnews[tt_news]' => $rows['uid'],
							'tx_locator_pi1[startLat]' => $this->_GP['lat_lon']->lat,
							'tx_locator_pi1[startLon]' => $this->_GP['lat_lon']->lon
                        );

						// for tt_news detail link
						if (!$this->conf['ttNewsDetailViewLink']) $this->conf['ttNewsDetailViewLink'] = 'Details';
						$token = $this->conf['ttNewsDetailViewLink'];
						$allowCaching = 1;
						$linkWrap = $this->pi_linkTP($token, $urlParams,
						$allowCaching);
						$marks['###TTNEWSSINGLEVIEWLINK###'] = $linkWrap;
					}

					// add hook for processing of extra item markers
					if (is_array($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerPoiItemHook'])) {
						foreach ($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerPoiItemHook'] as $_classRef) {
							$_procObj = & t3lib_div :: getUserObj($_classRef);
							$marks = $_procObj->extraItemMarkerMapAllProcessor($marks, $rows, $this->conf, $this);
						}
					}


					$poiTable .= $this->cObj->substituteMarkerArray($poiSubpart, $marks);
					$htmlTable .= $this->cObj->substituteMarkerArray($htmlSubpart, $marks);
				}

				$poiTable .= $this->cObj->getSubpart($this->template, "###POITABLE_FOOTER###");
				$marks['###PRINTLINK###'] = '<div class="printLink">';
				$marks['###PRINTLINK###'] .= '<a href="' . 'uploads/tx_locator/temp/' . $file . '" target="_blank">' .
				'<img src="typo3conf/ext/locator/pi1/res/printLink.gif" alt="' . $this->pi_getLL('printPoiTable') .
				'" title="' . $this->pi_getLL('printPoiTable') . '"/></a></div>';
				$htmlTable .= $this->cObj->getSubpart($this->template, "###HTMLPOITABLE_FOOTER###");
				$marks['###POITABLE###'] = $poiTable;
				fwrite($fHandle, $htmlTable . '</div>');
				fwrite($fHandle, '</body></html>');
				fclose($fHandle);

			}
			// add hook for processing of extra item markers
			if (is_array($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerMapAllHook'])) {
				foreach ($GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['locator']['extraItemMarkerMapAllHook'] as $_classRef) {
					$_procObj = & t3lib_div :: getUserObj($_classRef);
					$marks = $_procObj->extraItemMarkerMapAllProcessor($marks, $this->conf, $this);
				}
			}
			
			$subpart = $this->cObj->getSubpart($this->template, "###MAPALL###");
			$content = $this->cObj->substituteMarkerArray($subpart, $marks);
		}
		$mapicon_you = t3lib_extMgm :: siteRelPath('locator') . 'pi1/icons/pointerRed.gif';
		list ($mapicon_you_width, $mapicon_you_height, $type, $attr) = getimagesize("$mapicon_you");
		// routing map
		if ($this->conf['showRoute']) {
			// needed when multiple startingpoints occurs
			if (strpos($this->_GP['startCity'], ',') > 0) {
				$s = explode(',', $this->_GP['startCity']);
				$this->_GP['startCity'] = $s[1];
				$this->_GP['startAddress'] = $s[0];
			}
			if ($this->_GP['startLat'] != '')
				$routeAddresses = 'from: ' . $this->_GP['startLat'] . ',' . $this->_GP['startLon'] .
				' to: ' . $this->_GP['lat'] . ',' . $this->_GP['lon'];
			else
				$routeAddresses = 'from: ' . $this->_GP['startAddress'] . ',' . $this->_GP['startCity'] . ',' . $this->_GP['startZipcode'] . ',' .
				$this->_GP['startCountry'] . ' to: ' . $this->_GP['lat'] . ',' . $this->_GP['lon'];
			$locale = '{"locale":"' . $GLOBALS['TSFE']->config['config']['language'] . '"}';
			//    "from: " + "Ringstrasse 1,Herbolzheim,DE" + " to: " + "Elzstrasse 10,Rheinhausen,DE",
			//  { "locale": "DE" }

			//debug($routeAddresses);

			// route_v3.js
			$distance = $this->pi_getLL('distanceTitle');
			$distanceUnit = $this->pi_getLL($this->conf['distanceUnit']);
			$language = $GLOBALS['TSFE']->config['config']['language'];
			if ($this->_GP['startLat'] != '')
				$start = $this->_GP['startLat'] . ',' . $this->_GP['startLon'];
			else
				$start = $this->_GP['startAddress'] . ',' . $this->_GP['startCity'] . ',' . $this->_GP['startZipcode'] .
				',' . $this->_GP['startCountry'];
			$end = $this->_GP['lat'] . ',' . $this->_GP['lon'];
			// route_v3.js end

			// if googleErrorPageId ist set and and error occurs in routeView
			// switch to this page
			if ($this->conf['googleErrorPageId'] > 0) {
				$arr = array (
					'tx_locator_pi1[uid]' => $this->_GP['storeUid'],
					'tx_locator_pi1[mode]' => 'listView',

				);
				$pageLink = $this->pi_getPageLink($this->conf['googleErrorPageId'], '_top', $arr);
			}
			// the additional layers
			if ($this->conf['enableMoreButton']) {
				$enableMoreButton = 1;
				$moreButtonLabel = $this->pi_getLL('moreButton');
			} else
				$enableMoreButton = 0;

			$jsfile = addslashes(implode('', @ file(t3lib_extMgm :: siteRelPath('locator') . 'route.js')));

			if (substr($this->conf['googleApiVersion'], 0, 1) == '3')
				$jsfile = addslashes(implode('', @ file(t3lib_extMgm :: siteRelPath('locator') . 'route_v3.js')));

			$multiRoute = ($this->_GP['multiRouteAddresses'] != '') ? 1 : 0; // switch for multiRoutes, used in route.js
			if ($multiRoute) {
				$routeAddressesArray = '"' . $this->_GP['startAddress'] . ',' . $this->_GP['startCity'] . ',' . $this->_GP['startZipcode'] . ',' . $this->_GP['startCountry'] . '"';
				$a = explode(':', substr($this->_GP['multiRouteAddresses'], 0, strlen($this->_GP['multiRouteAddresses']) - 1));
				while (list ($i, $val) = each($a)) {
					if ($val != '')
						$routeAddressesArray .= ',"' . $val . '"';
					// route_v3.js
					$wayPoints .= 'wayPoints.push({location:"' . $val . '",stopover:true});';
					$end = $val;
					// route_v3.js end

				}
				$routeAddressesArray .= ',"' . $this->_GP['startAddress'] . ',' . $this->_GP['startCity'] . ',' . $this->_GP['startZipcode'] . ',' . $this->_GP['startCountry'] . '"';
			}
			//debug($routeAddressesArray);
			//debug($this->_GP);
		}
		// normal map
		else {
			if ($this->conf['enableMoreButton']) {
				$enableMoreButton = 1;
				$moreButtonLabel = $this->pi_getLL('moreButton');
			} else
				$enableMoreButton = 0;

			$jsfile = addslashes(implode('', @ file(t3lib_extMgm :: siteRelPath('locator') . 'map.js')));

			if (substr($this->conf['googleApiVersion'], 0, 1) == '3')
		        $jsfile = addslashes(implode('', @ file(t3lib_extMgm :: siteRelPath('locator') . 'map_v3.js')));

		}
		if ($this->conf['displayMode'] == 'mapAllView')
			$mapId = 'mapAll';
		else
			$mapId = 'map';
		$googleApiVersion = $this->conf['googleApiVersion'];
		$enableStreetView = $this->conf['enableStreetView'];
		if (!$this->conf['enableStreetViewOverlay'])
			$this->conf['enableStreetViewOverlay'] = 0;
		$enableStreetViewOverlay = $this->conf['enableStreetViewOverlay'];

		/****************************************
		*   additional layers                   *
		****************************************/
		if ($this->conf['enableMoreButton'] && $this->conf['additionalLayers'] > '') {
			$addLayers = explode(';', preg_replace('/\n/', ';', $this->conf['additionalLayers']));
			for ($i = 0; $i < count($addLayers); $i++) {
				$layer = explode(',', $addLayers[$i]);
				$layers .= 'layers[' . $i . '] = new GLayer("' . $layer[1] . '");';
				if ($layer[2] == 1) {
					$layers .= 'map.addOverlay(layers[' . $i . ']);';
					$layers .= 'layers[' . $i . '].Visible = true;';
					$layers .= 'layers[' . $i . '].Added = true;';
					$layersControl .= '"' . $layer[0] . '",';
				} else {
					$layers .= 'layers[' . $i . '].Visible = false;';
					$layers .= 'layers[' . $i . '].Added = false;';
					$layersControl .= '"' . $layer[0] . '",';
				}
			}
			$layersControl = substr($layersControl, 0, strlen($layersControl) - 1);
			$layers .= 'layerControl = new LayerControl([' . $layersControl . ']);';
		}
		if ($this->conf['defaultMapType'] > '')
			$defaultMapType = $this->conf['defaultMapType'];
		else
			$defaultMapType = 'ROADMAP';

		eval ("\$javascript = \"$jsfile\";");

		$content .= stripslashes($javascript);

		return $content;
	}

	function showZipcodeAreas() {
		// Den Aufruf des JS in den Bodytag schreiben.
		// und vorhandene tags mit uebernehmen
//		$tags = explode('"', $GLOBALS['TSFE']->pSetup['bodyTag']);
//		$GLOBALS['TSFE']->pSetup['bodyTag'] = '';
//		$GLOBALS['TSFE']->JSeventFuncCalls['onload'][$this->pObj->prefixId] = 'load();' . $tags[1];
//		$GLOBALS['TSFE']->JSeventFuncCalls['onunload'][$this->pObj->prefixId] = 'GUnload();';

		// don't touch ids and classes in body tag - only onload
		preg_match("@onload=(\")(.*)\g1@iU", $GLOBALS['TSFE']->pSetup['bodyTag'], $tags);
		$GLOBALS['TSFE']->pSetup['bodyTag'] = preg_replace("@onload=(\")(.*)\g1@iU", "", $GLOBALS['TSFE']->pSetup['bodyTag']);
		$GLOBALS['TSFE']->JSeventFuncCalls['onload'][$this->pObj->prefixId] = 'load();' . $tags[2];

		//        debug($this->input);

//		$jsfile = addslashes(implode('', @ file(t3lib_extMgm :: siteRelPath('locator') . 'map.js')));
		$jsfile = addslashes(implode('', @ file(t3lib_extMgm :: siteRelPath('locator') . 'map_v3.js')));


		if ($this->conf['zoomZipcodeArea'] != '')
			$zoom = $this->conf['zoomZipcodeArea'];
		else {
			$zoom = 3;
			if ($this->_GP['radius'] > 500 && $this->_GP['radius'] <= 1000)
				$zoom = 12;
			if ($this->_GP['radius'] <= 500)
				$zoom = 10;
			if ($this->_GP['radius'] <= 100)
				$zoom = 8;
			if ($this->_GP['radius'] <= 25)
				$zoom = 7;
			if ($this->_GP['radius'] < 5)
				$zoom = 4;
			if ($this->_GP['radius'] < 3)
				$zoom = 4;
			if ($this->_GP['radius'] < 2)
				$zoom = 4;
		}

		$center_lat_float = (float) $this->input['center_lat'];
		$center_lon_float = (float) $this->input['center_lon'];
		$mapId = 'map';
		$defaultMapType = 'ROADMAP';
		$enableStreetViewOverlay = 1;

		if ($this->conf['apiV3Layers'])
			$googleLibraries = '&amp;libraries=' . $this->conf['apiV3Layers'];

		if (t3lib_div::inList($this->conf['apiV3Layers'], 'weather'))
		    $showWeatherLayer = 1;
		else $showWeatherLayer = 0;
		if (t3lib_div::inList($this->conf['apiV3Layers'], 'traffic'))
		    $showTrafficLayer = 1;
		else $showTrafficLayer = 0;
		if (t3lib_div::inList($this->conf['apiV3Layers'], 'panoramio'))
		    $showPanoramioLayer = 1;
		else $showPanoramioLayer = 0;
		if (t3lib_div::inList($this->conf['apiV3Layers'], 'bicycling'))
		    $showBicyclingLayer = 1;
		else $showBicyclingLayer = 0;
		
		$icon = 'pointerRed.png';

		$marks = array ();
		$subpart = $this->cObj->getSubpart($this->template, "###ZIPCODEMAP###");
		$content = $this->cObj->substituteMarkerArray($subpart, $marks);

		$retval .= "var myLatLng = new google.maps.LatLng(" . $center_lat_float . "," . $center_lon_float . ");
		                var shadow = new google.maps.MarkerImage('typo3conf/ext/locator/pi1/res/shadow.png',
		                // The shadow image is larger in the horizontal dimension
		                // while the position and offset are the same as for the main image.
		                new google.maps.Size(37, 37),
		                new google.maps.Point(0,0),
		                new google.maps.Point(10, 37));

		                var marker = new google.maps.Marker({
		                position: myLatLng,
		                map: map,
		                icon: 'uploads/tx_locator/$icon',
		                shadow: shadow
		                });

		                ";

// now the polygon

  		$retval .= " var polygonCoords = Array();
	  	  	";
		for ($i = 0; $i < count($this->input['zipcode']); $i++) {
			if ($i == 0) {
				$endLat = $this->input['lat'][$i];
				$endLon = $this->input['lon'][$i];
			}
			if ($zipcode != $this->input['zipcode'][$i] || $area != $this->input['area'][$i]) {
				$retval .= 'p = new google.maps.LatLng(' . $endLat . ',' . $endLon . ');';
				$retval .= 'polygonCoords.push(p);';

		$retval .= "
	  		var polygon = new google.maps.Polygon({
	      	paths: polygonCoords,
	      	strokeColor: '#00008F',
	      	strokeOpacity: 0.8,
	      	strokeWeight: 3,
	      	fillColor: '#000080',
	      	fillOpacity: 0.1  });  			
			
			polygon.setMap(map);		
			var polygonCoords = Array();
		";

				$zipcode = $this->input['zipcode'][$i];
				$area = $this->input['area'][$i];
				$endLat = $this->input['lat'][$i];
				$endLon = $this->input['lon'][$i];
			}
			$retval .= 'p = new google.maps.LatLng(' . $this->input['lat'][$i] . ',' . $this->input['lon'][$i] . ');';
			$retval .= 'polygonCoords.push(p);';
		}
//		$retval .= 'p = new google.maps.LatLng(' . $endLat . ',' . $endLon . ');';
//		$retval .= 'polygonCoords.push(p);';


		$retval .= "
	  		var polygon = new google.maps.Polygon({
	      	paths: polygonCoords,
	      	strokeColor: '#00008F',
	      	strokeOpacity: 0.8,
	      	strokeWeight: 3,
	      	fillColor: '#000080',
	      	fillOpacity: 0.1  });  			
			
			polygon.setMap(map);		
		";

		$map_results = $retval;

		eval ("\$javascript = \"$jsfile\";");
		$content .= stripslashes($javascript);
		return $content;


	}


	function cleanHTML($html) {
		$doc = new DOMDocument();
		
		// load the HTML string we want to strip
		$doc->loadHTML($html);
		
		// get all the script tags
		$script_tags = $doc->getElementsByTagName('script');
		
		$length = $script_tags->length;
		
		// for each tag, remove it from the DOM
		for ($i = 0; $i < $length; $i++) {
		  $script_tags->item($i)->parentNode->removeChild($script_tags->item($i));
		}
		
		// get the HTML string back
		$clean = $doc->saveHTML();
		return $clean;

	}



	/* Returns the $msg in error div-tags
	 *
	 * @param   $msg        string, messagestring
	 * @return     String        HTML wrapped error message
	 *
	 */
	function showError($msg) {
		return '<div class="errorMessage">' . 'locator_view message: ' . $this->errorMessages[$msg] . '</div>';
	}

//	var $errorMessages = array ();
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/locator/pi1/class.tx_locator_view.php']) {
	include_once ($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/locator/pi1/class.tx_locator_view.php']);
}
?>