<?php
if (!defined ('TYPO3_MODE')) 	die ('Access denied.');

$TCA["tx_locator_locations"] = array (
	"ctrl" => $TCA["tx_locator_locations"]["ctrl"],
	"interface" => array (
		"showRecordFieldList" => "hidden,endtime,fe_group,storename,storeid,address,additionaladdress,contactperson,city,state,zipcode,country,attributes,products,phone,mobile,hours,url,notes,imageurl,icon,content,use_coordinate,categories,lat,lon,geocode"
	),
	"feInterface" => $TCA["tx_locator_locations"]["feInterface"],
	"columns" => array (
		'hidden' => array (
			'exclude' => 1,
			'label'   => 'LLL:EXT:lang/locallang_general.xml:LGL.hidden',
			'config'  => array (
				'type'    => 'check',
				'default' => '0'
			)
		),
		'endtime' => array (		
			'exclude' => 1,
			'label'   => 'LLL:EXT:lang/locallang_general.xml:LGL.endtime',
			'config'  => array (
				'type'     => 'input',
				'size'     => '8',
				'max'      => '20',
				'eval'     => 'date',
				'checkbox' => '0',
				'default'  => '0',
				'range'    => array (
					'upper' => mktime(0, 0, 0, 12, 31, 2020),
					'lower' => mktime(0, 0, 0, date('m')-1, date('d'), date('Y'))
				)
			)
		),
		'fe_group' => array (		
			'exclude' => 1,
			'label'   => 'LLL:EXT:lang/locallang_general.xml:LGL.fe_group',
			'config'  => array (
				'type'  => 'select',
				'items' => array (
					array('', 0),
					array('LLL:EXT:lang/locallang_general.xml:LGL.hide_at_login', -1),
					array('LLL:EXT:lang/locallang_general.xml:LGL.any_login', -2),
					array('LLL:EXT:lang/locallang_general.xml:LGL.usergroups', '--div--')
				),
				'foreign_table' => 'fe_groups'
			)
		),
		"storename" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.storename",
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "required,trim",
			)
		),

		"relatedto" => Array (
			"exclude" => 0,
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.relatedto",
			"config" => Array (
				"type" => "select",
				"items" => Array (
				    Array('', 0)
				),
				'foreign_table' => 'tx_locator_locations',
				'foreign_table_where' => 'AND tx_locator_locations.uid != ###THIS_UID###',
				"minitems" => "0",
				"maxitems" => "1",
				"default" => "0",

//				"type" => "input",
//				"size" => "30",
//				"eval" => "trim",
			)
		),

		"storeid" => Array (
			"exclude" => 0,
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.storeid",
			"config" => Array (
				"type" => "input",
				"size" => "30",
				"eval" => "trim",
			)
		),

		'attributes' => array (
			'exclude' => 1,
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.attributes",
			'config'  => array (

				'type'  => 'select',
//				'items' => array (
//					array('', 0),
//					array('LLL:EXT:lang/locallang_general.xml:LGL.hide_at_login', -1),
//					array('LLL:EXT:lang/locallang_general.xml:LGL.any_login', -2),
//					array('LLL:EXT:lang/locallang_general.xml:LGL.usergroups', '--div--')
//				),
				'foreign_table' => 'tx_locator_attributes',
				//'renderMode' => 'checkbox',
				'foreign_table_loadIcon' => 1,
				'iconsInOptionTags' => 1,
				'size' => 10,
				'maxitems' => 30,
				"show_thumbs" => 1,

			)
		),



		"address" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.address",
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "trim",
			)
		),
		"additionaladdress" => Array (
			"exclude" => 0,
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.additionaladdress",
			"config" => Array (
				"type" => "input",
				"size" => "30",
				"eval" => "trim",
			)
		),
		"contactperson" => Array (
			"exclude" => 0,
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.contactperson",
			"config" => Array (
				"type" => "input",
				"size" => "30",
				"eval" => "trim",
			)
		),
		"city" => Array (
			"exclude" => 0,		
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.city",
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "required,trim",
			)
		),
		"state" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.state",
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "trim",
			)
		),
		"zipcode" => Array (
			"exclude" => 0,		
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.zipcode",
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "required,trim",
			)
		),
		"country" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.country",
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "required,trim",
			)
		),
		"products" => Array (
			"exclude" => 0,
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.products",
			"config" => Array (
				"type" => "input",
				"size" => "50",
				"eval" => "trim",
				"max" => "255",
			)
		),
		"phone" => Array (
			"exclude" => 0,		
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.phone",
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "trim",
			)
		),
		"mobile" => Array (
			"exclude" => 0,
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.mobile",
			"config" => Array (
				"type" => "input",
				"size" => "30",
				"eval" => "trim",
			)
		),
		"fax" => Array (
			"exclude" => 0,
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.fax",
			"config" => Array (
				"type" => "input",
				"size" => "30",
				"eval" => "trim",
			)
		),
		"email" => Array (
			"exclude" => 0,
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.email",
			"config" => Array (
				"type" => "input",
				"size" => "30",
				"eval" => "trim",
			)
		),
		"hours" => Array (
			"exclude" => 0,		
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.hours",
			"config" => Array (
				"type" => "text",
				"cols" => "30",	
				"rows" => "5",
			)
		),
		"url" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.url",
			"config" => Array (
				"type" => "input",	
				"size" => "30",
				"max" => "255",
//				"checkbox" => "",
				"eval" => "trim",
				"wizards" => Array(
					"_PADDING" => 2,
					"link" => Array(
						"type" => "popup",
						"title" => "Link",
						"icon" => "link_popup.gif",
						"script" => "browse_links.php?mode=wizard",
						"JSopenParams" => "height=300,width=500,status=0,menubar=0,scrollbars=1"
					)
				)




			)
		),
		"notes" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.notes",
			"config" => Array (
/*				"type" => "text",
				"cols" => "30",	
				"rows" => "5",
*/
				'type' => 'text',
				'cols' => '48',
				'rows' => '5',
				'softref' => 'typolink_tag,images,email[subst],url',
				'wizards' => Array(
					'_PADDING' => 4,
					'RTE' => Array(
						'notNewRecords' => 1,
						'RTEonly' => 1,
						'type' => 'script',
						'title' => 'LLL:EXT:locator/locallang_db.xml:tx_locator_locations.notes',
						'icon' => 'wizard_rte2.gif',
						'script' => 'wizard_rte.php',
					),
				)

			),
            'defaultExtras' => 'richtext[*]:rte_transform[mode=ts_css]',
//            'defaultExtras' => 'richtext[*]'
// 			  see showItem !

		),
		"media" => Array (
			"exclude" => 0,
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.media",
			"config" => Array (
				"type" => "group",
				"internal_type" => "file",
				"allowed" => "gif,png,jpeg,jpg,flv,mp4,mov",
				"max_size" => 1000000,
				"uploadfolder" => "uploads/tx_locator/media",
				"show_thumbs" => 0,
				"size" => 1,
				"minitems" => 0,
				"maxitems" => 1,
			)
		),
		"imageurl" => Array (
			"exclude" => 0,		
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.imageurl",
			"config" => Array (
				"type" => "group",
				"internal_type" => "file",
				"allowed" => "gif,png,jpeg,jpg",	
				"max_size" => 500,	
				"uploadfolder" => "uploads/tx_locator",
				"show_thumbs" => 1,	
				"size" => 1,	
				"minitems" => 0,
				"maxitems" => 1,
			)
		),
		"icon" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.icon",
			"config" => Array (
				"type" => "select",
				"items" => Array (),
				"itemsProcFunc" => "tx_locator_tx_locator_locations_icon->main",
				"size" => 1,	
				"maxitems" => 1,
			)
		),
		"use_coordinate" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.use_coordinate",
			"config" => Array (
				"type" => "check",
			)
		),
/*		"categories" => Array (
			"exclude" => 0,		
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.categories",
			"config" => Array (
				"type" => "select",
				"items" => Array (),
				"itemsProcFunc" => "tx_locator_tx_locator_locations_categories->main",
				"size" => 10,
				"maxitems" => 10,
			)
		),
*/
		"categoryuid" => Array (
			"exclude" => 0,
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.categories",
/*			"config" => Array (
				"type" => "select",
				'foreign_table' => 'tx_locator_categories',
				'foreign_table_where' => 'AND tx_locator_categories.pid = ###CURRENT_PID###',
				"maxitems" => "10",
				"size" => "10",
			)
*/


/*
     		'config' => Array (
				'type' => 'select',
				'foreign_table' => 'tx_locator_categories',
				"maxitems" => "10",

				'renderMode' => 'tree',
				'treeConfig' => array(
					'parentField' => 'parentuid',
					'appearance' => array(
						'expandAll' => true,
						'showHeader' => true,
					),
				),
			)
*/

     		'config' => Array (
				'type' => 'select',
				'form_type' => 'user',
				'userFunc' => 'tx_locator_treeview->displayCategoryTree',
				'treeView' => 1,
				'treeName' => 'locatorteeviewexample',
        		'treeMaxDepth' => 999,
				'size' => 10,
				'selectedListStyle' => 'width:150px',
				'minitems' => 1,
				'maxitems' => 10,
				'foreign_table' => 'tx_locator_categories',
//				'foreign_table_where' => 'AND tx_locator_categories.pid=###CURRENT_PID### ORDER BY tx_locator_categories.name',
				'foreign_table_where' => 'AND tx_locator_categories.pid>0 ORDER BY tx_locator_categories.name',
//'pid' => '###PAGE_TSCONFIG_IDLIST###',
				'wizards' => Array(
					'_PADDING' => 2,
					'_VERTICAL' => 1,
					'add' => Array(
						'type' => 'script',
						'title' => 'LLL:EXT:locator/locallang_db.xml:tx_locator_categories.createNewParentCategory',
						'icon' => 'add.gif',
						'params' => Array(
							'table'=>'tx_locator_categories',
							'pid' => '###CURRENT_PID###',
							'setValue' => 'set'
						),
						'script' => 'wizard_add.php',
					),
					'list' => Array(
						'type' => 'script',
						'title' => 'LLL:EXT:locator/locallang_db.xml:tx_locator_categories.listCategories',
						'icon' => 'list.gif',
						'params' => Array(
							'table'=>'tx_locator_categories',
							'pid' => '###CURRENT_PID###',
						),
						'script' => 'wizard_list.php',
					),
				),
      		)

		),


		"lat" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.lat",
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "trim",
			)
		),
		"lon" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.lon",
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "trim",
			)
		),

		"geocode" => Array (
			"exclude" => 1,
			"label" => "tx_locator[geocode]",
			"config" => Array (
				"type" => "check",
				"default" => "1",
			)
		),
		// added for meta_feedit
		"sorting" => Array (
			"exclude" => 0,
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_locations.lon",
			"config" => Array (
				"type" => "input",
				"size" => "10",
				"eval" => "int",
			)
		),

		 'content' => Array (
			'exclude' => 1,
			'label' => 'LLL:EXT:locator/locallang_db.xml:tx_locator_locations.content',
			'config' => Array (
				'type' => 'group',
				'internal_type' => 'db',
				'allowed' => 'tt_content',
				'size' => 5,
				'minitems' => 0,
				'maxitems' => 30,
				'show_thumbs' => 1,
			),
		),



	),
	"types" => array (
//		"0" => array("showitem" => "hidden;;1;;1-1-1, storename, relatedto, storeid, address, additionaladdress, contactperson, city, state, zipcode, country, attributes, products, phone, mobile, fax, email, hours, url, notes;;2;richtext:rte_transform[flag=rte_enabled|mode=ts];4-4-4, media, imageurl, icon, content, use_coordinate, categoryuid, lat, lon, geocode")
		"0" => array("showitem" => "hidden;;1;;1-1-1, storename, relatedto, storeid, address, additionaladdress, contactperson, city, state, zipcode, country, attributes, products, phone, mobile, fax, email, hours, url, notes, media, imageurl, icon, content, use_coordinate, categoryuid, lat, lon, geocode")
	),
	"palettes" => array (
		"1" => array("showitem" => "endtime, fe_group")
	)
);



$TCA["tx_locator_categories"] = array (
	"ctrl" => $TCA["tx_locator_categories"]["ctrl"],
	"interface" => array (
		"showRecordFieldList" => "hidden, sys_language_uid,l10n_parent,l10n_diffsource,fe_group,name,description, parentuid"
	),
	"feInterface" => $TCA["tx_locator_categories"]["feInterface"],
	"columns" => array (
		'sys_language_uid' => array (
			'exclude' => 1,
			'label'  => 'LLL:EXT:lang/locallang_general.xml:LGL.language',
			'config' => array (
				'type'                => 'select',
				'foreign_table'       => 'sys_language',
				'foreign_table_where' => 'ORDER BY sys_language.title',
				'items' => array(
					array('LLL:EXT:lang/locallang_general.xml:LGL.allLanguages', -1),
					array('LLL:EXT:lang/locallang_general.xml:LGL.default_value', 0)
				)
			)
		),
		'l10n_parent' => array (
			'displayCond' => 'FIELD:sys_language_uid:>:0',
			'exclude'     => 1,
			'label'       => 'LLL:EXT:lang/locallang_general.xml:LGL.l18n_parent',
			'config'      => array (
				'type'  => 'select',
				'items' => array (
					array('', 0),
				),
				'foreign_table'       => 'tx_locator_categories',
				'foreign_table_where' => 'AND tx_locator_categories.pid=###CURRENT_PID### AND tx_locator_categories.sys_language_uid IN (-1,0)',
			)
		),
		'l10n_diffsource' => array (
			'config' => array (
				'type' => 'passthrough'
			)
		),

		'hidden' => array (
			'exclude' => 1,
			'label'   => 'LLL:EXT:lang/locallang_general.xml:LGL.hidden',
			'config'  => array (
				'type'    => 'check',
				'default' => '0'
			)
		),


		'fe_group' => array (		
			'exclude' => 1,
			'label'   => 'LLL:EXT:lang/locallang_general.xml:LGL.fe_group',
			'config'  => array (
				'type'  => 'select',
				'items' => array (
					array('', 0),
					array('LLL:EXT:lang/locallang_general.xml:LGL.hide_at_login', -1),
					array('LLL:EXT:lang/locallang_general.xml:LGL.any_login', -2),
					array('LLL:EXT:lang/locallang_general.xml:LGL.usergroups', '--div--')
				),
				'foreign_table' => 'fe_groups'
			)
		),
		"parentuid" => Array (
			"exclude" => 0,
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_categories.parentuid",
/*			"config" => Array (
				"type" => "select",
				'foreign_table' => 'tx_locator_categories',
				'foreign_table_where' => 'AND tx_locator_categories.pid = ###CURRENT_PID###',
				"maxitems" => "1",
				"size" => "10",
			)
*/
     		'config' => Array (
				'type' => 'select',
				'form_type' => 'user',
				'userFunc' => 'tx_locator_treeview->displayCategoryTree',
				'treeView' => 1,
				'treeName' => 'locatorteeviewexample',
        		'treeMaxDepth' => 999,
				'size' => 10,
				'selectedListStyle' => 'width:150px',
				'minitems' => 0,
				'maxitems' => 2,  // this is set to 1 in user function
				'foreign_table' => 'tx_locator_categories',
				'foreign_table_where' => 'AND tx_locator_categories.pid=###CURRENT_PID### ORDER BY tx_locator_categories.name',
				'foreign_table_where' => ' ORDER BY tx_locator_categories.name',
				'wizards' => Array(
					'_PADDING' => 2,
					'_VERTICAL' => 1,
					'add' => Array(
						'type' => 'script',
						'title' => 'LLL:EXT:locator/locallang_db.xml:tx_locator_categories.createNewParentCategory',
						'icon' => 'add.gif',
						'params' => Array(
							'table'=>'tx_locator_categories',
							'pid' => '###CURRENT_PID###',
							'setValue' => 'set'
						),
						'script' => 'wizard_add.php',
					),
					'list' => Array(
						'type' => 'script',
						'title' => 'LLL:EXT:locator/locallang_db.xml:tx_locator_categories.listCategories',
						'icon' => 'list.gif',
						'params' => Array(
							'table'=>'tx_locator_categories',
							'pid' => '###CURRENT_PID###',
						),
						'script' => 'wizard_list.php',
					),
				),
      		)
		),

		
		
		
		
		"name" => Array (		
			"exclude" => 0,		
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_categories.name",
			"config" => Array (
				"type" => "input",	
				"size" => "30",	
				"eval" => "required,trim",
			)
		),
		"description" => Array (		
			"exclude" => 1,		
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_categories.description",
			"config" => Array (
				"type" => "text",
				"cols" => "30",	
				"rows" => "5",
			)
		),
	),
	"types" => array (
		"0" => array("showitem" => "hidden, sys_language_uid;;;;1-1-1, l10n_parent, l10n_diffsource, name, description, parentuid")
	),
	"palettes" => array (
		"1" => array("showitem" => "")
	)
);

$TCA["tx_locator_attributes"] = array (
	"ctrl" => $TCA["tx_locator_attributes"]["ctrl"],
	"interface" => array (
		"showRecordFieldList" => "sys_language_uid,l10n_parent,l10n_diffsource,name,icon"
	),
	"feInterface" => $TCA["tx_locator_attributes"]["feInterface"],
	"columns" => array (
		'sys_language_uid' => array (
			'exclude' => 1,
			'label'  => 'LLL:EXT:lang/locallang_general.xml:LGL.language',
			'config' => array (
				'type'                => 'select',
				'foreign_table'       => 'sys_language',
				'foreign_table_where' => 'ORDER BY sys_language.title',
				'items' => array(
					array('LLL:EXT:lang/locallang_general.xml:LGL.allLanguages', -1),
					array('LLL:EXT:lang/locallang_general.xml:LGL.default_value', 0)
				)
			)
		),
		'l10n_parent' => array (
			'displayCond' => 'FIELD:sys_language_uid:>:0',
			'exclude'     => 1,
			'label'       => 'LLL:EXT:lang/locallang_general.xml:LGL.l18n_parent',
			'config'      => array (
				'type'  => 'select',
				'items' => array (
					array('', 0),
				),
				'foreign_table'       => 'tx_locator_categories',
				'foreign_table_where' => 'AND tx_locator_categories.pid=###CURRENT_PID### AND tx_locator_categories.sys_language_uid IN (-1,0)',
			)
		),
		'l10n_diffsource' => array (
			'config' => array (
				'type' => 'passthrough'
			)
		),


/*
		'fe_group' => array (
			'exclude' => 1,
			'label'   => 'LLL:EXT:lang/locallang_general.xml:LGL.fe_group',
			'config'  => array (
				'type'  => 'select',
				'items' => array (
					array('', 0),
					array('LLL:EXT:lang/locallang_general.xml:LGL.hide_at_login', -1),
					array('LLL:EXT:lang/locallang_general.xml:LGL.any_login', -2),
					array('LLL:EXT:lang/locallang_general.xml:LGL.usergroups', '--div--')
				),
				'foreign_table' => 'fe_groups'
			)
		),
*/

		"name" => Array (
			"exclude" => 0,
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_attributes.name",
			"config" => Array (
				"type" => "input",
				"size" => "30",
				"eval" => "required,trim",
			)
		),

		"icon" => Array (
			"exclude" => 0,
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_attributes.icon",
			"config" => Array (
				"type" => "group",
				"internal_type" => "file",
				"allowed" => "gif,png,jpeg,jpg",
				"max_size" => 500,
				"uploadfolder" => "uploads/tx_locator",
				"show_thumbs" => 1,
				"size" => 1,
				"minitems" => 0,
				"maxitems" => 1,
			)
		),


	),
	"types" => array (
		"0" => array("showitem" => "sys_language_uid;;;;1-1-1, l10n_parent, l10n_diffsource, name, icon")
	),
	"palettes" => array (
		"1" => array("showitem" => "")
	)
);




$TCA["tx_locator_zipcodeareas"] = array (
	"ctrl" => $TCA["tx_locator_zipcodeareas"]["ctrl"],
	"interface" => array (
		"showRecordFieldList" => "zipcode, area, lat, lon"
	),
	"feInterface" => $TCA["tx_locator_categories"]["feInterface"],
	"columns" => array (
/*		'fe_group' => array (
			'exclude' => 1,
			'label'   => 'LLL:EXT:lang/locallang_general.xml:LGL.fe_group',
			'config'  => array (
				'type'  => 'select',
				'items' => array (
					array('', 0),
					array('LLL:EXT:lang/locallang_general.xml:LGL.hide_at_login', -1),
					array('LLL:EXT:lang/locallang_general.xml:LGL.any_login', -2),
					array('LLL:EXT:lang/locallang_general.xml:LGL.usergroups', '--div--')
				),
				'foreign_table' => 'fe_groups'
			)
		),
*/
		"zipcode" => Array (
			"exclude" => 0,
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_zipcodeareas.zipcode",
			"config" => Array (
				"type" => "input",
				"size" => "5",
				"eval" => "int,required,trim",
			)
		),





		"area" => Array (
			"exclude" => 0,
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_zipcodeareas.area",
			"config" => Array (
				"type" => "input",
				"size" => "10",
				"eval" => "int,required,trim",
			)
		),
		"lat" => Array (
			"exclude" => 1,
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_zipcodeareas.lat",
			"config" => Array (
				"type" => "input",
				"size" => "30",
				"eval" => "float,required,trim",
			)
		),
		"lon" => Array (
			"exclude" => 1,
			"label" => "LLL:EXT:locator/locallang_db.xml:tx_locator_zipcodeareas.lon",
			"config" => Array (
				"type" => "input",
				"size" => "30",
				"eval" => "float,required,trim",
			)
		),

		
	),
	
	"types" => array (
		"0" => array("showitem" => "zipcode;;;;1-1-1, area, lat, lon")
	),
	"palettes" => array (
		"1" => array("showitem" => "")
	)
);


//$TCA['tx_locator_locations']['columns']['notes']['defaultExtras'] = 'richtext[*]';


?>
